/**
 * Created with PyCharm.
 * User: mag
 * Date: 16.03.14
 * Time: 18:43
 * To change this template use File | Settings | File Templates.
 */

var dv = dv ? dv : {};
(function(dv){
    function Con(p0, p1) {
        var dx = p1[0]- p0[0],
                dy = p1[1] - p0[1],
                L = Math.sqrt(dx*dx + dy*dy),
                dxl = dx/ L,
                dyl = dy/L
                ;
        return {
            after: function(p, dist){
                return [p[0] + dxl*dist, p[1] + dyl*dist];
            },
            before: function(p, dist){
                return [p[0] - dxl*dist, p[1] - dyl*dist];
            },
            left: function(p, dist){
                return [p[0] + dyl*dist, p[1] - dxl*dist];
            },
            right: function(p, dist){
                return [p[0] - dyl*dist, p[1] + dxl*dist];
            },
            none: function(p, dist){
                return [p[0], p[1]];
            }
        };

    }

    function c(p){
        return p[0] + "," + p[1];
    }

    function Arrow() {
        var p0, p1, pm,
                radius = 0,
                dr = 0,
                sideshift = 10,
                lengthshift = 10,
                aw2 = 15,
                con
        ;
        function arr(p0, p1, sideshift, lengthshift, from, to){
            function sgn(x) {
                return (x > 0) - (x < 0);
            }
            function rightarrpoints(p, val){
                var d = sgn(val) * sideshift;
                return [con.before(con.right(p, sideshift), d), p, con.before(con.left(p, sideshift), d)];
            }
            function leftarrpoints(p, val){
                var d = sgn(val) * sideshift;
                return [con.before(con.left(p, sideshift), d), p, con.before(con.right(p, sideshift), d)];
            }

            var points = leftarrpoints(p0, from)
                    .concat(rightarrpoints(p1, to));
            return "M" + c(points.shift()) + "L"
                    + points.map(c).join("L")
                    + "Z"
                    ;
        }
        var obj = {
            radius: function(_){
                if (!arguments.length){
                    return radius;
                } else {
                    radius = _;
                    dr = Math.sqrt(1/2) * radius;
                    return obj;
                }
            },
            p01: function(_){
                if (!arguments.length){
                    return [p0, p1];
                } else {
                    p0 = _[0];
                    p1 = _[1];
                    pm = [(p0[0] + p1[0])/2, (p0[1] + p1[1])/2];
                    con = Con(p0, p1);
                    return obj;
                }
            },
            line: function(){
                return "M"+c(con.after(p0, radius))+"L"+c(pm)+ " "+c(con.before(p1, radius));
            },
            /* dir0 and dir1 are directions of arrow at p0 nd p1 */

            /* Path of full Arrow */
            d: function(dir0, dir1){
                return arr(con.after(p0, dir0 > 0 ? radius + lengthshift : radius),
                        con.before(p1, dir1 < 0 ? radius + lengthshift : radius),
                                sideshift, lengthshift, dir0, dir1);
            },
            /* Path from p0 to mid between p0 and p1*/
            d0: function(dir0, dir1){
                return arr(con.after(p0, dir0 > 0 ? radius + lengthshift : radius),
                        pm, sideshift, lengthshift, dir0, 0);
            },
            /* Path from mid between p0 and p1 to p1*/
            d1: function(dir0, dir1){
                return arr(pm,
                        con.before(p1, dir1 < 0 ? radius + lengthshift : radius),
                                sideshift, lengthshift, 0, dir1);
            },
            /* d0 + d1*/
            d2: function(dir0, dir1){
                return arr(con.after(p0, dir0 > 0 ? radius + lengthshift : radius), pm, sideshift, lengthshift, dir0, 0)
                        + arr(pm, con.before(p1, dir1 < 0 ? radius + lengthshift : radius), sideshift, lengthshift, 0, dir1);

            },
            sideshift: function(_){
                if (!arguments.length){
                    return sideshift;
                } else {
                    sideshift = _;
                    return obj;
                }
            },
            lengthshift: function(_){
                if (!arguments.length){
                    return lengthshift;
                } else {
                    lengthshift = _;
                    return obj;
                }
            }
        };
        return obj;
    }
    dv.Arrow = Arrow;

})(dv);