/**
 * Created with PyCharm.
 * User: a404799
 * Date: 30.09.13
 * Time: 09:26
 * To change this template use File | Settings | File Templates.
 */
var dm = dm || {};

(function(){
    // A factory function for creating attributes
    "use strict";
    function Attributefactory(){
        // objects have attributes
        function Attribute(name){
            var key = name,
                label = name,
                description,
                value_description = {},
                fallbackcompare = function(a,b) {
                    return a > b? 1: a < b ? -1 : 0;
                },
                naturalcomparefunc = fallbackcompare,
                valuedescriptions,
                simplevaluegetter = function(obj){
                    return obj[key];
                },
                valuegetter = simplevaluegetter,
                attr = {},
                valueformatter = function(_){
                    return _;
                };

            // gets or defines the method to get the value of an attribute of an object
            attr.key = function(_){
                if (!arguments.length) return key || valuegetter;
                if (typeof(_) === 'string'){
                    key = _;
                    valuegetter = simplevaluegetter;
                } else {
                    key = undefined;
                    valuegetter = _;
                }
                return attr;
            };

            // returns the name of an attribute
            attr.name = function(){
                return name;
            };

            // gets or sets the description of the attribute
            attr.description = function(_){
                if (!arguments.length) return description;
                description = _;
                return attr;
            };

            // renders the content of a th (table head)
            attr.th = function(th){
                th.text(name);
            };

            // returns the attribute value for an object
            attr.objvalue = function(obj){
                return valuegetter(obj)
            };

            attr.compare = {
                ascending: function(a, b){
                    naturalcomparefunc(valuegetter(a), valuegetter(b))
                },
                descending: function(a, b){
                    naturalcomparefunc(valuegetter(b), valuegetter(a))
                }
            };
            /*
            Sets or gets a sort function used to sort attribute values in their natural order.
            If no argument is given the sorting function is returned.
            If argument is a function it is used as natural sort function.
            If argument is an array of values, their order is assumed to be the natural order and a
            corresponding sorting function is created internally.
             */
            attr.naturalcomparefunc = function(_){
                if (!arguments.length){
                    return naturalcomparefunc;
                }
                if (typeof(_) === "function") {
                    naturalcomparefunc = _;
                } else {
                    var value_order = {};
                    _.forEach(function(value, idx){
                        value_order[value] = idx;
                    });
                    naturalcomparefunc = function(a,b){
                        var ao = value_order[a],
                            bo = value_order[b],
                            res = ao - bo;
                        if (isNaN(res)) {
                            if (isNaN(ao) && isNaN(bo)){
                                return fallbackcompare(a, b);
                            } else if (isNaN(ao)) {
                                return 1;
                            } else {
                                return -1;
                            }
                        } else {
                            return res;
                        }
                    };
                }
                return attr;
            };

            attr.valuedescriptions = function(_){
                if (!arguments.length) return valuedescriptions;
                valuedescriptions = _;
                var sortedvalues = [];
                _.forEach(function(item){
                    value_description[item[0]] = item[1];
                    sortedvalues.push(item[0]);
                });
                attr.naturalcomparefunc(sortedvalues);
                return attr;
            };

            attr.valuedescription = function(value){
                return value_description[value];
            };

            // gets or set a function used to format a value
            attr.valueformatter = function(_){
                if (!arguments.length) return valueformatter;
                valueformatter = _;
                return attr;
            };

            Attribute[name] = attr;
            return attr;
        }
        return Attribute;
    }
    function get_compare(attributes){
        var idx,
            comparefunctions = attributes.map(function(attr){return attr.naturalcomparefunc();});
        function compare(a, b){
            var res,
                objvalue;
            for(idx = 0; idx < attributes.length; idx++){
                objvalue = attributes[idx].objvalue;
                res = comparefunctions[idx](objvalue(a), objvalue(b));
                if (res) {
                    return res;
                }
            }
            return 0;
        }
        return compare;
    }
    dm.Attributefactory = Attributefactory;
    dm.get_compare = get_compare;
})();





function Control(attr){
    function F(){}
    F.prototype = attr;
    var conf = new F();

    conf.settings = {
        sortable: false,
        isactivesort: false,
        sortorder: 'ascending',
        filterable: false,
        dispatcher: undefined
    };

    conf.isactivesort = function(_){
        if (!arguments.length) return conf.settings.isactivesort;
        conf.settings.isactivesort = _;
        return conf;
    };

    conf.sortable = function(_){
        if (!arguments.length) return conf.settings.sortable;
        conf.settings.sortable = _;
        return conf;
    };

    conf.dispatcher = function(_){
        if (!arguments.length) return conf.settings.dispatcher;
        conf.settings.dispatcher = _;
        return conf;
    };

    conf.sortaction = function(){
        console.log(conf.name(), conf.settings)
        if (conf.settings.isactivesort === true){
            conf.settings.sortorder = 'ascending' ? conf.settings.sortorder = 'descending' : conf.settings.sortorder = 'ascending';
        } else {
            conf.settings.dispatcher.sortcontrol(false);
        }
        conf.settings.dispatcher.on("sortcontrol", conf.isactivesort);
        //console.log(conf.settings, conf.settings.isactivesort);
        conf.isactivesort(true);
        conf.settings.dispatcher.sort(conf.compare[conf.settings.sortorder]);
    };


    conf.filterable = function(_){
        if (!arguments.length) return filterable;
        conf.settings.filterable = _;
        return conf;
    };


    // gets and sets settings of the gui
/*    conf.settings = function(_){
        if (!arguments.length) return settings;
        settings = _;
        return conf;
    };
*/
    // render as table head
    conf.th = function(th){
        th
            .style("position", "relative")
            .append('span')
            .attr("class", "lablel")
            .text(conf.name())
            .attr("title", attr.description());
        if (conf.settings.sortable === true){
            th
                .append('span')
                .style("float", "right")
                .attr("class", "updown")
                .call(function(sortgui){
                    if (conf.settings.sortorder === 'ascending'){
                        sortgui.html("&#x25BC;");
                    } else {
                        sortgui.html("&#x25B2;");
                    }
                    sortgui.style("color", conf.settings.isactivesort ? 'black': 'lightgray');
                })
                .on("click", conf.sortaction);
        }
    };
    return conf;
}
/*

            cat.gui = function(){
                var onchange = console.log
                    ;


                function gui(selection, idx){
                    var controlstable = selection
                        .append("td")
                        .append("table");
                    var controlstabletr = controlstable
                        .append("tr");
                    controlstabletr
                        .append("td")
                        .datum({idx: idx})
                        .style("position", "relative")
                        .attr("rowspan", 2)
                        .attr("class", "lablel")
                        .text(key)
                        .attr("title", description)
                        .on("click", filter);
                    controlstabletr.append("td")
                        .attr("class", "updown")
                        .html("&#x25B2;")
                        .datum({idx: idx, action: 'sortascending'})
                        .attr("title", "sort ascending")
                        .on("click", sortaction);
                    controlstable.append("tr")
                        .append("td")
                        .html("&#x25BC;")
                        .datum({idx: idx, action: "sortdescending"})
                        .attr("class", "updown")
                        .attr("title", "sort descending")
                        .on("click", sortaction);
                }

                gui.onchange = function(_){
                    if (!arguments.length) return onchange;
                    onchange = _;
                    return gui;
                };

                function filter(){
                    var control = d3.select(this);
                    var datum = control.datum();
                    var alloptions;
                    function remove(){
                        control.selectAll("div").remove();
                        datum.filtervisible = false;
                    }
                    if(datum.filtervisible){
                        remove();
                        return;
                    }
                    datum.filtervisible = true;
                    var div = control.append("div")
                        .attr("class", "gui")
                        .on("click", function(){
                            d3.event.stopPropagation();
                        })
                        .style({position: "absolute", top: "1em", left:"0em", width: "100px"});
                    div.append("h3")
                        .text("Filter:");

                    function addoption(selection, option, func){
                        var itr = selection.append("tr");
                        itr.append("td")
                            .append("input")
                            .attr("type", "checkbox")
                            .attr("value", option.value)
                            .attr("checked", option.checked)
                            .on("change", func);
                        itr.append("td")
                            .text(option.value);
                    }
                    function toggleall(){
                        var checked = this.checked;
                        alloptions.each(function(){this.checked=checked;});
                    }
                    var selectbox = div.append("table");

                    valuedescriptions.map(function(vd){return {value:vd[0], checked:true};}).forEach(function(filter){
                        if (filter.value === 'Select all') {
                            selectbox.call(addoption, filter, toggleall);
                        } else {
                            selectbox.call(addoption, filter);
                        }

                    });

                    alloptions = selectbox.selectAll("input");
                    div.append("input")
                        .attr("type", "button")
                        .attr("value", "cancel")
                        .on("click", remove);
                    div.append("input")
                        .attr("type", "button")
                        .attr("value", "ok")
                        .on("click", okclick);

                    function okclick(){
                        var newfilters = [];
                        alloptions.each(function(){
                            newfilters.push({value: this.value, checked: this.checked});
                        });
                        filteraction(newfilters);
                        remove();
                    }
                }

                function sortaction(){
                    onchange(this.__data__);
                }

                function filteraction(newfilters){
                    onchange({filter: newfilters});
                }


                return gui;
            };


 */