/**
 * Created with PyCharm.
 * User: a404799
 * User: a404799
 * Date: 15.03.13
 * Time: 11:40
 * To change this template use File | Settings | File Templates.
 */

var dv = dv || {};

(function () {
    "use strict";

    var counter = 0;


    function BandwithChart(ele) {
        var chartid = 'BandwithChart' + counter++,
            width = 500,
            height = 400,
            leftMargin = 100,
            rightMargin = 50,
            topMargin = 50,
            bottomMargin = 50,
            data,
            minorticksize = 4,
            majorticksize = 10,
            dpi = 96,
            xtitle,
            ytitle,
            xmin,
            xmax,
            ymin,
            ymax,
            xtype,
            ytype,
            xunits,
            yunits,
            xScale,
            yScale,
            xAxis,
            leftyAxis,
            legendtotalx,
            legendtotaly,
			axistitlefontsizept = 10,
			tickfontsizept = 10,
            zeroforlogscale = 1E-50
            ;
        var
            svg = d3.select(ele).node().html("")
                .append("svg:svg")
                .attr("id", idstr()),
            svgdefs = svg.append("svg:defs"),
            pat = svgdefs
                .append("pattern")
                .attr("id", "diagonalHatch")
                .attr("patternUnits", "userSpaceOnUse")
                .attr("width", 4)
                .attr("height", 4)
                .attr("patternTransform", "rotate(45 2 2)")
                .append("path")
                .attr("d", "M -1,2 l 6,0")
                .style("stroke", "#000000")
                .style("stroke-width", "1"),
            titletext = svg.append("text")
                .attr("id", idstr("title")),
            legendtotalg = svg.append("svg:g")
                .attr('id', idstr("legendtotal"))
                .attr('class', "legendtotal"),
            plotarea = svg.append("svg:g")
                .attr("id", idstr("plotarea"))
                .attr("clip-path", 'url(#'+idstr("clip")+')'),
            div = d3.select(ele).node().append("div")
                .attr("class", "tooltip")
                .style("opacity", 0),
            properties = d3.select(ele).node().append("div")
                .attr("class", "properties widget shadow")
                .style({position: "absolute", top: "0.5em", left: "10em", visibility: "hidden"}),
            cliprect = svg.append("svg:clipPath").attr("id", idstr("clip")).append("svg:rect"),
            xaxistopg,
            xaxisbottomg,
            yaxisleftg,
            yaxisrightg,
            dataline = d3.svg.line(),
            zeroforlogscale = 1E-50,
            dm,
            redraw,
            pointindicator,
            obj = {}

        ;
        //console.log('init', svg);


        var detail_color = (function () {
            var n = 0,
                detail_color = {},
                colors = d3.scale.category20().range()
                ;
            function f(detail) {
                if (detail_color[detail] === undefined) {
                    detail_color[detail] = colors[n % 20];
                    n++;
                }
                return detail_color[detail];
            }
            return f;
        })();

        function idstr(){
            var i, parts = [chartid];
            for(i = 0; i < arguments.length; ++i){
                parts.push(arguments[i]);
            }
            return parts.join("--");
        }

        function refidstr(){
            return "#" + idstr.apply(undefined, arguments);
        }

        function Pointindicator(){
            var labeltext,
                labelrect,
                grouppointindicator = svg.selectAll("g.pointindicator")
                    .data([null]);
            var dy = 44;
            var bandwidth = xScale.rangeBand();
            function textlines(sel, x, y, lines){
                var tspan = sel.selectAll("tspan")
                    .data(lines);
                tspan
                    .enter()
                    .append("tspan")
                    .attr("dy", dy);
                tspan
                    .attr("x", x)
                    .text(function(d){return d;});
                tspan.exit().remove();
            }
            grouppointindicator
                .enter()
                .call(function(sel){
                    var g = sel
                        .append("g")
                        .attr("class", "pointindicator");
                    labelrect = g.append("rect")
                        .style({"fill": 'white', stroke: 'gray', "stroke-width": "2px", "stroke-dasharray": "2, 2", opacity: 0.8})
                    ;
                    labeltext = g.append("text")
                    ;
                });
            return {
                show: function(x, ymax, label){
                    var x = xScale(x)  + bandwidth / 2,
                        y = yScale(ymax.mag)
                        ;
                    labeltext
                        .attr("y", y - 2.5 * dy)
                        .call(textlines, x, y, [label, ymax.mag.toExponential(2) + " " + ymax.units]);
                    grouppointindicator.style("display", "block");
                    dv.copybb(labeltext, labelrect);

                },
                hide: function(){
                    grouppointindicator.style("display", "none");
                }
            };
        }
/*
*/

        function classchange(obj, factor){
            var classes = obj.className.baseVal.replace(/^\s+|\s+$/g, '').split(/\s+/),
                firstclass = classes[0],
                detailclass,
                totalclasses,
                datum;

            function changestyle(obj, attr, increment){
                //console.log(obj);
                try {
                    var val = parseInt(obj.style(attr), 10);
                    obj.style(attr, (val + factor*increment));
                } catch(e) {
                    //console.log(e);
                }
            }

            function textboldnormal(obj){
                obj.style("font-weight", factor >= 0 ? "bold" : "normal");
            }

            function hideshow(obj){
                obj.style("visibility",{"1":"visible", "-1":"hidden"}[factor]);
            }
            if (firstclass === 'total'){
                totalclasses = obj.className.baseVal.replace(/ +/g, '.');
                svg.selectAll("rect." + totalclasses).call(changestyle, "stroke-width", 4);
                svg.selectAll("path." + totalclasses).call(changestyle, "stroke-width", 4);
                svg.selectAll("text." + totalclasses).call(textboldnormal);
            } else if (firstclass.substr(0, 4) === 'item'){
                detailclass = classes[classes.length-1];
                datum = d3.select(obj).datum();
                if (factor > 0){
                    pointindicator.show(datum.idx, datum.ymax, datum.label);
                }
                svg.selectAll("line." + detailclass).call(changestyle, "stroke-width", 3);
                svg.selectAll("path." + detailclass).call(changestyle, "stroke-width", 3);
                svg.selectAll("text." + detailclass).call(textboldnormal);

            } else {
                detailclass = classes[classes.length-1];
                svg.selectAll("line." + detailclass).call(changestyle, "stroke-width", 3);
                svg.selectAll("text.legendtextdetail." + detailclass).call(textboldnormal);
            }
        }

        function highlight(){
            classchange(this, +4);
        }

        function normal(){
            classchange(this, -4);
            pointindicator.hide();
        }

        obj.animatetotal = function(){
            svg.selectAll(".total")
                .on("click", toggledetails);
            svg.selectAll("path.total,text.total,rect.total")
                .on("mouseover", highlight)
                .on("mouseout", normal);
        };

        obj.animatedetails = function(){
            svg.selectAll("line.linedetail,path.legendlinedetail,text.legendtextdetail")
                .on("mouseover", highlight)
                .on("mouseout", normal);
        };

        obj.animate = function(){
            pointindicator = Pointindicator();
            obj.animatetotal();
            obj.animatedetails();
        };


        function get_detaillinestyle(name){
            return {"stroke-width": 4, stroke:detail_color(name), fill:"none"};
        }

        function editaxis(){
            properties.html('<fieldset><legend>Axes</legend>\
<fieldset>\
<legend>Y</legend>\
<table>\
<tr><td>Min:</td><td><input class="ymin" size="10" type="text"></td></tr>\
<tr><td>Max:</td><td><input class="ymax" size="10" type="text"></td></tr>\
<tr><td>Type:</td><td><select class="yaxistype">\
<option value="log">log</option>\
<option value="lin">lin</option>\
</select>\
</td></tr>\
</table>\
</fieldset>\
<input class="axisapply" type="button" value="Apply">\
<input class="axisclose" type="button" value="Close">\
</fieldset>\
</fieldset>');
            properties.style("visibility", "visible");
            properties.select(".ymin").attr("value", ymin);
            properties.select(".ymax").attr("value", ymax);
            properties.select(".yaxistype option[value="+ytype+"]").attr("selected", true);

            properties.select(".axisapply").on("click", function(){
                ymin = parseFloat(properties.select(".ymin").node().value);
                ymax = parseFloat(properties.select(".ymax").node().value);
                ytype = properties.select(".yaxistype").node().value;
                redraw(obj);
            });
            properties.select(".axisclose").on("click", function(){
                properties.style("visibility", "hidden");
            });
        }

        obj.onredraw = function(_){
            redraw = _;
        };

        obj.plotaxis = function(){
            xAxis = d3.svg.axis()
                .scale(xScale)
                .orient('bottom')
                .tickFormat(function(d, i){
                    return data[i].subset.label;
                })
            ;

            var topxAxis = d3.svg.axis()
                .scale(xScale)
                .orient('bottom')
                .tickFormat(function(){})
                ;


            leftyAxis = d3.svg.axis()
                .scale(yScale)
                .ticks(4)
                .tickPadding(10)
                .tickSize(-majorticksize, -minorticksize)
                .orient('left');

            var rightyAxis = d3.svg.axis()
                .scale(yScale)
                .ticks(4)
                .tickSize(majorticksize, minorticksize)
                .orient('left')
                .tickFormat(function(){})
                ;
            //var fmt = rightyAxis.tickFormat();
            //.tickFormat(function(x){return fmt(x).toString().split('e').join('--')});

            svg
                .attr("width", dv.pt(width, dpi))
                .attr("height", dv.pt(height, dpi))
                .attr("viewBox", "0 0 " + width + " " + height);

            cliprect
                .attr("x", leftMargin)
                .attr("y", topMargin)
                .attr("width", width - leftMargin - rightMargin)
                .attr("height", height - topMargin - bottomMargin);




            // Add the left y-axis.
            yaxisleftg = svg.selectAll("g.y.axis.left")
                .data([null]);
            yaxisleftg
                .enter()
                .append('svg:g').attr("class", "y axis left")
                .on('click', editaxis)
                .append("text")
                .attr("class", "title")
                //.attr("dy","-5em")
                .style("text-anchor", "middle");
            yaxisleftg
                .attr("transform", "translate(" + leftMargin + ",0)")
                .call(leftyAxis);
            yaxisleftg.select("text.title")
                //.attr("transform", "translate(" + (-leftMargin+axistitlefontsizept*dv.pt2px*1.3) + "," + (topMargin + (height-topMargin-bottomMargin)/2) + "), rotate(-90)")
                .attr("transform", "matrix(0,-1,1,0,0,0)")
                .attr("x", -(topMargin + (height-topMargin-bottomMargin)/2))
                .attr("y", -leftMargin+axistitlefontsizept*dv.pt2px*1.3)
				.style("font-size", axistitlefontsizept *dv.pt2px+"px")
                .call(dv.supernumbers, (ytitle === undefined ? " ": ytitle)+ " [" + yunits.replace('/a', ' a-1') + "]");

            yaxisrightg = svg.selectAll("g.y.axis.right")
                .data([null]);
            yaxisrightg
                .enter()
                .append('svg:g').attr("class", "y axis right");
            yaxisrightg
                .attr("transform", "translate("+ (width - rightMargin) + ",0)")
                .call(rightyAxis);

            var scientificformat = dv.get_scientificformatter(tickfontsizept);
            svg.selectAll("g.tick text").each(scientificformat);

        };




        function toggledetails(){
            var legenddetail = svg.select(refidstr("legenddetail"));
            if (!legenddetail.empty()){
                legenddetail.remove();
                svg.selectAll("line.linedetail,path.legendlinedetail")
                    .style("visibility", "hidden");
            } else {
                svg.selectAll("line.linedetail,path.legendlinedetail")
                    .style("visibility", "visible");
                plotlegenddetail();
            }
            obj.animatedetails();
        }


        obj.plotdata = function(lowerbandwidthequalmin){
            var clip = 'url('+refidstr("clip")+')',
                y1, y2,
                dx = xScale.rangeBand()
                ;

            var rectbandwidth = plotarea.selectAll("rect.total")
                .data(data);
            rectbandwidth
                .enter()
                .append("rect")
                .attr("class", function(d, idx){return "item-"+ idx + " total " + d.subset.cssclasses.join(' ');})
                .attr("clip-path", clip)
                ;
            rectbandwidth
                .each(function(d, idx){
                    var rect = d3.select(this);
                    rect.style(d.subset.linestyle);
                    d.ymax = {mag: d3.max(d3.values(d.case_max.mag)), units: d.case_max.units};
                    d.ymin = {mag: d3.min(d3.values(d.case_max.mag)), units: d.case_max.units};
                    d.label = "Max";
                    d.idx = d.subset.idx;
                    y1 = yScale(Math.max(d.ymax.mag, zeroforlogscale));
                    if (lowerbandwidthequalmin){
                        y2 = yScale(Math.max(d.ymin.mag, zeroforlogscale));
                    } else {
                        y2 = yScale(d.case_max.mag["RF"]);
                    }
                    rect
                        .attr("x",xScale(idx))
                        .attr("y", y1)
                        .attr("width", xScale.rangeBand())
                        .attr("height", Math.max(0, y2 - y1));
                })
            ;
            rectbandwidth
                .exit()
                .remove()
            ;
        };

        obj.plotdatadetails = function(){
            var clip = 'url('+refidstr("clip")+')',
                dx = xScale.rangeBand()
                ;

            function detaildata(d, idx){
                var name,
                    ydetail,
                    details = []
                   ;
                for (name in d.case_max.mag){
                    if(d.case_max.mag.hasOwnProperty(name)){
                        ydetail = d.case_max.get(name);
                        details.push({
                            idx: idx,
                            ymax: ydetail,
                            label: name
                        });
                    }
                }
                return details;
            }
            var itemgroup = plotarea.selectAll("g.total")
                .data(data);
            itemgroup
                .enter()
                .append("g")
                .attr("class", function(d, idx){return "item-"+ idx + " total " + d.subset.cssclasses.join(' ');})
                .attr("clip-path", clip)
                ;
            itemgroup
                .exit()
                .remove()
                .call(function(_){
                })
            ;
            var linedetail = itemgroup.selectAll("line.linedetail")
                    .data(function(item, idx){return detaildata(item, idx);});
            linedetail
                .enter()
                .append("line")
            ;
            linedetail
                .each(function(d, idx){
                    var x1 = xScale(d.idx),
                        y = yScale(Math.max(d.ymax.mag, zeroforlogscale));
                    d3.select(this)
                        .attr("x1", x1)
                        .attr("x2", x1 + dx)
                        .attr("y1", y)
                        .attr("y2", y)
                        .attr("class", "item-" + d.idx + " linedetail " + d.label.replace(/[^a-zA-Z0-9]/g, '-'))
                        .style(get_detaillinestyle(d.label))
                        .style("visibility", "hidden");
                });
            linedetail
                .exit()
                .remove();
        };



        obj.plottitle = function(title){
            titletext
                .attr("x", leftMargin + (width - leftMargin -rightMargin)/2)
                .attr("y", topMargin)
                .attr("dy", "-0.5em")
                .style({font:'Arial', 'font-size': axistitlefontsizept*dv.pt2px+"px", "text-anchor": "middle"})
                .text(title);
        };

        function plotlegenddetail(){
            var dy = 44,
                i,
                case_max,
                label,
                label_max = {},
                listof_max_label,
                max,
                yscalemin,
                g,
                origin = (width-1.15*rightMargin)+"," + topMargin
            ;
            g = svg.append('svg:g')
                .attr("transform", "translate("+origin+")")
                .attr('id', idstr("legenddetail"))
                .attr('class', "legend")
                .style("font-size", axistitlefontsizept*dv.pt2px+"px")
                .style("font-family", "Arial,Helvetice,sans-serif")
            ;
            for(i = 0; i < data.length; ++i){
                case_max = data[i].case_max.mag;
                //console.log(xylabel_max);
                for (label in case_max){
                    if(case_max.hasOwnProperty(label)){
                        if (label_max[label] === undefined){
                            label_max[label] = case_max[label];
                        } else {
                            label_max[label] = Math.max(label_max[label], case_max[label]);
                        }
                    }
                }
            }
            listof_max_label = [];
            for(label in label_max){
                if (label_max.hasOwnProperty(label)){
                    listof_max_label.push([label_max[label], label]);
                }
            }
            listof_max_label.sort(function(a, b){return b[0]-a[0];});
            //console.log(listof_max_label);
            yscalemin = yScale.domain()[0];
            for(i = 0; i < listof_max_label.length; ++i){
                max = listof_max_label[i][0];
                if (max < yscalemin) {
                    break;
                }
                label = listof_max_label[i][1];
                g.append("text")
                    .text(label)
                    //.attr('id', idstr("legendtextdetail",label))
                    .attr('class', "legendtextdetail " + label.replace(/[^a-zA-Z0-9]/g, '-'))
                    .attr('x', 40)
                    .attr('y', i*dy+20)
                    .attr('fill', detail_color(label))
                ;
            }
        }

        obj.dataExtent = function(){
            var i, ymimax = [], ydums = [];
            for(i=0; i < data.length; ++i){
                ymimax = d3.extent(d3.values(data[i].case_max.mag));
                ydums.push(ymimax[0]);
                ydums.push(ymimax[1]);
            }
            return {
                'y': d3.extent(ydums)
            };

        };

        obj.svg = function(){
            return svg;
        };

        obj.plotarea = function(){
            return plotarea;
        };

        obj.data = function(_){
            if (!arguments.length) {return data;}
            data = _;
            yunits = yunits || data[0].case_max.units;
            return obj;
        };

        obj.set = function(){
            var extent = this.dataExtent();
            var yextent = [ymin===undefined ? extent.y[0]: ymin,
                    ymax===undefined ? extent.y[1]: ymax];

            xScale = d3.scale.ordinal().domain(d3.range(data.length));
            xScale.rangeRoundBands([leftMargin, width - rightMargin], 0.0, 1);

            if(ytype === 'log'){
                yScale = d3.scale.log().domain((yextent));
                dataline.y(function(d){return yScale(Math.max(d[1], zeroforlogscale));});
            } else {
                yScale = d3.scale.linear().domain(yextent);
                dataline.y(function(d){return yScale(d[1]);});
            }
            yScale.range([height - bottomMargin, topMargin ]);

            return obj;
        };


        obj.dm = function(_){
            if (!arguments.length) return dm;
            dm = _;
            return obj;
        };

        obj.xtitle = function(_){
            if (!arguments.length) return xtitle;
            xtitle = _;
            return obj;
        };

        obj.ytitle = function(_){
            if (!arguments.length) return ytitle;
            ytitle = _;
            return obj;
        };

        obj.xtype = function(_){
            if (!arguments.length) return xtype;
            xtype = _;
            return obj;
        };

        obj.ytype = function(_){
            if (!arguments.length) return ytype;
            ytype = _;
            return obj;
        };

        obj.xmin = function(_){
            if (!arguments.length) return xmin;
            xmin = _;
            return obj;
        };

        obj.xmax = function(_){
            if (!arguments.length) return xmax;
            xmax = _;
            return obj;
        };

        obj.xScale = function(){
            return xScale;
        };

        obj.yScale = function(){
            return yScale;
        };

        obj.ymin = function(_){
            if (!arguments.length) return ymin;
            ymin = _;
            return obj;
        };

        obj.ymax = function(_){
            if (!arguments.length) return ymax;
            ymax = _;
            return obj;
        };

        obj.minorticksize = function(_){
            if (!arguments.length) return minorticksize;
            minorticksize = _;
            return obj;
        };

        obj.majorticksize = function(_){
            if (!arguments.length) return majorticksize;
            majorticksize = _;
            return obj;
        };

        obj.xUnits = function(_){
            if (!arguments.length) return xunits;
            xunits = _;
            return obj;
        };

        obj.yUnits = function(_){
            if (!arguments.length) return yunits;
            yunits = _;
            return obj;
        };

        obj.xAxis = function(_){
            if (!arguments.length) return xAxis;
            xAxis = _;
            return obj;
        };

        obj.yAxis = function(_){
            if (!arguments.length) return leftyAxis;
            leftyAxis = _;
            return obj;
        };

        obj.width = function(_){
            if (!arguments.length) return width;
            width = _;
            return obj;
        };
        obj.height = function(_){
            if (!arguments.length) return height;
            height = _;
            return obj;
        };
        obj.leftMargin = function(_){
            if (!arguments.length) return leftMargin;
            leftMargin = _;
            return obj;
        };
        obj.rightMargin = function(_){
            if (!arguments.length) return rightMargin;
            rightMargin = _;
            return obj;
        };
        obj.bottomMargin = function(_){
            if (!arguments.length) return bottomMargin;
            bottomMargin = _;
            return obj;
        };
        obj.topMargin = function(_){
            if (!arguments.length) return topMargin;
            topMargin = _;
            return obj;
        };

        obj.legendtotalx = function(_){
            if (!arguments.length) return legendtotalx || (2*leftMargin);
            legendtotalx = _;
            legendtotalg.attr("transform", "translate("+ legendtotalx + "," + obj.legendtotaly() + ")");
            return obj;
        };

        obj.legendtotaly = function(_){
            if (!arguments.length) return legendtotaly || (1.1 * topMargin);
            legendtotaly = _;
            legendtotalg.attr("transform", "translate("+ obj.legendtotalx() + "," + legendtotaly + ")");
            return obj;
        };

		obj.tickfontsizept = function(_){
			if (!arguments.length) return tickfontsizept;
			tickfontsizept = _;
		};

		obj.axistitlefontsizept = function(_){
			if (!arguments.length) return axistitlefontsizept;
			axistitlefontsizept = _;
		};

        obj.legendtotalg = function(){
            return legendtotalg;
        };

        obj.idstr = idstr;
        obj.refidstr = refidstr;

        return obj;
    }
    dv.BandwidthChart = BandwithChart;

})();


