/**
 * Created with PyCharm.
 * User: a404799
 * User: a404799
 * Date: 15.03.13
 * Time: 11:40
 * To change this template use File | Settings | File Templates.
 */

var dv = dv || {};

(function () {
    "use strict";

    var counter = 0;

    function BarChart(ele) {
        var chartid = 'BarChart' + counter++,
            width = 500,
            height = 400,
            leftMargin = 100,
            rightMargin = 50,
            topMargin = 50,
            bottomMargin = 50,
            data,
            minorticksize = 4,
            majorticksize = 10,
            dpi = 96,
            xtitle,
            ytitle,
            xmin,
            xmax,
            ymin,
            ymax,
            xtype,
            ytype,
            xunits,
            yunits,
            xScale,
            yScale,
            xAxis,
            leftyAxis,
            legendtotalx,
            legendtotaly,
			axistitlefontsizept = 10,
			tickfontsizept = 10,
            zeroforlogscale = 1E-50
            ;
        var
            svg = d3.select(ele).node().html("")
                .append("svg:svg")
                .attr("id", idstr()),
            svgdefs = svg.append("svg:defs"),
            pat = svgdefs
                .append("pattern")
                .attr("id", "diagonalHatch")
                .attr("patternUnits", "userSpaceOnUse")
                .attr("width", 4)
                .attr("height", 4)
                .attr("patternTransform", "rotate(45 2 2)")
                .append("path")
                .attr("d", "M -1,2 l 6,0")
                .style("stroke", "#000000")
                .style("stroke-width", "1"),
            titletext = svg.append("text")
                .attr("id", idstr("title")),
            legendtotalg = svg.append("svg:g")
                .attr('id', idstr("legendtotal"))
                .attr('class', "legendtotal"),
            plotarea = svg.append("svg:g")
                .attr("id", idstr("plotarea"))
                .attr("clip-path", 'url(#'+idstr("clip")+')'),
            div = d3.select(ele).node().append("div")
                .attr("class", "tooltip")
                .style("opacity", 0),
            properties = d3.select(ele).node().append("div")
                .attr("class", "properties widget shadow")
                .style({position: "absolute", top: "0.5em", left: "10em", visibility: "hidden"}),
            cliprect = svg.append("svg:clipPath").attr("id", idstr("clip")).append("svg:rect"),
            xaxistopg,
            xaxisbottomg,
            yaxisleftg,
            yaxisrightg,
            dataline = d3.svg.line(),
            zeroforlogscale = 1E-50,
            dm,
            redraw,
            pointindicator,
            obj = {}

        ;
        //console.log('init', svg);

        function idstr(){
            var i, parts = [chartid];
            for(i = 0; i < arguments.length; ++i){
                parts.push(arguments[i]);
            }
            return parts.join("--");
        }

        function refidstr(){
            return "#" + idstr.apply(undefined, arguments);
        }

        function Pointindicator(){
            var labeltext,
                labelrect,
                grouppointindicator = svg.selectAll("g.pointindicator")
                    .data([null]);
            var dy = 44;
            var bandwidth = xScale.rangeBand();
            function textlines(sel, x, y, lines){
                var tspan = sel.selectAll("tspan")
                    .data(lines);
                tspan
                    .enter()
                    .append("tspan")
                    .attr("dy", dy);
                tspan
                    .attr("x", x)
                    .text(function(d){return d;});
                tspan.exit().remove();
            }
            grouppointindicator
                .enter()
                .call(function(sel){
                    var g = sel
                        .append("g")
                        .attr("class", "pointindicator");
                    labelrect = g.append("rect")
                        .style({"fill": 'white', stroke: 'gray', "stroke-width": 1, "stroke-dasharray": "2, 2", opacity: 0.8})
                    ;
                    labeltext = g.append("text")
                    ;
                });
            return {
                show: function(x, ymax, label){
                    var x = xScale(x)  + bandwidth / 2,
                        y = yScale(ymax.mag)
                        ;
                    labeltext
                        .attr("y", y - 2.5 * dy)
                        .call(textlines, x, y, [label, ymax.mag.toExponential(2) + " " + ymax.units])
                    grouppointindicator.style("display", "block");
                    dv.copybb(labeltext, labelrect);

                },
                hide: function(){
                    grouppointindicator.style("display", "none");
                }
            };
        }
/*
*/

        function classchange(obj, factor){
            var classes = obj.className.baseVal.replace(/^\s+|\s+$/g, '').split(/\s+/),
                firstclass = classes[0],
                detailclass,
                totalclasses,
                datum;

            function changestyle(obj, attr, increment){
                //console.log(obj);
                try {
                    var val = parseInt(obj.style(attr), 10);
                    obj.style(attr, (val + factor*increment));
                } catch(e) {
                    //console.log(e);
                }
            }

            function textboldnormal(obj){
                obj.style("font-weight", factor >= 0 ? "bold" : "normal");
            }

            function hideshow(obj){
                obj.style("visibility",{"1":"visible", "-1":"hidden"}[factor]);
            }
            if (firstclass === 'total'){
                totalclasses = obj.className.baseVal.replace(/ +/g, '.');
                svg.selectAll("rect." + totalclasses).call(changestyle, "stroke-width", 2);
                svg.selectAll("path." + totalclasses).call(changestyle, "stroke-width", 2);
                svg.selectAll("text." + totalclasses).call(textboldnormal);
            } else if (firstclass.substr(0, 4) === 'item'){
                detailclass = classes[classes.length-1];
                datum = d3.select(obj).datum();
                if (factor > 0){
                    pointindicator.show(datum.idx, datum.ymax, datum.label);
                }
                svg.selectAll("line." + detailclass).call(changestyle, "stroke-width", 2);
                svg.selectAll("path." + detailclass).call(changestyle, "stroke-width", 2);
                svg.selectAll("text." + detailclass).call(textboldnormal);

            } else {
                detailclass = classes[classes.length-1];
                svg.selectAll("line." + detailclass).call(changestyle, "stroke-width", 2);
                svg.selectAll("text.legendtextdetail." + detailclass).call(textboldnormal);
            }
        }

        function highlight(){
            classchange(this, +4);
        }

        function normal(){
            classchange(this, -4);
            pointindicator.hide();
        }

        obj.animatetotal = function(){
            svg.selectAll(".total")
                .on("click", toggledetails);
            svg.selectAll("path.total,text.total,rect.total")
                .on("mouseover", highlight)
                .on("mouseout", normal);
        };

        obj.animatedetails = function(){
            svg.selectAll("line.linedetail,path.legendlinedetail,text.legendtextdetail")
                .on("mouseover", highlight)
                .on("mouseout", normal);
        };

        obj.animate = function(){
            pointindicator = Pointindicator();
            obj.animatetotal();
            obj.animatedetails();
        };


        function get_detaillinestyle(name){
            return {"stroke-width": 2, stroke:get_detailcolor(name), fill:"none"};
        }

        function editaxis(){
            properties.html('<fieldset><legend>Axes</legend>\
<fieldset>\
<legend>Y</legend>\
<table>\
<tr><td>Min:</td><td><input class="ymin" size="10" type="text"></td></tr>\
<tr><td>Max:</td><td><input class="ymax" size="10" type="text"></td></tr>\
<tr><td>Type:</td><td><select class="yaxistype">\
<option value="log">log</option>\
<option value="lin">lin</option>\
</select>\
</td></tr>\
</table>\
</fieldset>\
<input class="axisapply" type="button" value="Apply">\
<input class="axisclose" type="button" value="Close">\
</fieldset>\
</fieldset>');
            properties.style("visibility", "visible");
            properties.select(".ymin").attr("value", ymin);
            properties.select(".ymax").attr("value", ymax);
            properties.select(".yaxistype option[value="+ytype+"]").attr("selected", true);

            properties.select(".axisapply").on("click", function(){
                ymin = parseFloat(properties.select(".ymin").node().value);
                ymax = parseFloat(properties.select(".ymax").node().value);
                ytype = properties.select(".yaxistype").node().value;
                redraw(obj);
            });
            properties.select(".axisclose").on("click", function(){
                properties.style("visibility", "hidden");
            });
        }

        obj.onredraw = function(_){
            redraw = _;
        };


        obj.plotaxis = function(){
            xAxis = d3.svg.axis()
                .scale(xScale)
                .orient('bottom')
                .tickFormat(function(d, i){
                    return data[i].subset.label;
                })
            ;

            var topxAxis = d3.svg.axis()
                .scale(xScale)
                .orient('bottom')
                .tickFormat(function(){})
                ;


            leftyAxis = d3.svg.axis()
                .scale(yScale)
                .ticks(4)
                .tickPadding(10)
                .tickSize(-majorticksize, -minorticksize)
                .orient('left');

            var rightyAxis = d3.svg.axis()
                .scale(yScale)
                .ticks(4)
                .tickSize(majorticksize)
                .orient('left')
                .tickFormat(function(){})
                ;
            //var fmt = rightyAxis.tickFormat();
            //.tickFormat(function(x){return fmt(x).toString().split('e').join('--')});

            svg
                .attr("width", dv.pt(width, dpi))
                .attr("height", dv.pt(height, dpi))
                .attr("viewBox", "0 0 " + width + " " + height)

            cliprect
                .attr("x", leftMargin)
                .attr("y", topMargin)
                .attr("width", width - leftMargin - rightMargin)
                .attr("height", height - topMargin - bottomMargin);




            // Add the left y-axis.
            yaxisleftg = svg.selectAll("g.y.axis.left")
                .data([null]);
            yaxisleftg
                .enter()
                .append('svg:g').attr("class", "y axis left")
                .on('click', editaxis)
                .append("text")
                .attr("class", "title")
                //.attr("dy","-5em")
                .style("text-anchor", "middle");
            yaxisleftg
                .attr("transform", "translate(" + leftMargin + ",0)")
                .call(leftyAxis);
            yaxisleftg.select("text.title")
                //.attr("transform", "translate(" + (-leftMargin+axistitlefontsizept*dv.pt2px*1.3) + "," + (topMargin + (height-topMargin-bottomMargin)/2) + "), rotate(-90)")
                .attr("transform", "matrix(0,-1,1,0,0,0)")
                .attr("x", -(topMargin + (height-topMargin-bottomMargin)/2))
                .attr("y", -leftMargin+axistitlefontsizept*dv.pt2px*1.3)

				.style("font-size", axistitlefontsizept *dv.pt2px+"px")
                .call(dv.supernumbers, (ytitle === undefined ? " ": ytitle)+ " [" + yunits.replace('/a', ' a-1') + "]");

            yaxisrightg = svg.selectAll("g.y.axis.right")
                .data([null]);
            yaxisrightg
                .enter()
                .append('svg:g').attr("class", "y axis right");
            yaxisrightg
                .attr("transform", "translate("+ (width - rightMargin) + ",0)")
                .call(rightyAxis);

            var scientificformat = dv.get_scientificformatter(tickfontsizept);
            svg.selectAll("g.tick text").each(scientificformat);

        };




        function toggledetails(){
            var legenddetail = svg.select(refidstr("legenddetail"));
            if (!legenddetail.empty()){
                legenddetail.remove();
                svg.selectAll("line.linedetail,path.legendlinedetail")
                    .style("visibility", "hidden");
            } else {
                svg.selectAll("line.linedetail,path.legendlinedetail")
                    .style("visibility", "visible");
                plotlegenddetail();
            }
            obj.animatedetails();
        }


        obj.plotdata = function(){
            var clip = 'url('+refidstr("clip")+')',
                y1,
                y2 = height - bottomMargin,
                dx = xScale.rangeBand()
                ;

            var recttotal = plotarea.selectAll("rect.total")
                .data(data);
            recttotal
                .enter()
                .append("rect")
                .attr("class", function(d, idx){return "item-"+ idx + " total " + d.subset.cssclasses.join(' ');})
                .attr("clip-path", clip)
                ;
            recttotal
                .each(function(d, idx){
                    var rect = d3.select(this),
                        total,
                        imax;
                    rect.style(d.subset.linestyle);
                    total = d.xy.total();
                    d.ymax = total.y.max();
                    imax = total.y.mag.indexOf(d.ymax.mag);
                    d.xmax = total.x.get(imax);
                    d.label = "Total";
                    d.idx = d.subset.idx;
                    y1 = yScale(Math.max(d.ymax.mag, zeroforlogscale));
                    rect
                       // .attr("fill", "url(#diagonalHatch)")
                        .attr("x",xScale(idx))
                        .attr("y", y1)
                        .attr("width", xScale.rangeBand())
                        .attr("height", Math.max(0, y2 - y1));
                })
            ;
            recttotal
                .exit()
                .remove()
            ;
        };

        obj.plotdatadetails = function(){
            var clip = 'url('+refidstr("clip")+')',
                dx = xScale.rangeBand()
                ;

            function detaildata(d, idx){
                var name,
                    ydetail,
                    details = [],
                    xy = d.xy;
                for (name in xy.y.mag){
                    if(xy.y.mag.hasOwnProperty(name)){
                        ydetail = xy.y.get(name);
                        details.push({
                            idx: idx,
                            ymax: ydetail.max(),
                            label: name
                        });
                    }
                }
                return details;
            }
            var itemgroup = plotarea.selectAll("g.total")
                .data(data);
            itemgroup
                .enter()
                .append("g")
                .attr("class", function(d, idx){return "item-"+ idx + " total " + d.subset.cssclasses.join(' ');})
                .attr("clip-path", clip)
                ;
            itemgroup
                .exit()
                .remove()
                .call(function(_){
                })
            ;
            var linedetail = itemgroup.selectAll("line.linedetail")
                    .data(function(item, idx){return detaildata(item, idx);});
            linedetail
                .enter()
                .append("line")
            ;
            linedetail
                .each(function(d, idx){
                    var x1 = xScale(d.idx),
                        y = yScale(Math.max(d.ymax.mag, zeroforlogscale));
                    d3.select(this)
                        .attr("x1", x1)
                        .attr("x2", x1 + dx)
                        .attr("y1", y)
                        .attr("y2", y)
                        .attr("class", "item-" + d.idx + " linedetail " + d.label)
                        .style(get_detaillinestyle(d.label))
                        .style("visibility", "hidden");
                });
            linedetail
                .exit()
                .remove();
        };



        obj.plottitle = function(title){
            titletext
                .attr("x", leftMargin + (width - leftMargin -rightMargin)/2)
                .attr("y", topMargin)
                .attr("dy", "-0.5em")
                .style({font:'Arial', 'font-size': axistitlefontsizept*dv.pt2px+"px", "text-anchor": "middle"})
                .text(title);
        };

        function plotlegenddetail(){
            var dy = 44,
                i, xy, xylabel_max, label,
                label_max = {},
                listof_max_label,
                max,
                yscalemin,
                g,
                origin = (width-1.15*rightMargin)+"," + topMargin
            ;
            g = svg.append('svg:g')
                .attr("transform", "translate("+origin+")")
                .attr('id', idstr("legenddetail"))
                .attr('class', "legend");
            for(i = 0; i < data.length; ++i){
                xy = data[i].xy;
                xylabel_max = xy.y.maxTab().mag;
                //console.log(xylabel_max);
                for (label in xylabel_max){
                    if(xylabel_max.hasOwnProperty(label)){
                        if (label_max[label] === undefined){
                            label_max[label] = xylabel_max[label];
                        } else {
                            label_max[label] = Math.max(label_max[label], xylabel_max[label]);
                        }
                    }
                }
            }
            listof_max_label = [];
            for(label in label_max){
                if (label_max.hasOwnProperty(label)){
                    listof_max_label.push([label_max[label], label]);
                }
            }
            listof_max_label.sort(function(a, b){return b[0]-a[0];});
            //console.log(listof_max_label);
            yscalemin = yScale.domain()[0];
            for(i = 0; i < listof_max_label.length; ++i){
                max = listof_max_label[i][0];
                if (max < yscalemin) {
                    break;
                }
                label = listof_max_label[i][1];
                g.append("text")
                    .text(label)
                    //.attr('id', idstr("legendtextdetail",label))
                    .attr('class', "legendtextdetail " + label)
                    .attr('x', 40)
                    .attr('y', i*dy+20)
                    .style("font-size", 35.28+"px")
                    .attr('fill', get_detailcolor(label))
                ;
            }
        }

        obj.xysExtent = function(){
            var i, xmimax, ymimax, xdums = [], ydums = [];
            for(i=0; i < data.length; ++i){
                xmimax = data[i].xy.x.extent().mag;
                xdums.push(xmimax[0]);
                xdums.push(xmimax[1]);
                ymimax = data[i].xy.y.extent().mag;
                ydums.push(ymimax[0]);
                ydums.push(ymimax[1]);
            }
            return {
                'x': d3.extent(xdums),
                'y': d3.extent(ydums)
            };

        };

        obj.svg = function(){
            return svg;
        };

        obj.plotarea = function(){
            return plotarea;
        };

        obj.data = function(_){
            if (!arguments.length) {return data;}
            data = _;
            xunits = xunits || data[0].xy.x.units;
            yunits = yunits || data[0].xy.y.units;
            return obj;
        };

        obj.set = function(){
            var extent = this.xysExtent();
            var yextent = [ymin===undefined ? extent.y[0]: ymin,
                    ymax===undefined ? extent.y[1]: ymax];

            xScale = d3.scale.ordinal().domain(d3.range(data.length));
            xScale.rangeRoundBands([leftMargin, width - rightMargin], 0.0, 1);

            if(ytype === 'log'){
                yScale = d3.scale.log().domain((yextent));
                dataline.y(function(d){return yScale(Math.max(d[1], zeroforlogscale));});
            } else {
                yScale = d3.scale.linear().domain(yextent);
                dataline.y(function(d){return yScale(d[1]);});
            }
            yScale.range([height - bottomMargin, topMargin ]);

            return obj;
        };


        obj.dm = function(_){
            if (!arguments.length) return dm;
            dm = _;
            return obj;
        };

        obj.xtitle = function(_){
            if (!arguments.length) return xtitle;
            xtitle = _;
            return obj;
        };

        obj.ytitle = function(_){
            if (!arguments.length) return ytitle;
            ytitle = _;
            return obj;
        };

        obj.xtype = function(_){
            if (!arguments.length) return xtype;
            xtype = _;
            return obj;
        };

        obj.ytype = function(_){
            if (!arguments.length) return ytype;
            ytype = _;
            return obj;
        };

        obj.xmin = function(_){
            if (!arguments.length) return xmin;
            xmin = _;
            return obj;
        };

        obj.xmax = function(_){
            if (!arguments.length) return xmax;
            xmax = _;
            return obj;
        };

        obj.xScale = function(){
            return xScale;
        };

        obj.yScale = function(){
            return yScale;
        };

        obj.ymin = function(_){
            if (!arguments.length) return ymin;
            ymin = _;
            return obj;
        };

        obj.ymax = function(_){
            if (!arguments.length) return ymax;
            ymax = _;
            return obj;
        };

        obj.minorticksize = function(_){
            if (!arguments.length) return minorticksize;
            minorticksize = _;
            return obj;
        };

        obj.majorticksize = function(_){
            if (!arguments.length) return majorticksize;
            majorticksize = _;
            return obj;
        };

        obj.xUnits = function(_){
            if (!arguments.length) return xunits;
            xunits = _;
            return obj;
        };

        obj.yUnits = function(_){
            if (!arguments.length) return yunits;
            yunits = _;
            return obj;
        };

        obj.xAxis = function(_){
            if (!arguments.length) return xAxis;
            xAxis = _;
            return obj;
        };

        obj.yAxis = function(_){
            if (!arguments.length) return leftyAxis;
            leftyAxis = _;
            return obj;
        };

        obj.width = function(_){
            if (!arguments.length) return width;
            width = _;
            return obj;
        };
        obj.height = function(_){
            if (!arguments.length) return height;
            height = _;
            return obj;
        };
        obj.leftMargin = function(_){
            if (!arguments.length) return leftMargin;
            leftMargin = _;
            return obj;
        };
        obj.rightMargin = function(_){
            if (!arguments.length) return rightMargin;
            rightMargin = _;
            return obj;
        };
        obj.bottomMargin = function(_){
            if (!arguments.length) return bottomMargin;
            bottomMargin = _;
            return obj;
        };
        obj.topMargin = function(_){
            if (!arguments.length) return topMargin;
            topMargin = _;
            return obj;
        };

        obj.legendtotalx = function(_){
            if (!arguments.length) return legendtotalx || (2*leftMargin);
            legendtotalx = _;
            legendtotalg.attr("transform", "translate("+ legendtotalx + "," + obj.legendtotaly() + ")");
            return obj;
        };

        obj.legendtotaly = function(_){
            if (!arguments.length) return legendtotaly || (1.1 * topMargin);
            legendtotaly = _;
            legendtotalg.attr("transform", "translate("+ obj.legendtotalx() + "," + legendtotaly + ")");
            return obj;
        };


		obj.tickfontsizept = function(_){
			if (!arguments.length) return tickfontsizept;
			tickfontsizept = _;
		};

		obj.axistitlefontsizept = function(_){
			if (!arguments.length) return axistitlefontsizept;
			axistitlefontsizept = _;
            return obj;
		};

        obj.legendtotalg = function(){
            return legendtotalg;
        };

        obj.idstr = idstr;
        obj.refidstr = refidstr;

        return obj;
    }
    dv.BarChart = BarChart;

})();

(function(){
    function barchartdata(){
        var objects,
            legendobjects = [],
            stylingpreferences = [],
            axisattributes = [],
            legendattributes = [],
            axistitlefontsizept = 10,
            insync,
            f = {}
            ;

        function update(obj, other){
            for (var key in other){
                if (other.hasOwnProperty(key)){
                    obj[key] = other[key];
                }
            }
        }

        f.objects = function(_){
            if (!arguments.length) return objects;
            objects = _;
            insync = false;
            return f;
        };

		f.axistitlefontsizept = function(_){
            if (!arguments.length) return axistitlefontsizept;
			axistitlefontsizept = _;
            return f;
		};

        f.axisattributes = function(_){
            if (!arguments.length) return axisattributes;
            axisattributes = _;
            insync = false;
            return f;
        };

        f.legendattributes = function(_){
            if (!arguments.length) return legendattributes;
            legendattributes = _;
            insync = false;
            return f;
        };

        f.sort = function(){
            var attributes = [];
            [axisattributes, legendattributes].forEach(function(attrs){
                attrs.forEach(function(attr){
                    attributes.push(attr);
                });
            });
            objects.sort(dm.get_compare(attributes));
            insync = false;
            return f;
        };

        function sync(){
            if (insync === true) return;
            legendattributes.forEach(function(attr){
                attr.pattern = new Pattern(attr.name());
            });
            var legendstringcontainer = {},
                legendstr;

            legendobjects = [];
            if (legendattributes.length > 0){
                objects.forEach(function(obj){
                    var legendobj = {};
                    legendattributes.forEach(function(attr){
                        var value = attr.objvalue(obj);
                        attr.pattern.push(value);
                        legendobj[attr.name()] = attr.objvalue(obj);
                    });
                    legendstr = d3.values(legendobj).toString();
                    if (legendstringcontainer.hasOwnProperty(legendstr) === false){
                        legendstringcontainer[legendstr] = null;
                        legendobjects.push(legendobj);
                    }
                });
                legendobjects.sort(dm.get_compare(legendattributes));
            }
            insync = true;
            return f;
        }

        f.data = function(){
            var linestyle,
                pattern;
            sync();
            var sortedlegendattributes = legendattributes.slice();
            sortedlegendattributes.sort(function(a, b){return b.pattern.distinctvalues - a.pattern.distinctvalues;});
            var numberobjectstyles = Math.min(sortedlegendattributes.length, stylingpreferences.length);
            return objects.map(function(obj, subsetidx){
                linestyle = {fill: "#ADD9AA", stroke: "black", "stroke-width": 2, //opacity: 0.3
                };
                for(i=0; i < numberobjectstyles; ++i){
                    pattern = sortedlegendattributes[i].pattern;
                    update(linestyle, stylingpreferences[i].get(pattern.valueids[subsetidx]));
                }
                return {
                    global: obj,
                    subset: {
                        idx: subsetidx,
                        cssclasses: sortedlegendattributes.map(function(attr, idx){
                            return 'c' + idx + '-' + attr.pattern.value_id[attr.objvalue(obj)];
                        }),
                        label: legendattributes.map(function(attr){return attr.objvalue(obj)}).join(' '),
                        linestyle: linestyle,
                        visible: 'total'
                    }
                };
            });
        };

        f.legenddata = function(){
            var linestyle,
                attr,
                idx;
            sync();
            var sortedlegendattributes = legendattributes.slice();
            sortedlegendattributes.sort(function(a, b){return b.pattern.distinctvalues - a.pattern.distinctvalues;});
            var numberobjectstyles = Math.min(sortedlegendattributes.length, stylingpreferences.length);
            return legendobjects.map(function(obj, objidx){
                linestyle = {fill: "lightblue", stroke: "black", "stroke-width": 2//, opacity: 0.3
                };
                for(i=0; i < numberobjectstyles; ++i){
                    attr = sortedlegendattributes[i];
                    idx = attr.pattern.value_id[attr.objvalue(obj)];
                    update(linestyle, stylingpreferences[i].get(idx));
                }
                return {
                    global: obj,
                    subset: {
                        idx: objidx,
                        cssclasses: sortedlegendattributes.map(function(attr, idx){
                            return 'c' + idx + '-' + attr.pattern.value_id[attr.objvalue(obj)];
                        }),
                        label: legendattributes.map(function(attr){return attr.objvalue(obj)}).join(' '),
                        linestyle: linestyle,
                        visible: 'total'
                    }
                };
            });
        };

        f.stylingpreferences = function(_){
            if (!arguments.length) return stylingpreferences;
            stylingpreferences = _;
            return f;
        };

        f.axisdata = function(){
            sync();
            return axisattributes.map(function(attr){
                var grouper = dm.grouper();
                objects.map(function(obj){return attr.objvalue(obj);}).forEach(function(item){grouper.add(item)});
                return grouper.listof_item_start_stop();
            });
        };

        f.maxcharsperitem = function(){
            var value = 0;
            f.axisdata().forEach(function(row){
                row.forEach(function(item){
                    value = Math.max(value, item[0].length/(item[2] - item[1]));
                })
            });
            return value;
        };

        f.renderXAxis = function(barchart, height){
            var svg = barchart.svg(),
                xscale = barchart.xScale(),
                bandwidth = xscale.rangeBand(),

                y1 = barchart.height() - barchart.bottomMargin(),
                y = y1,// + height,
                xaxis = svg.selectAll("g.x.axis")
                    .data([null]),
                axisdata = f.axisdata(),
                startidx = axisdata.length
                ;
            xaxis.enter()
                .append("g")
                .attr("class", "x axis");

            xaxis.append("line")
                .attr("x1", barchart.leftMargin())
                .attr("y1", y1)
                .attr("x2", barchart.width() - barchart.rightMargin())
                .attr("y2", y1);

            xaxis.append("line")
                .attr("x1", barchart.leftMargin())
                .attr("y1", barchart.topMargin())
                .attr("x2", barchart.width() - barchart.rightMargin())
                .attr("y2", barchart.topMargin());
            xaxis.append("line")
                .attr("x1", xscale(0))
                .attr("y1", y1)
                .attr("x2", xscale(0))
                .attr("y2", y1 + height * axisdata.length)
            ;

            var attributes = xaxis.selectAll("g.attributes")
                .data(axisdata)
                .enter()
                .append("g")
                .attr("class","attributes");
            var text = attributes.selectAll("text")
                .data(function(arr, idx){
                    return arr.map(function(d){return {yidx: startidx-idx, txt:d[0], start:d[1], stop: d[2]}});
                })
                .enter()
                .append("text")
                .style({font:'Arial', 'font-size': axistitlefontsizept*dv.pt2px+"px",
                    "text-anchor": "middle"})
                .attr("x", function(d){
                    return (xscale(d.start) + xscale(d.stop-1)+bandwidth)/2;
                })
                .attr("y", function(d){return y + d.yidx * height;})
                .text(function(d){return d.txt;});
            var line = attributes.selectAll("line")
                .data(function(arr, idx){
                    return arr.map(function(d){return {yidx: startidx-idx-1, txt:d[0], start:d[1], stop: d[2]}});
                })
                .enter()
                .append("line")
                .attr("x1", function(d){return xscale(d.stop-1)+bandwidth;})
                .attr("x2", function(d){return xscale(d.stop-1)+bandwidth;})
                .attr("y1", function(d){
                    return y1 + d.yidx * height
                })
                .attr("y2", function(d){return y1 + (d.yidx + 1) * height})
            ;
        };

        return f;
    }
    dv.barchartdata = barchartdata;
})();

