/**
 * Created with PyCharm.
 * User: a404799
 * Date: 08.04.14
 * Time: 11:32
 * To change this template use File | Settings | File Templates.
 */


function Decay(){
    'use strict';
    var n_hl = {}, // nuclide lambda
        n_lam = {}, // nuclide lambda
        m_d_part = {}, // mother daughter part
        d_mset = {}, // daughter set of direct parents
        m_n_paths = {}, // mother nuclide paths
        mdhps = [],
        log2 = Math.LN2;

    function setdefault(dict, key, value){
        return (dict[key] = dict[key] || value);
    }
    function walk(n, fun,arg){
        (m_d_part[n] ? d3.keys(m_d_part[n]) : []).forEach(function(d){
            fun(n, d, arg);
            walk(d, fun, arg);
        });
    }
    function get_descendants(n){
        var descendantset = d3.set([n]);
        walk(n, function(m, d){
            descendantset.add(d);
        });
        return descendantset;
    }
    function atoms2bq(n_atoms) {
        var n_bq = {};
        d3.map(n_atoms).forEach(function(n, atoms){
            n_bq[n] = atoms * n_lam[n];
        });
        return n_bq;
    }
    function bq2atoms(n_bq) {
        var n_atoms = {};
        d3.map(n_bq).forEach(function(n, bq){
            n_atoms[n] = bq / n_lam[n];
        });
        return n_atoms;
    }

    function eval_m_paths(m, ip, paths){ //evaluates all paths starting at m
        var d_lam = m_d_part[m],
            lp = paths[ip].length
            ;
        d3.keys(d_lam).forEach(function(d, i){
            var path, j;
            if (i > 0) {
                path = paths[ip].slice(0, lp);
                j = paths.length;
                paths.push(path);
            } else {
                j = ip;
                path = paths[ip];
            }
            path.push(d);
            setdefault(m_n_paths[path[0]], d, []).push(path.slice());
            if (m_d_part[d] !== undefined) {
                eval_m_paths(d, j, paths);
            }
        });
    }

    function get_n_paths(m){
        var n_paths = m_n_paths[m];
        if (n_paths === undefined) {
            m_n_paths[m] = {};
            eval_m_paths(m, 0, [[m]]);
            n_paths = m_n_paths[m];
        }
        return n_paths;
    }

    return {
        mdhps: function(_){
            if (!arguments.length){return mdhps;}
            mdhps = _;
            mdhps.forEach(function(mdhp){
                var m = mdhp[0],
                    d = mdhp[1],
                    hl = mdhp[2],
                    p = mdhp[3]
                    ;
                n_lam[m] = log2 / (hl * 365.25*86400);
                setdefault(n_lam, d, 0);
                setdefault(m_d_part, m, {})[d] = p;
                setdefault(d_mset, m, d3.set()).add(m);
            });
        },
        Inventory: function(_){
            var hlshortmax = false,
                m_factor = {},
                _pathsok = false,
                n_atoms0 = {},
                relevantset,
                paths,
                entryset,
                listof_n_pathatoms0
            ;
            function eval_m_factor(m){
                walk(m, function f(m, d) {
                        m_factor[d] = setdefault(m_factor, d, 0) + 1;
                    }
                );
            }
            function check_paths(){
                if (_pathsok) {return;}
                var descendantset = d3.set();
                d3.keys(n_atoms0).forEach(function(n){
                    d3.keys(m_d_part[n]).forEach(function(d){
                        get_descendants(d).forEach(function(dd){
                            descendantset.add(dd);
                        });
                    });
                });
                entryset = d3.set();
                d3.keys(n_atoms0).forEach(function(n){
                    if (!descendantset.has(n)){
                        entryset.add(n);
                    }
                });

                entryset.values().forEach(function(n){
                    m_factor[n] = 1.0;
                    eval_m_factor(n);
                });

                relevantset = d3.set(descendantset.values().concat(entryset.values()));

                paths = [];

                entryset.values().forEach(function(nuc){
                    d3.values(get_n_paths(nuc)).forEach(function(npaths){
                        npaths.forEach(function(path){
                            paths.push(path);
                        });
                    });
                });

                listof_n_pathatoms0 = [];
                var listof_n_part = [];
                paths.forEach(function(path){
                    var d = path[path.length-1],
                        n_pathatoms0 = {},
                        n_part = {},
                        part = 1.0,
                        m
                        ;
                    n_pathatoms0[d] = n_atoms0[d] || 0;
                    for (var i = path.length - 1; i > 0; i = i - 1) {
                        m = path[i-1];
                        d = path[i];
                        part = m_d_part[m][d] * part;
                        n_part[m] = part;
                        n_pathatoms0[m] = (n_atoms0[m] || 0) * part;
                    }
                    listof_n_pathatoms0.push(n_pathatoms0);
                    listof_n_part.push(n_part);
                });
                _pathsok = true;
            }
            function calc_bateman(path, n_pathatoms0, n_exp, n_res, f){
                if (f === undefined) {f = 1;}
                var b = 0,
                    n = path[path.length - 1]
                ;
                path.forEach(function(i, j){
                    path.slice(j).forEach(function(k){
                        var klam = n_lam[k],
                            cnij = 1.0,
                            q
                            ;
                        path.slice(j).forEach(function(l){
                            if (l !== n) {cnij = cnij * n_lam[l];}
                            if (l !== k) {
                                cnij = cnij / (n_lam[l] - klam);
                            }
                        });
                        q = cnij * n_pathatoms0[i] / m_factor[i] * n_exp[k];
                        b = b + q;
                    });
                });
                n_res[n] = setdefault(n_res, n, 0) + b * f;
                return n_res;
            }

            function n_atoms(t1){
                check_paths();
                var n_atoms = {},
                    n_exp = {}
                    ;
                relevantset.values().forEach(function(n){
                    n_exp[n] = Math.exp(-n_lam[n] * t1);
                });

                entryset.values().forEach(function(n){
                    n_atoms[n] = n_exp[n] * n_atoms0[n];
                });

                for (var i = 0; i < paths.length; i = i + 1){
                    calc_bateman(paths[i], listof_n_pathatoms0[i], n_exp, n_atoms);
                }

                return n_atoms;
            }

            function n_timeIntegratedBq(self, t1, t2){
                check_paths();
                var n_res = {},
                    n_exp = {}
                    ;
                relevantset.values().forEach(function(n){
                    n_exp[n] = decay.n_lam[n] ? Math.exp(-n_lam[n] * t1) / n_lam[n] : 0;
                });

                if (t2 !== undefined){
                    n_exp[n] = decay.n_lam[n] ? Math.exp(-n_lam[n] * t2) / n_lam[n] : 0;
                }

                entryset.values().forEach(function(n){
                    n_res[n] = n_exp[n] * n_atoms0[n] * decay.n_lam[n];
                });

                for (var i = 0; i < paths.length; i = i + 1){
                    calc_bateman(paths[i], listof_n_pathatoms0[i], n_exp, n_res, n_lam[path[path.length - 1]]);
                }

                return n_res;
            }

            return {
                n_bq0: function(_){
                    if (!arguments.length) {return atoms2bq(n_atoms0);}
                    _pathsok = false;
                    n_atoms0 = bq2atoms(_);
                },
                n_mol0: function(_){
                    if (!arguments.length) {return atoms2mol(n_atoms0);}
                    _pathsok = false;
                    n_atoms0 = mol2atoms(_);
                },
                n_bq: function(t1){
                    return atoms2bq(n_atoms(t1))
                }
            };
        }
    };
}
