var get_detailcolor = (function (d3) {
    "use strict";
    var n = 0,
        detail_color = {
            "A-999": "#000000",
            "Ac-227": "#00FFFF",
            "Ag-108m": "#C8001E",
            "Ag-999": "#FF0000",
            "Am-241": "#FF7800",
            "Am-242m": "#FF00FF",
            "Am-243": "#0000FF",
            "B-999": "#FF0000",
            "Be-10": "#00FF00",
            "C-14": "#FF0000",
            "C-999": "#00FF00",
            "Ca-41": "#00FFFF",
            "Ca-999": "#00FFFF",
            "Ch-14": "#0000FF",
            "Ch-14c": "#FFFF00",
            "Cl-36": "#000000",
            "Cm-243": "#BEBEF0",
            "Cm-244": "#00FF00",
            "Cm-245": "#FF00FF",
            "Cm-246": "#00FFFF",
            "Co-60": "#1EC800",
            "Cs-135": "#9400D3",
            "Cs-137": "#0000FF",
            "D-999": "#0000FF",
            "E-999": "#FFFF00",
            "Eu-154": "#FF0000",
            "F-999": "#BC8F8F",
            "G-999": "#008F8F",
            "H-3": "#BEBEF0",
            "H-999": "#BC008F",
            "Ho-166m": "#FF7800",
            "Ho-999": "#FF7800",
            "I-129": "#00FF00",
            "I-999": "#BC8F00",
            "J-999": "#FFFF05",
            "K-40": "#282800",
            "K-999": "#37FFFF",
            "L-999": "#FF37FF",
            "M-999": "#FFFF37",
            "Mo-93": "#646464",
            "N-999": "#3737FF",
            "Nb-93m": "#3C8F50",
            "Nb-94": "#BEBEF0",
            "Nb-999": "#BEBEF0",
            "Ni-59": "#FF00FF",
            "Ni-63": "#00FFFF",
            "Ni-999": "#00FFFF",
            "Np-237": "#0000FF",
            "O-999": "#37FF37",
            "P-999": "#FF3737",
            "Pa-231": "#0000FF",
            "Pb-210": "#646464",
            "Pb-999": "#646464",
            "Pd-107": "#FF7800",
            "Pd-999": "#FF7800",
            "Po-210": "#3C8F50",
            "Pu-238": "#0000FF",
            "Pu-239": "#3C8F50",
            "Pu-240": "#FF00FF",
            "Pu-241": "#00FF00",
            "Pu-242": "#FF7800",
            "Q-999": "#19FFFF",
            "R-999": "#9B9B9B",
            "Ra-226": "#9400D3",
            "Ra-228": "#FF0000",
            "S-999": "#9B3737",
            "Se-79": "#FF7800",
            "Se-999": "#FF7800",
            "Sm-151": "#3C8F50",
            "Sm-999": "#3C8F50",
            "Sn-121m": "#9B5A64",
            "Sn-126": "#9400D3",
            "Sn-999": "#9400D3",
            "Sr-90": "#9B5A64",
            "Sr-999": "#9B5A64",
            "T-999": "#379B37",
            "Tc-99": "#FF0000",
            "Th-228": "#9400D3",
            "Th-229": "#FF0000",
            "Th-230": "#9B5A64",
            "Th-232": "#00FFFF",
            "U-232": "#0000FF",
            "U-233": "#00FFFF",
            "U-234": "#FF0000",
            "U-235": "#9400D3",
            "U-236": "#FF7800",
            "U-238": "#00FF00",
            "U-999": "#37379B",
            "V-999": "#9B9B37",
            "W-999": "#9B9B9B",
            "X-999": "#9BFFFF",
            "Y-999": "#FF9BFF",
            "Z-999": "#FFFF9B",
            "Zr-93": "#646464",
            "Zr-999": "#646464"
        },
        colors = d3.scale.category20().range()
        ;
    function f(detail) {
        if (detail_color[detail] === undefined) {
            detail_color[detail] = colors[n % 20];
            n++;
        }
        return detail_color[detail];
    }
    return f;
}(window.d3));

