/**
/**
 * Created with PyCharm.
 * User: mag
 * Date: 10.02.13
 * Time: 09:29
 * To change this template use File | Settings | File Templates.
 */

var dm = dm || {};
if (!window.console) window.console = {};
if (!window.console.log) window.console.log = function () { };
var console = window.console;

if (!Array.prototype.indexOf) {
    Array.prototype.indexOf = function (searchElement /*, fromIndex */ ) {
        "use strict";
        if (this == null) {
            throw new TypeError();
        }
        var t = Object(this);
        var len = t.length >>> 0;
        if (len === 0) {
            return -1;
        }
        var n = 0;
        if (arguments.length > 1) {
            n = Number(arguments[1]);
            if (n !== n) { // shortcut for verifying if it's NaN
                n = 0;
            } else if (n !== 0 && n != Infinity && n !== -Infinity) {
                n = (n > 0 || -1) * Math.floor(Math.abs(n));
            }
        }
        if (n >= len) {
            return -1;
        }
        var k = n >= 0 ? n : Math.max(len - Math.abs(n), 0);
        for (; k < len; k++) {
            if (k in t && t[k] === searchElement) {
                return k;
            }
        }
        return -1;
    };
}

Array.prototype.bisect = function(x, lo, hi) {
    var mid;
    if(lo === undefined) lo = 0;
    if(hi === undefined) hi = this.length;
    while(lo < hi) {
        mid = Math.floor((lo + hi) / 2);
        if(x < this[mid]) hi = mid;
        else lo = mid + 1;
    }
    return lo;
};

function zeros(n){
    var i, a = new Array(n);
    for (i = 0; i < n; ++i){
        a[i] = 0;
    }
    return a;
}

if (typeof String.prototype.endsWith !== 'function') {
    String.prototype.endsWith = function(suffix) {
        return this.indexOf(suffix, this.length - suffix.length) !== -1;
    };
}

if(typeof String.prototype.trim !== 'function') {
  String.prototype.trim = function() {
    return this.replace(/^\s+|\s+$/g, '');
  };
}

// handling of units based on module quantities

function get_unitsconversionfactor(fromunits, tounits){
    var fq = new Qty(fromunits || '1');
    var tq = new Qty(tounits || '1');
    if(!fq.isCompatible(tq)){
        throw 'cannot convert "'+fromunits+'" to "'+tounits+'"';
    }
    return fq.isUnitless()? 1 : fq.to(tq).scalar;
}
function get_unitsproduct(a, b){
    var aqty = new Qty(a || "1");
    var bqty = new Qty(b || "1");
    return aqty.mul(bqty);
}

function get_unitsdivide(a, b){
    if (a === '' && b === '') return new Qty("1");
    var aqty = new Qty(a || "1");
    var bqty = new Qty(b || "1");
    return aqty.div(bqty);
}

(function(){
    "use strict";
    /*
     Returns an array of all unique keys of supplied objects
     */
    function get_allkeys(){
        var dum = {},
            allkeys = [],
            key;
        for (var i=0; i<arguments.length; i++){
            for (key in arguments[i]) {
                if (arguments[i].hasOwnProperty(key)){
                    dum[key] = null;
                }
            }
        }
        for (key in dum) {
            if (dum.hasOwnProperty(key)){
                allkeys.push(key);
            }
        }
        return allkeys;
    }
    /*
    function keys(obj) {
        var keys = [];
        for (key in obj) {
            if (obj.hasOwnProperty(key)){
                keys.push(key);
            }
        }
        return keys;
    }
    */

    /*
     Interpolation helper function
     */

    function get_interpolations(a, b){
        var ab = [], ais = [], bis = [];
        // find start
        var alen = a.length,
            blen = b.length;
        if (a[0] > b[blen-1] || b[0] > a[alen-1]) {
            throw "arrays a and b do not overlap";
        }
        var first;
        var aai, bbi;
        // find first value of ab
        var ai= 0, bi=0;
        if (a[0] < b[0]) {
            for (first = b[0]; ai < alen; ){
                if (a[ai] < first){
                    ai++;
                } else {
                    break;
                }
            }
        } else if (a[0] > b[0]) {
            for (first = a[0]; bi < blen; ) {
                if (b[bi] < first){
                    bi++;
                } else {
                    break;
                }
            }
        }
        for (var i=0; true; i++){
            aai = a[ai];
            bbi = b[bi];
            if (aai === undefined || bbi === undefined){
                break;
            }
            if (aai < bbi){
                ab[i] = aai;
                ais.push(ai);
                bis.push([bi-1, bi, (aai-b[bi-1])/(bbi-b[bi-1])]);
                ai++;
            } else if (aai > bbi) {
                ab[i] = bbi;
                ais.push([ai-1, ai, (bbi-a[ai-1])/(aai-a[ai-1])]);
                bis.push(bi);
                bi++;
            } else {
                ab[i] = aai;
                ais.push(ai);
                bis.push(bi);
                bi++;
                ai++;
            }
        }
        return {ab:ab, ais:ais, bis:bis};
    }

    function interpolated(a, indices){
        var ilen = indices.length;
        var iarr = new Array(ilen);
        var i=-1, iis, i0, i1, s;
        while (++i <ilen) {
            iis = indices[i];
            if (typeof iis === "number"){
                iarr[i] = a[iis];
            } else {
                i0 = iis[0];
                i1 = iis[1];
                s = iis[2];
                iarr[i] = a[i0] + (a[i1] - a[i0]) * s;
            }
        }
        return iarr;
    }


    /*
     Number with units
     */

    function Num(mag, units){
        this.mag = mag;
        this.units = units;
    }
    Num.prototype._type = 'Num';
    Num.prototype.mul = function(o, u){
        var other = PQ(o, u);
        if (other._type === 'Num'){
            var unitsproduct = get_unitsproduct(this.units, other.units);
            return new Num(this.mag * other.mag * unitsproduct.scalar, unitsproduct.units());
        } else {
            return other.mul(this);
        }
    };

    Num.prototype.div = function(o, u){
        var other = PQ(o, u);
        var unitsdivide = get_unitsdivide(this.units, other.units);
        if (other._type === "Num"){
            return new Num(this.mag / other.mag * unitsdivide.scalar, unitsdivide.units());
        } else {
            throw "division not implemented"
        }
    };

    Num.prototype.plus = function(o, u){
        var other = PQ(o, u);
        var otherscale = get_unitsconversionfactor(other.units, this.units);
        if (other._type === 'Num'){
            return new Num(this.mag + other.mag * otherscale, this.units);
        } else {
            return other.plus(this);
        }
    };

    Num.prototype.minus = function(o, u){
        return this.plus(PQ(o, u).mul(-1));
    };

    Num.prototype.inUnitsOf = function(newunits){
        return new Num(this.mag * get_unitsconversionfactor(this.units, newunits), newunits);
    };
    /*
     Array with units
     */

    function Arr(mag, units){
        this.mag = mag;
        this.units = units;
    }
    Arr.prototype._type = 'Arr';
    Arr.prototype.mul = function(o, u){
        var other = PQ(o, u);
        var mag = new Array(this.mag.length);
        var i, unitsproduct;
        if(other._type === "Arr"){
            if (this.mag.length !== other.mag.length) {
                throw "array length do not match";
            }
            unitsproduct = get_unitsproduct(this.units, other.units);
            for (i = 0; i < this.mag.length; i++){
                mag[i] = this.mag[i] * other.mag[i] * unitsproduct.scalar;
            }
            return new Arr(mag, unitsproduct.units());
        } else if(other._type === "Num"){
            unitsproduct = get_unitsproduct(this.units, other.units);
            for (i = 0; i < this.mag.length; i++){
                mag[i] = this.mag[i] * other.mag * unitsproduct.scalar;
            }
            return new Arr(mag, unitsproduct.units());
        } else {
            return other.mul(this);
        }
    };
    Arr.prototype.div = function(o, u){

    };
    Arr.prototype.plus = function(o, u){
        var other = PQ(o, u);
        var otherscale = get_unitsconversionfactor(other.units, this.units);
        var mag = new Array(this.mag.length);
        var i;
        if(other._type === "Arr"){
            if (this.mag.length !== other.mag.length) {
                throw "array length do not match";
            }
            for (i = 0; i < this.mag.length; i++){
                mag[i] = this.mag[i] + other.mag[i] * otherscale;
            }
            return new Arr(mag, this.units);
        } else if(other._type === "Num"){
            for (i=0; i<this.mag.length; i++){
                mag[i] = this.mag[i] + other.mag * otherscale;
            }
            return new Arr(mag, this.units);
        } else {
            return other.plus(this);
        }
    };
    Arr.prototype.equalsto = function(o, u){
        var other = PQ(o, u);
        if(other._type !== "Arr"){
            return false;
        }
        if (this.units !== other.units){
            return false;
        }
        if (this.mag.length !== other.mag.length) {
            return false;
        }
        for (var i= 0; i<this.mag.length; i++){
            if (this.mag[i] !== other.mag[i]) {
                return false;
            }
        }
        return true;
    };

    Arr.prototype.interpolated = function(indices){
        return new Arr(interpolated(this.mag, (indices)), this.units);
    };

    Arr.prototype.max = function(){
        return PQ(Math.max.apply(null, this.mag), this.units);
    };

    Arr.prototype.min = function(){
        return PQ(Math.min.apply(null, this.mag), this.units);
    };

    Arr.prototype.extent = function(){
        return PQ([Math.min.apply(null, this.mag), Math.max.apply(null, this.mag)], this.units);
    };

    Arr.prototype.get = function(idx){
        return PQ(this.mag[idx], this.units);
    };
    /*
     Table of numbers with unique units
     */

    function TabNum(mag, units){
        this.mag = mag;
        this.units = units;
    }
    TabNum.prototype._type = 'TabNum';

    TabNum.prototype.get = function(key){
        return PQ(this.mag[key], this.units);
    };

    TabNum.prototype.mul = function(o, u){
        var other = PQ(o, u);
        var mag = {};
        var returntype, key, thisnumber, othernumber, otherarraylength, magarr, i;
        var unitsproduct = get_unitsproduct(this.units, other.units);
        if (other._type === "TabArr"){
            returntype = TabArr;
            for (key in this.mag){
                if (this.mag.hasOwnProperty(key)){
                    thisnumber = this.mag[key];
                    otherarray = other.mag[key];
                    if (otherarray !== undefined){
                        otherarraylength = otherarray.length;
                        magarr = new Array(otherarraylength);
                        for (i = 0; i < otherarraylength; i++){
                            magarr[i] = otherarray[i] * thisnumber * unitsproduct.scalar;
                        }
                        mag[key] = magarr;
                    }
                }
            }
        } else if (other._type === "TabNum"){
            returntype = TabNum;
            for (key in this.mag){
                if (this.mag.hasOwnProperty(key)){
                    thisnumber = this.mag[key];
                    othernumber = other.mag[key];
                    if (othernumber !== undefined){
                        mag[key] = thisnumber * othernumber * unitsproduct.scalar;
                    }
                }
            }
        } else if (other._type === "Arr"){
            returntype = TabArr;
            for (key in this.mag){
                if (this.mag.hasOwnProperty(key)){
                    thisnumber = this.mag[key];
                    var otherarray = other.mag;
                    otherarraylength = otherarray.length;
                    magarr = new Array(otherarraylength);
                    for (i = 0; i < otherarraylength; i++){
                        magarr[i] = otherarray[i] * thisnumber * unitsproduct.scalar;
                    }
                    mag[key] = magarr;
                }
            }
        } else if (other._type === "Num"){
            returntype = TabNum;
            othernumber = other.mag;
            for (key in this.mag){
                if (this.mag.hasOwnProperty(key)){
                    mag[key] = this.mag[key] * othernumber * unitsproduct.scalar;
                }
            }
        }
        return new returntype(mag, unitsproduct.units());
    };
    TabNum.prototype.plus = function (o, u) {
        var other = PQ(o, u);
        var mag = {},
            key;
        var otherscale = get_unitsconversionfactor(other.units, this.units);
        if (other._type === "TabNum") {
            var allkeys = get_allkeys(this.mag, other.mag);
            for (var i = 0; i < allkeys.length; i++) {
                key = allkeys[i];
                var thisnumber = this.mag[key] || 0,
                    othernumber = other.mag[key] || 0;
                mag[key] = thisnumber + othernumber * otherscale;
            }
            return new TabNum(mag, this.units);
        }
        throw "not implemented: Tablenumber.plus(" + other._type + ")";
    };

    TabNum.prototype.topkeys = function(fraction){
        var key, i, threshold,
            thismag = this.mag,
            topkeys = [],
            listof_val_key = [];
        for(key in thismag){
            if (thismag.hasOwnProperty(key)){
                listof_val_key.push([thismag[key], key]);
            }
        }
        listof_val_key.sort(function(a,b){return a[0]-b[0];});
        i = listof_val_key.length - 1;
        threshold = listof_val_key[i][0] * fraction;
        for( ; i >= 0; i--){
            if(listof_val_key[i][0] >= threshold){
                topkeys.push(listof_val_key[i][1]);
            }
        }
        return topkeys;
    };

    TabNum.prototype.inUnitsOf = function(newunits){
        var factor = get_unitsconversionfactor(this.units, newunits),
            key,
            key_newmag = {};
        for (key in this.mag){
            if (this.mag.hasOwnProperty(key)){
                key_newmag[key] = this.mag[key] * factor;
            }
        }
        return new TabNum(key_newmag , newunits);
    };
    /*
     Table of arrays with unique units
     */

    function TabArr(mag, units){
        this.mag = mag;
        this.units = units;
    }
    TabArr.prototype._type = 'TabArr';

    TabArr.prototype.get = function(key){
        return PQ(this.mag[key], this.units);
    };

    TabArr.prototype.plus = function(o, u){
        var other = PQ(o, u);
        var mag = {},
            key, keys,
            i, ki,
            thisarray,
            otherarray,
            thisarraylength,
            otherarraylength,
            magarr,
            thismag = this.mag,
            othermag = other.mag;
        var otherscale = get_unitsconversionfactor(other.units, this.units);
        if(other._type === 'TabArr'){
            keys = get_allkeys(thismag, othermag);
            for (ki=0; ki < keys.length; ki++){
                key = keys[ki];
                thisarray = this.mag[key];
                otherarray = other.mag[key];
                if (thisarray && otherarray){
                    thisarraylength = thisarray.length;
                    magarr = new Array(thisarraylength);
                    otherarraylength = otherarray.length;
                    thisarraylength = thisarray.length;
                    if (thisarraylength !== otherarraylength) {
                        throw "length of arrays is not identical";
                    }
                    for (i=0; i<thisarraylength; i++){
                        magarr[i] = thisarray[i] + otherscale * otherarray[i];
                    }
                } else if (thisarray){
                    magarr = thisarray.slice();
                } else {
                    otherarraylength = otherarray.length;
                    magarr = new Array(otherarraylength);
                    for (i=0; i<otherarraylength; i++){
                        magarr[i] = otherscale * otherarray[i];
                    }
                }
                mag[key] = magarr;
            }
        } else {
            throw 'not implemented TabArr.plus("'+other._type+'")';
        }
        return PQ(mag, this.units);
    };
    TabArr.prototype.mul = function(o, u){
        var other = PQ(o, u);
        var mag = {}, i, key, thisarray, magarr, otherarray, thisarraylength, othernumber;
        var unitsproduct = get_unitsproduct(this.units, other.units);
        if (other._type === "TabArr"){
            for (key in this.mag){
                if (this.mag.hasOwnProperty(key)){
                    thisarray = this.mag[key];
                    otherarray = other.mag[key];
                    if (otherarray){
                        thisarraylength = thisarray.length;
                        if (thisarraylength !== otherarray.length) {
                            throw "length of arrays is not identical";
                        }
                        magarr = new Array(thisarraylength);
                        for (i=0; i<thisarraylength; i++){
                            magarr[i] = thisarray[i] * otherarray[i] * unitsproduct.scalar;
                        }
                        mag[key] = magarr;
                    }
                }
            }
        } else if (other._type === "TabNum"){
            for (key in this.mag){
                if (this.mag.hasOwnProperty(key)){
                    thisarray = this.mag[key];
                    othernumber = other.mag[key];
                    if (othernumber!==undefined){
                        thisarraylength = thisarray.length;
                        magarr = new Array(thisarraylength);
                        for (i=0; i<thisarraylength; i++){
                            magarr[i] = thisarray[i] * othernumber * unitsproduct.scalar;
                        }
                        mag[key] = magarr;
                    } else {
                        throw 'other["'+key+'"] undefined';
                    }
                }
            }
        } else if (other._type  === "Arr"){
            otherarray = other.mag;
            for (key in this.mag){
                if (this.mag.hasOwnProperty(key)){
                    thisarray = this.mag[key];
                    thisarraylength = thisarray.length;
                    if (thisarraylength !== otherarray.length) {
                        throw "length of arrays is not identical";
                    }
                    magarr = new Array(thisarraylength);
                    for (i=0; i<thisarraylength; i++){
                        magarr[i] = thisarray[i] * otherarray[i] * unitsproduct.scalar;
                    }
                    mag[key] = magarr;
                }
            }
        } else if (other._type === "Num"){
            othernumber = other.mag;
            for (key in this.mag){
                if (this.mag.hasOwnProperty(key)){
                    thisarray = this.mag[key];
                    magarr = new Array(thisarray.length);
                    for (i=0; i<thisarray.length; i++){
                        magarr[i] = thisarray[i] * othernumber * unitsproduct.scalar;
                    }
                    mag[key] = magarr;
                }
            }
        }
        return new TabArr(mag, unitsproduct.units());
    };

    TabArr.prototype.interpolated = function(indices){
        var key;
        var newmag = {},
            thismag = this.mag;
        for (key in thismag){
            if (thismag.hasOwnProperty(key)){
                newmag[key] = interpolated(thismag[key], indices);
            }
        }
        return new TabArr(newmag, this.units);
    };

    TabArr.prototype.total = function(){
        var i, key, thislength, arr, total;
        for (key in this.mag){
            if (this.mag.hasOwnProperty(key)){
                thislength = this.mag[key].length;
                total = zeros(thislength);
                break;
            }
        }
        if (thislength){
            for (key in this.mag){
                if (this.mag.hasOwnProperty(key)){
                    arr = this.mag[key];
                    for(i=0; i<thislength; ++i){
                        total[i] += arr[i];
                    }
                }
            }
            return PQ(total, this.units);
        } else {
            throw 'Arr has zero length';
        }
    };

    TabArr.prototype.max = function(){
        var key,
            maxval = -Infinity;
        for (key in this.mag){
            if (this.mag.hasOwnProperty(key)){
                maxval = Math.max(maxval,  Math.max.apply(null, this.mag[key]));
            }
        }
        return PQ(maxval, this.units);
    };

    TabArr.prototype.min = function(){
        var key,
            minval = Infinity;
        for (key in this.mag){
            if (this.mag.hasOwnProperty(key)){
                minval = Math.min(minval,  Math.min.apply(null, this.mag[key]));
            }
        }
        return PQ(minval, this.units);
    };

    TabArr.prototype.extent = function(){
        var key,
            minval = Infinity,
            maxval = -Infinity;
        for (key in this.mag){
            if (this.mag.hasOwnProperty(key)){
                minval = Math.min(minval,  Math.min.apply(null, this.mag[key]));
                maxval = Math.max(maxval,  Math.max.apply(null, this.mag[key]));
            }
        }
        return PQ([minval, maxval], this.units);
    };

    // returns a TabNum object with maximum values
    TabArr.prototype.maxTab = function(){
        var key,
            key_max = {};
        for (key in this.mag){
            if (this.mag.hasOwnProperty(key)){
                key_max[key] = Math.max.apply(null, this.mag[key]);
            }
        }
        return PQ(key_max, this.units);
    };


    TabArr.prototype.minTab = function(){
        var key,
            minima = {};
        for (key in this.mag){
            if (this.mag.hasOwnProperty(key)){
                minima[key] = Math.min.apply(null, this.mag[key]);
            }
        }
        return PQ(minima, this.units);
    };

    TabArr.prototype.topkeys_count = function(fraction){
        var thismag = this.mag,
            arrlength,
            i, j,key, val, key_val, topkeys, topkey,
            topkeys_count = {};
        for(key in thismag){
            if(thismag.hasOwnProperty(key)){
                arrlength = thismag[key].length;
                break;
            }
        }
        for(i=0; i < arrlength; ++i){
            key_val = {};
            for(key in thismag){
                if(thismag.hasOwnProperty(key)){
                    val = thismag[key][i];
                    key_val[key] = val;
                }
            }
            topkeys = PQ(key_val).topkeys(fraction);
            for (j=0; j< topkeys.length; ++j) {
                topkey = topkeys[j];
                if(topkeys_count[topkey] === undefined){
                    topkeys_count[topkey] = 1;
                } else {
                    topkeys_count[topkey]++;
                }
            }
        }
        return topkeys_count;
    };

    /*
     An object with x and y data (i.e. a time series)
$    */

    function XY(x, y){
        this.x = x;
        this.y = y;
    }
    XY.prototype._type = 'XY';
    XY.prototype.mul = function(o, u){
        var other = PQ(o, u);
        var newy;
        if (other._type !== 'XY'){
            newy = this.y.mul(other);
            return new XY(this.x, newy);
        } else {
            if ((this.x._type !== other.x._type) && (this.y._type !== other.y._type)){
                throw 'incompatible x and y during XY.plus(XY) detected';
            }
            if (!this.x.equalsto(other.x)){
                var inter = get_interpolations(this.x.mag, other.x.mag);
                return this.interpolated(inter.ab, inter.ais).mul(other.interpolated(inter.ab, inter.bis));
            }
            newy = this.y.mul(other.y);
            return new XY(this.x, newy);
        }
    };
    XY.prototype.plus = function(o, u){
        var other = PQ(o, u);
        var newy;
        if (other._type === 'XY'){
            if ((this.x._type !== other.x._type) && (this.y._type !== other.y._type)){
                throw 'incompatible x and y during XY.plus(XY) detected';
            }
            if (!this.x.equalsto(other.x)){
                var inter = get_interpolations(this.x.mag, other.x.mag);
                return this.interpolated(inter.ab, inter.ais).plus(other.interpolated(inter.ab, inter.bis));
            }
            newy = this.y.plus(other.y);
            return new XY(this.x, newy);
        } else if (other._type === 'Num') {
            var newx = this.x.plus(other);
            return new XY(newx, this.y);
        }
        throw 'not implemented XY.plus("'+other._type+'")';
    };
    XY.prototype.minus = function(o, u){
        return this.plus(PQ(o, u).mul(-1));
    };

    XY.prototype.interpolated = function(newxmag, indices){
        return new XY(PQ(newxmag, this.x.units), PQ(this.y.interpolated(indices), this.y.units));
    };

    XY.prototype.total = function(){
        return PQ({x:this.x, y:this.y.total()});
    };

    XY.prototype.slice = function(opts){
        var gr, gidx, lo, lidx, i, lastelement,
            thisxunits = this.x.units,
            thisxmag = this.x.mag,
            thisxlength = this.x.mag.length,
            newxmag = [];
        if(opts.gt && opts.ge){
            throw 'argument ge and gt may not be used at the same time';
        }
        if(opts.lt && opts.le){
            throw 'argument le and lt may not be used at the same time';
        }
        // greater or greater than
        if(opts.gt !== undefined){
            gr = opts.gt.inUnitsOf(thisxunits).mag;
            gidx = thisxmag.bisect(gr);
            if(gr >= thisxmag[thisxlength-1]){
                throw 'gt is larger than last array element';
            }
        } else if (opts.ge !== undefined) {
            gr = opts.ge.inUnitsOf(thisxunits).mag;
            gidx = thisxmag.bisect(gr);
            if(gr > thisxmag[thisxlength-1]){
                throw 'ge is larger than last array element';
            }
            if(gr!==thisxmag[gidx]){
                newxmag.push(gr);
            }
        } else {
            gidx = 0;
        }
        // lower or lower than
        if (opts.lt !== undefined){
            lo = opts.lt.inUnitsOf(thisxunits).mag;
            lidx = thisxmag.bisect(lo)-1;
            if(lo === thisxmag[lidx]){
                lidx--;
            }
            if(lidx < 0){
                throw 'lt is smaller than first array element';
            }
        } else if (opts.le !== undefined){
            lo = opts.le.inUnitsOf(thisxunits).mag;
            lidx = thisxmag.bisect(lo)-1;
            if(lidx <= 0){
                throw 'le is smaller than first array element';
            }
            if(lo !== thisxmag[lidx]){
                lastelement = lo;
            }
        } else {
            lidx = thisxlength-1;
        }
        if(lo !== undefined && gr !== undefined && lo < gr){
            throw 'lower bound greater than upper bound';
        }
        for (i=gidx; i<=lidx; ++i){
            newxmag.push(thisxmag[i]);
        }
        if(lastelement !== undefined){
            newxmag.push(lastelement);
        }
        //console.log(newxmag);
        var inter = get_interpolations(thisxmag, newxmag);
        return this.interpolated(inter.ab, inter.ais);
    };
    // returns a list of [maxkey, startindex] items
    XY.prototype.supports = function(){
        var thisymag = this.y.mag,
            thisxlength = this.x.mag.length,
            i, key, maxkey, val, maxval, lastmaxkey,
            supports = [];
        for(i=0; i < thisxlength; ++i){
            maxval = -Infinity;
            for(key in thisymag){
                if(thisymag.hasOwnProperty(key)){
                    val = thisymag[key][i];
                    if(val > maxval){
                        maxval = val;
                        maxkey = key;
                    }
                }
            }
            if(lastmaxkey !== maxkey){
                supports.push([maxkey, i]);
                lastmaxkey = maxkey;
            }
        }
        return supports;
    };

    XY.prototype.topkeys_count = function(fraction){
        var thisymag = this.y.mag,
            thisxlength = this.x.mag.length,
            i, key, val, key_val, topkeys, topkey,
            topkeys_count = {};
        for(i=0; i < thisxlength; ++i){
            key_val = {};
            for(key in thisymag){
                if(thisymag.hasOwnProperty(key)){
                    val = thisymag[key][i];
                    key_val[key] = val;
                }
            }
            topkeys = PQ(key_val).topkeys(fraction);
            for (i=0; i< topkeys.length; ++i) {
                topkey = topkeys[i];
                if(topkeys_count[topkey] === undefined){
                    topkeys_count[topkey] = 1;
                } else {
                    topkeys_count[topkey]++;
                }
            }
        }
        return topkeys_count;
    };
     /*
       Convenience function returning a Num-, Arr-, TabNum-, TabArr- or XY-object
    */
    function PQ(v, units) {
        if (v._type !== undefined) {
            return v;
        }
        var tod = typeof v;
        units = units || "";
        if (tod === "number"){
            return new Num(v, units);
        } else if (tod === "string"){
            return data[v];
            //throw "first argument of PQ may not be a string: " + v;
        } else if (v.length) {
            return new Arr(v, units);
        } else if (tod === "object"){
            if ((v.x !== undefined) && (v.y !== undefined)){
                return new XY(PQ(v.x), PQ(v.y));
            }
            for (var key in v) {
                if (v.hasOwnProperty(key)){
                    tod = typeof v[key];
                    if (tod === 'number') {
                        return new TabNum(v, units);
                    } else if (v[key].length !== undefined){
                        return new TabArr(v, units);
                    }
                    throw "cannot create PQ from: "+v;
                }
            }
        } else {
            throw "first argument of PQ is neither a number nor an array: " + v;
        }
    }
    function plus(v, units) {
        return PQ(v, units);
    }
    function minus(v, units) {
        return PQ(v, units).mul(-1);
    }
    /*

     */
    var parser = (function (){
        function get_expr(arg){
            if (arg.children !== undefined) {
                return arg;
            } else {
                return new Expr(arg);
            }
        }
        function Expr(arg){
            this.children = {};
            this.txt = undefined;
            if (typeof arg === 'string'){
                this.children[arg] = NOTLOADED;
            }
        }
        Expr.prototype.get_names = function(){
            var names = [],
                children = this.children;
            for (var name in children){
                if (children.hasOwnProperty(name)){
                    names.push(name);
                }
            }
            return names;
        };
        var _f = function(arg){
            var expr = get_expr(arg),
                children = expr.children;
            for (var name in children){
                if (children.hasOwnProperty(name)){
                    this.children[name] = children[name];
                }
            }
            return this;
        };
        Expr.prototype.plus = _f;
        Expr.prototype.mul = _f;
        Expr.prototype.minus = _f;
        Expr.prototype.slice = function(){return this;};
        return get_expr;
    })();

    function get_expr(txt){
        var PQ = parser, plus = parser, minus = parser;
        var expr;
        try {
            expr = eval(txt);
            expr.txt = txt;
        } catch(e){
            console.log(e);
            console.log(txt);
        }
        return expr;
    }

    var data = {};
    var name_expr = {};
    var name_formula = {};
    var abbr_descr = {};

    function clear(){
        var prop;
        for (prop in data) {
            if (data.hasOwnProperty(prop)) {
                delete data[prop];
            }
        }
        for (prop in name_expr) {
            if (name_expr.hasOwnProperty(prop)) {
                delete name_expr[prop];
            }
        }
    }

    function define(name_txt){
        var name, txt;
        for (name in name_txt){
            if (name_txt.hasOwnProperty(name)){
                txt = name_txt[name];
                name_formula[name] = txt;
                name_expr[name] = get_expr(txt);
            }
        }
    }

    function search(name, tree){
        try {
            var children = name_expr[name].children;
            tree.node[name] = 1;
            for (var childname in children){
                if (children.hasOwnProperty(childname)){
                    search(childname, tree);
                }
            }
        } catch(e) {
            tree.leave[name] = 1;
        }
    }

    function leaves(name){
        var tree = {'node': {}, 'leave': {}};
        search(name, tree);
        return d3.keys(tree.leave);
    }

    function getformula(name){
        var x,
            formula
            ;
        if (!name_expr[name]) {
            return '"' + name + '"';
        }
        formula = name_formula[name];
        if (name_expr[name].children){
            for (x in name_expr[name].children){
                if (name_expr[name].children.hasOwnProperty(x)){
                    formula = formula.replace('"'+x+'"', getformula(x));
                }
            }
        }
        return formula;
    }

    function searchmissingdata(name, tree){
        if (data[name] === undefined ) {
            try {
                var children = name_expr[name].children;
                tree.node[name] = 1;
                for (var childname in children){
                    if (children.hasOwnProperty(childname)){
                        searchmissingdata(childname, tree);
                    }
                }
            } catch(e) {
                tree.leave[name] = 1;
            }
        }
    }

    var LOADED = 1,
        NOTLOADED = 0;

    /*
    once loaded, for each name there exists an entry in dm.name
     */

    function load(names, success, failed){
        names = (typeof names === "string")? [names]: names;
        var i,
            name,
            leaveuris = [],
            leavenames = [],
            treeleave = {},
            treenode = {},
            tree = {'node': treenode, 'leave': treeleave};

        // get tree with unloaded nodes and leaves
        for (i=0; i< names.length; ++i){
            name = names[i];
            if (data[name] === undefined){
                searchmissingdata(name, tree);
            }
        }
        // first we load all leaves
        for (name in treeleave){
            if (treeleave.hasOwnProperty(name)){
                leavenames.push(name);
                if(data[name] === undefined){
                    leaveuris.push(dm.dirname + name + '.js');
                }
            }
        }
        // load all leaves and calculate expressions
        loadScripts(leaveuris, function(ok, faileduris){
            //console.log(leaveuris)
            if (!ok) {
                failed && failed(faileduris);
                //window.alert("failed to load: " + faileduris.join(", "));
            } else {
                calculate(leavenames);
            }
        });

        function calculate(availablenames){
            var i,
                name,
                childname,
                children,
                availablename,
                allchildrenloaded,
                newavailablenames;

            var PQ = dm.PQ;

            do {
                newavailablenames = [];
                for (name in treenode){
                    if (treenode.hasOwnProperty(name)){
                        children = name_expr[name].children;
                        for (i=0; i<availablenames.length; ++i){
                            availablename = availablenames[i];
                            if (children[availablename] !== undefined){
                                children[availablename] = LOADED;
                            }
                        }
                        allchildrenloaded = true;
                        for (childname in children){
                            if (children.hasOwnProperty(childname)){
                                if(data[childname] === undefined){
                                    if (children[childname] === NOTLOADED){
                                        allchildrenloaded = false;
                                        break;
                                    }
                                }
                            }
                        }
                        if (allchildrenloaded && !data[name]){
                            //console.log(name);
                            data[name] = eval(name_expr[name].txt);
                            //data[name].name = name;
                            try{
                            } catch(e) {
                                console.log(e);
                                console.log("failed: "+ name+ " = " + name_expr[name].txt);
                            }
                            if (names.indexOf(name) == -1){
                                newavailablenames.push(name);
                            }
                        }
                    }
                }
                availablenames = newavailablenames;
            } while (availablenames.length);
            success && success();
        }
    }

    function loadandname(names, success, failed){
        function nameandsuccess(){
            var i, name, notloadednames = names, stillnotloadednames;
            do {
                stillnotloadednames = [];
                for(i=0; i < notloadednames.length; ++i){
                    //console.log(names.length, i, names[i], data[names[i]]);
                    name = notloadednames[i];
                    if (data[name] === undefined){
                        stillnotloadednames.push(name)
                    } else {
                        data[name].name = name;
                    }
                }
                notloadednames = stillnotloadednames;
                console.log("notloadednames", notloadednames);
           } while (1===2);//(notloadednames.length > 0);
            success && success();
        }
        load(names, nameandsuccess, failed);
    }
    /*
     finished is a function(ok, faileduris)
     */
    function loadScripts(uris, finished) {
        var numberofuris = uris.length,
            faileduris = [],
            processed = 0,
            ok=true,
            head = document.head || document.getElementsByTagName('head')[0];
        /*
         On IE9, script.onerror does not work, instead a window.onerror is fired.
         So we first save the original window.onerror and then define a new window.onerror
         function which is similar to the fail function below. Before calling the finished
         function the original window.onerror is restored.
         */
        var origwindowonerror = window.onerror;

        window.Xonerror = function(evt, src){
            console.log('window.onerror');
            console.log(evt, src);
            faileduris.push(src);
            ok = false;
            if (++processed === numberofuris) {
                window.onerror = origwindowonerror;
                finished(ok, faileduris);
            }
            return true;
        };
        /*  */
        function success(evt){
            //var y=this;
            //var e = window;
            //console.log('success', evt.srcElement);
            if (++processed === numberofuris) {
                window.onerror = origwindowonerror;
                finished(ok, faileduris);
            }
            return true;
        }
        function fail(e){
            console.log('fail');
            console.log(e);
            faileduris.push(this.src);
            head.removeChild(this);
            ok = false;
            if (++processed === numberofuris) {
                window.onerror = origwindowonerror;
                finished(ok, faileduris);
            }
            return true;
        }
        if (!uris.length) finished && finished(ok, faileduris);
        else{
            for (var i=0; i<uris.length; ++i){
                var script  = document.createElement('script');
                script.type = 'text/javascript';
                script.src = _baseuri+uris[i];
                if (finished) {
                    script.onload = success;
                    script.onreadystatechange = success; // For IE8-
                    script.onerror = fail;
                }
                head.appendChild(script);

            }
        }
    }

    function Finder(names, key_seen){
        var i, j, key, keys, name
            ;
        if (key_seen === undefined) key_seen = {};
        this.names = names;
        this.key_names = {};
        this.searchkeys = [];
        this.key_seen = key_seen;
        for (i = 0; i < names.length; ++i){
            name = names[i];
            keys = name.split("-");
            for (j = 0; j < keys.length; ++j){
                key = keys[j];
                if(key_seen[key] === undefined){
                    if (this.key_names[key] === undefined) {
                        this.key_names[key] = [name];
                        this.searchkeys.push(key);
                    } else {
                        this.key_names[key].push(name);
                    }
                }
            }
        }
    }
    Finder.prototype.filter = function(arg){
        var i, keys,
            f = this
            ;
        if (typeof arg === "string"){
            keys = [arg];
        } else {
            keys = arg;
        }
        for (i = 0; i < keys.length; ++i){
            f = f.filterone(keys[i]);
        }
        return f;
    };

    Finder.prototype.filterone = function(searchkey) {
        var key, key_seen = {};
        key_seen[searchkey] = 1;
        for(key in this.key_seen){
            if (this.key_seen.hasOwnProperty(key)){
                key_seen[key] = 1;
            }
        }
        return new Finder(this.key_names[searchkey], key_seen);
    };
    var _baseuri = '';

    dm = {
        /*
         Num: Num,
         Arr: Arr,
         TabNum: TabNum,
         TabArr: TabArr,
         XY: XY,
         parser: parser,
         */
        baseuri : function(){
            if (arguments.length === 0){
                return _baseuri;
            } else {
                _baseuri = arguments[0];
            }
        },
        name_expr: name_expr,
        PQ: PQ,
        plus: plus,
        minus: minus,
        data: data,
        dirname: '',
        leaves: leaves,
        formula: getformula,
        searchmissingdata: searchmissingdata,
        load: load,
        loadScripts: loadScripts,
        loadandname: loadandname,
        define: define,
        clear: clear,
        abbr_descr: abbr_descr,
        Finder: Finder
    };

})();




