/**
 * Created by mag on 13.10.13.
 */

var dm = dm || {},
    d3 = d3 || {};

(function(d3, dm){
    "use strict";
    function DragDrop(){
        var dragele,
            dropele,
            dragcontainer,
            dropelec,
            onchange = function(){},
            dnd = {}
            ;

        dnd.onchange = function(_){
            if (!arguments.length) {return onchange;}
            onchange = _;
            return dnd;
        };

        dnd.container = function(div, title, memberfloat){
            var borderbeforerwidth,
                borderafterwidth,
                direction,
                members;
            function showinsertposition(){
                if(d3.event[direction] > dropelec){
                    //console.log(direction, dropelec,' ', d3.event[direction], ' after');
                    dropele.style[borderafterwidth] = "10px";
                    dropele.style[borderbeforerwidth] = "2px";
                } else {
                    //console.log(direction, dropelec, ' ', d3.event[direction], ' before');
                    dropele.style[borderbeforerwidth] = "10px";
                    dropele.style[borderafterwidth] = "2px";
                }
            }
            div
                .datum({title: title})
                .on("dragover", function(){
                    d3.event.preventDefault();
                })
                .on("drop", function(){
                    d3.event.stopPropagation();
                    dragele.parentNode.removeChild(dragele);
                    if (this.children.length === 0){
                        d3.select(this).html(null);
                    }
                    this.insertBefore(dragele);
                    d3.select(dragele)
                        .style("float", memberfloat)
                        .style("opacity", 1);
                    onchange();
                })
            ;

            members = div.selectAll('div');
            if (members.empty()){
                div.text(function(d){return d.title;});
            }
            members
                .attr("draggable","true")
                .on("dragstart", function(){
                    dragele = this;
                    dragcontainer = dragele.parentNode;
                    dragele.style.opacity = 0.6;
                })
                .on("dragenter", function(){
                    var bb;
                        if(this === dragele){
                            return;
                        }
                    bb = this.getBoundingClientRect();
                    dropele = this;
                    //console.log("dropele", bb, dropele);
                    direction = dropele.style.float === 'left' ? 'x' : 'y';
                    borderbeforerwidth = "border"+{y:'Top', x:'Left'}[direction]+"Width";
                    borderafterwidth = "border"+{y:'Bottom', x:'Right'}[direction]+"Width";
                    dropelec = direction === 'x' ?  bb.left + bb.width/2 : bb.top + bb.height/2;
                })
                .on("dragover", function(){
                    d3.event.preventDefault();
                    if(this===dragele){
                        return;
                    }
                    showinsertposition();
                })
                .on("dragleave", function(){
                    this.style.borderWidth = "2px";
                })
                .on("drop", function(){
                    d3.event.stopPropagation();
                    dragele.parentNode.removeChild(dragele);
                    var beforeelement = d3.event[direction] > dropelec ? dropele.nextSibling : dropele;
                    dropele.parentNode.insertBefore(dragele, beforeelement);
                    dropele.style.borderWidth = "2px";
                    dragele.style.float = dropele.style.float;
                    dragele.style.opacity = 1.0;
                    onchange();
                })
                .on("dragend", function(){
                    if (dragcontainer.childNodes.length === 0) {
                        d3.select(dragcontainer).text(function(d){return d.title;});
                    }
                });
        };
        return dnd;
    }

    function LinkDragDrop(){
        // drag a link of an input file over an other opens a new tab showing the difference of the links
        var dragele, dropele,
            ondrop = function(){
                var q = '&path=' + d3.select(dropele).attr("href").split('=')[1]
                    ;
                window.open(dragele.href+q, '_viewer');
            };
        var select = function(sel){
            function set_diffinks(base){
                sel
                    .each(function(){
                        var mydropele = this;
                        var span = d3.select(this.parentNode).selectAll("span.showdiff")
                            .data(this !== dragele ? [null]: []);
                        span.enter()
                            .append("span")
                            .attr("class", "showdiff linkish")
                            .text(" diff")
                            .on("click", function(){
                                dropele = mydropele;
                                ondrop();
                            });
                        span.exit()
                            .remove()
                        ;
                    })                ;
            }
            sel
                .attr("draggable","true")
                //.on("mouseover", function(){
                //    d3.select(this).style("cursor", "move");
                //})
                .on("dragstart", function(){
                    dragele = this;
                })
                .on("dragenter", function(){
                    d3.event.preventDefault();
                    dropele = this;
                })
                .on("dragover", function(){
                    //alert('drop?');
                    d3.event.preventDefault();
                })
                .on("click", function(){
                    dragele = this;
                    set_diffinks(dragele);
                })
                .on("drop", function(){
                    ondrop();
                    d3.event.preventDefault();
                })
            ;

        };
        select.ondrop = function(_){
            if (!arguments.length) {return ondrop;}
            ondrop = _;
            return select;
        };
        return select;
    }
    dm.DragDrop = DragDrop;
    dm.LinkDragDrop = LinkDragDrop;
}(d3, dm));