/**
 * Created with PyCharm.
 * User: A404799
 * Date: 28.07.14
 * Time: 10:20
 * To change this template use File | Settings | File Templates.
 */

(function (root, factory) {
    'use strict';
    if (typeof root.define === 'function' && root.define.amd) {
        root.define([], factory);
    } else if (typeof root.exports === 'object') {
        root.module.exports = factory();
    } else {
        root.Legends = factory();
    }
} (this, function() {
    'use strict';

    function wordwrapfactory(width, cut) {
        width = width || 75;
        cut = cut || false;
        var regex = '.{1,' +width+ '}(\\s|$)' + (cut ? '|.{' +width+ '}|.+$' : '|\\S+?(\\s|$)');
        return function(str){
            if (!str) {return str;}
            return str.match(new RegExp(regex, 'g'));
        };
    }

    function Symbol(name){
        this.name = name;

    }

    function Legendrenderer(){
        var that = this;
        this._fontsize = 8;
        this._lineheightem = 1.2;
        this._verticalpaddingem = 1.2;
        this._symbolwidthem = 2;
        this._symbolhorizontalpaddingem = 0.5;
        this._limitnumberofcolumns = 2;
        this._numberofcolumns = 0;
        this._charwidthfactor = 0.5;
        this._symbolvericalalign = 'firstline';

        function Labelbox(labellines){
            this.labellines = labellines || [];
            this._width = Math.max.apply(null, (this.labellines.map(function(line){return line.length;}))) * that._fontsize * that._charwidthfactor;
        }

        Labelbox.prototype.width = function(){
            return this._width;
        };

        Labelbox.prototype.height = function(){
            return this.labellines.length * that._lineheightem;
        };

    }

    /*
    Legenditem =
    {
        symbol: {
            marker: {type: 'square', .., stroke: ...., fill: ..., every: .., },
            line: {stroke: '..', 'dash-array': '...', 'stroke-width': ..}
            }
        label: {text: '...',}
    }
    */


    Legendrenderer.prototype.items = function(items){
        if (!arguments.length) {
            return this.items;
        }
        this.items = items;
        return this;
    };

    Legendrenderer.prototype.render = function(el){

    };

    Legendrenderer.prototype.numberofcolumns = function(n){
        if (!arguments.length) {
            return this._numberofcolumns;
        }
        this._limitnumberofcolumns = n;
        return this;
    };

    Legendrenderer.prototype.fontsize = function(px){
        if (!arguments.length) {
            return this._fontsize;
        }
        this._fontsize = px;
        return this;
    };

    Legendrenderer.prototype.lineheight = function(em){
        if (!arguments.length) {
            return this._lineheightem;
        }
        this._lineheightem = em;
        return this;
    };

    Legendrenderer.prototype.symbolwidth = function(em){
        if (!arguments.length) {
            return this._symbolwidthem;
        }
        this._symbolwidthem = em;
        return this;
    };

    Legendrenderer.prototype.verticalpadding = function(em){
        if (!arguments.length) {
            return this._verticalpaddingem;
        }
        this._verticalpaddingem = em;
        return this;
    };

    Legendrenderer.prototype.symbolhorizontalpadding = function(em){
        if (!arguments.length) {
            return this._symbolhorizontalpaddingem;
        }
        this._symbolhorizontalpaddingem = em;
        return this;
    };

    Legendrenderer.prototype.charwidthfactor = function(_){
        if (!arguments.length) {
            return this._charwidthfactor;
        }
        this._charwidthfactor = _;
        return this;
    };

    Legendrenderer.prototype.symbolvericalalign = function(s){
        if (!arguments.length) {
            return this._symbolvericalalign;
        }
        this._symbolvericalalign = s;
        return this;
    };

    return {
        Legends: Legendrenderer
    };
}));

/*

totallegends = Legends().fontsize(32.5).numberofcolumns(2).objects().render(ele);

    */