/**
 * Created with PyCharm.
 * User: a404799
 * Date: 06.12.13
 * Time: 18:05
 * To change this template use File | Settings | File Templates.
 */

Object.defineProperty(HTMLSelectElement.prototype, "selectedOptions", {
    get: (function() {
        try {
            document.querySelector(":checked");
            return function() {
                return this.querySelectorAll(":checked");
            };
        } catch (e) {
            return function() {
                if (!this.multiple) {
                    return this.selectedIndex >= 0
                            ? [this.options[this.selectedIndex]] : [];
                }
                for (var i = 0, a = []; i < this.options.length; i++)
                    if (this.options[i].selected) a.push(this.options[i]);
                return a;
            };
        }
    })()
});



var dv = dv || {};

(function() {
    "use strict";
    var notdefinedcolor = 'white';
    function create_legend(legendele, scale, title, format){
        var rectsize = 20,
            fontsize = 11,
            x0 = 10,
            ytitle = 20,
            y0scale = ytitle + fontsize,
            domain = scale.domain(),
            shifty = domain.length === 1 ? 0.5 : 0
            ;

        var titleele = legendele.selectAll("text.title")
            .data([title || ""]);
        titleele
            .enter()
            .append("text")
            .attr("class", "title")
            .attr("x", x0)
            .attr("y", ytitle);
        titleele
            .text(function(d){return d;});

        var colorscale = legendele.selectAll("g.colorscale")
            .data(domain);

        colorscale
            .exit()
            .remove();

        colorscale
            .enter()
            .append("g")
            .attr("class", "colorscale")
            .call(function(){
                this
                    .append('rect')
                    .attr('width', rectsize)
                    .attr('height', rectsize)
                    .attr('x', x0)
                ;
                this
                    .append('text')
                    .attr('x', x0 + rectsize + fontsize/2);
            }
        );

        colorscale.select('rect')
            .attr('y', function(d, i){
                return i * rectsize + y0scale;
            })
            .attr('fill', function(d){
                return d === undefined ? notdefinedcolor :scale(d);
            })
        ;

        colorscale.select('text')
            .attr('y', function(d, i){
                return (i + shifty) * rectsize + y0scale + fontsize/2;
            })
            .text(function(d) {
                return d === undefined ? 'no value' : format(d);
            })
        ;
    }

    function sign(num){
        if (num > 0){
            return 1;
        } else if (num < 0){
            return -1;
        } else {
            return 0;
        }
    }

    function picnictd(p){
        var key,
            value,
            junc,
            ft,
            tf,
            ifacegeobiocounter = 0,
            j1_leg_j2 = {},
            SOURCE = p['SOURCE'],
            LEG = p['LEG'],
            _at = {},
            _jd = {};

        for (key in SOURCE){
            if (SOURCE.hasOwnProperty(key)){
                value = SOURCE[key];
                if (_at[key] === undefined) {
                    _at[value.AT] = [key];
                } else {
                    _at[value.AT].push(key);
                }
            }
        }
        this._at = _at;

        for (key in LEG){
            if (LEG.hasOwnProperty(key)){
                value = LEG[key];
                ft = [value.FROM, value.TO];
                ft.forEach(function(x, idx){
                    if (ft[idx] === "IfaceGeoBio") {
                        ft[idx] = 'IfaceGeoBio' + ifacegeobiocounter;
                        ifacegeobiocounter ++;
                    }
                });
                tf = [ft[1],ft[0]];
                [ft, tf].forEach(function(x){
                    if (j1_leg_j2[x[0]] === undefined) {
                        j1_leg_j2[x[0]] = {};
                    }
                    j1_leg_j2[x[0]][key] = x[1];
                });

                ['FROM', 'TO', 'MATRIX FROM', 'MATRIX TO'].forEach(function(leginterface){
                    junc = LEG[key][leginterface];
                    if (junc === undefined){
                        return;
                    }
                    if (_jd[junc] === undefined) {
                        _jd[junc] = {};
                    }
                    if (_jd[junc][leginterface] === undefined) {
                        _jd[junc][leginterface] = [];
                    }
                    _jd[junc][leginterface].push(key);
                })
            }
        }
        this.j1_leg_j2 = j1_leg_j2;
        this._jd = _jd;
        this.p = p;
        this.elements = d3.set(d3.map(p.DECAYS).keys().map(function(key){return (key.split(' ')[0]);})).values();
        this.elements.sort();
        this.calc_legproperties();


        this.legtabproperties = [
            {
                name: 'Name',
                shownobjects: 'legs',
                legpropertyname: 'name'
            },
            {
                name: 'Config.',
                shownobjects: 'legs',
                legpropertyname: 'config'
            },
            /*
            */
            {
                name: 'Length',
                units: 'm',
                shownobjects: 'legs',
                legpropertyname: 'length',
                scale: {
                    typ: "linear"
                }
            },
            {
                name: 'T*i',
                units: 'm2/s',
                shownobjects: 'legs',
                legpropertyname: 'ti',
                scale: {
                    typ: "linear"
                },
                format: d3.format("10.1e")
            },
            {
                name: 'Darcy-velocity',
                units: 'm/s',
                legpropertyname: 'darcyvelocity',
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                },
                format: d3.format("10.2e")
            },
            {
                name: 'CSA',
                units: 'm2',
                legpropertyname: 'csa',
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                },
                format: d3.format("11.2e")
            },
            {
                name: 'Flowrate',
                units: 'm3/a',
                shownobjects: 'legs',
                legpropertyname: 'flowrate',
                scale: {
                    typ: "linear"
                },
                format: d3.format("10.2e")
            },
            {
                name: 'Peclet number',
                units: '',
                legpropertyname: 'peclet',
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                },
                format: d3.format("10.2g")
            },
            {
                name: 'Effective Dispersion coefficient',
                units: 'm2/s',
                legpropertyname: 'effectivedispersion',
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                },
                format: d3.format("10.2e")
            },
            {
                name: 'Grain Density',
                units: 'kg/m3',
                legpropertyname: 'density',
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                },
                format: d3.format("f")
            },
            {
                name: 'Specific surface',
                units: 'm2/m3',
                legpropertyname: 'ssa',
                format: d3.format("6.1f"),
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                }
            },
            {
                name: 'Penetration depth',
                units: 'm',
                legpropertyname: 'pd',
                format: d3.format("0.2f"),
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                }
            },
            {
                name: 'Porosity',
                units: '',
                legpropertyname: 'porosity',
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                }
            },
            {
                name: 'Porosity Factor',
                units: '',
                legpropertyname: 'porosityfactor',
                details: this.elements,
                showselect: true,
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                }
            },
            {
                name: 'Effective diffusion',
                units: 'm2/s',
                legpropertyname: 'effectivediffusion',
                details: this.elements,
                format: d3.format("10.2e"),
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                }
            },
            {
                name: 'Kd',
                units: 'm3/kg',
                legpropertyname: 'kd',
                details: this.elements,
                shownobjects: 'legs',
                scale: {
                    typ: "linear"
                }
            }
            ];

        var properties = [];
        function get_valuegetter(ltp, detail){
            if (ltp.units !== undefined) {
                if (detail){
                    return function(leg){
                        var obj = {};
                        d3.map(leg[ltp.legpropertyname]).forEach(function(key, value){
                            obj[key] = value.get(detail).inUnitsOf(ltp.units).mag;
                        });
                        return obj;
                    }
                } else {
                    return function(leg){
                        var obj = {};
                        d3.map(leg[ltp.legpropertyname]).forEach(function(key, value){
                            obj[key] = value.inUnitsOf(ltp.units).mag;
                        });
                        return obj;
                    }
                }
            } else {
                return function(leg){
                    return leg[ltp.legpropertyname];
                };
            }
        }

        function get_namewithunits(ltp){
            if (ltp.units === undefined){
                return ltp.name;
            } else {
                return ltp.name + " [" + (ltp.units === '' ? "-" : ltp.units) + "]";
            }
        }

        this.legtabproperties.forEach(function(ltp){
            ltp.name = get_namewithunits(ltp);
            ltp.getvalues = get_valuegetter(ltp);
            if (ltp.scale){
                if (ltp.details) {
                    ltp.details.forEach(function(detail){
                        properties.push({
                            name: ltp.name + ' ' + detail,
                            shownobjects: 'legs',
                            scale: ltp.scale,
                            getvalues: get_valuegetter(ltp, detail),
                            format: ltp.format ? ltp.format : function(d){return d;}
                        });
                    })
                } else {
                    properties.push({
                        name: ltp.name,
                        shownobjects: 'legs',
                        scale: ltp.scale,
                        getvalues: ltp.getvalues,
                        format: ltp.format ? ltp.format : function(d){return d;}
                    });
                }
            }
        });
        this.properties = properties;


        var name_prop = this.name_prop = {};
        this.properties.forEach(function(prop){name_prop[prop.name] = prop;});
        //console.log(this.properties);
        //this.props = {legs: undefined, junctions: undefined};
        this.dispatch = d3.dispatch("selectvar");
    }

    picnictd.prototype.calc_legproperties = function(){
        var legname,
            leg,
            p = this.p,
            elements = this.elements,
            rocktype,
            flowblock,
            matrixblock
            ;

        function getTabNum(eledict, newunits){
            //console.log(eledict,newunits);
            var units,
                key_mag = {};
            if (eledict === undefined){
                //elements.forEach(function(ele){
                //    key_mag[ele] = '-';
                //});
                return dm.PQ({}, newunits);
            }
            units = eledict[d3.map(eledict).keys()[0]].units;
            if (units) {
                elements.forEach(function(ele){
                    if (eledict[ele] !== undefined) {
                        key_mag[ele] = eledict[ele].mag;
                    } else if (eledict[ele.split('-')[0]] !== undefined){
                        key_mag[ele] = eledict[ele.split('-')[0]].mag;
                    } else if (eledict.ALL !== undefined) {
                        key_mag[ele] = eledict.ALL.mag;
                    } else {
                        key_mag[ele] = '-';
                    }
                });
                return dm.PQ(key_mag, units).inUnitsOf(newunits);
            } else {
                elements.forEach(function(ele){
                    if (eledict[ele] !== undefined) {
                        key_mag[ele] = eledict[ele];
                    } else if (eledict[ele.split('-')[0]] !== undefined){
                        key_mag[ele] = eledict[ele.split('-')[0]];
                    } else if (eledict.ALL !== undefined) {
                        key_mag[ele] = eledict.ALL;
                    } else {
                        key_mag[ele] = '-';
                    }
                });
                return dm.PQ(key_mag);
            }
        }
        var set;
        for (legname in p.LEG){
            if (p.LEG.hasOwnProperty(legname)){
                leg = p.LEG[legname];
                leg.name = {general: legname};
                rocktype = p["ROCK-TYPE"][leg["ROCK-TYPE"]];
                flowblock = p["FLOW-BLOCK"][rocktype['FLOW-BLOCK']];
                if (["CYLINDRICAL", "PLANAR"].indexOf(rocktype["MATRIX-GEOMETRY"]) > -1){
                    matrixblock = p["MATRIX-BLOCK"][rocktype["MATRIX-BLOCK"]];
                    leg.fractured = true;
                    set = function(value) {return {fracture: value}};
                } else {
                    leg.fractured = false;
                    leg.config = {general: "HPM"};
                    set = function(value) {return {general: value, fracture: value}};
                }
                leg.csa = set(getNum(leg.CSA));
                leg.length = {general: getNum(leg.LENGTH)};
                leg.porosity = set(dm.PQ(rocktype["FLOW-POROSITY"]));
                if (leg['DARCY-VELOCITY'].y === undefined){
                    leg.darcyvelocity = set(getNum({mag: Math.abs(leg['DARCY-VELOCITY'].mag), units: leg['DARCY-VELOCITY'].units}));
                } else {
                    leg.darcyvelocity = set(getNum({mag: d3.max(leg['DARCY-VELOCITY'].y.mag), units: leg['DARCY-VELOCITY'].y.units}));
                }
                leg.peclet = set(dm.PQ(leg.PECLET));
                leg.flowrate = set(leg.darcyvelocity.fracture.mul(leg.csa.fracture));
                leg.flowrate.total = leg.flowrate.fracture;
                leg.effectivediffusion = set(getTabNum(leg['EFFECTIVE-DIFFUSION'], 'm2/s'));
                leg.effectivedispersion = set(leg.length.general.mul(leg.darcyvelocity.fracture).div(leg.peclet.fracture));
                if (leg.effectivedispersion.mag < 0){
                    leg.effectivedispersion.mag = -leg.effectivedispersion.mag;
                }
                leg.kd = set(getTabNum(flowblock['INFILL-KD'], 'm3/kg'));
                leg.density = set(flowblock['DRY-DENSITY'] ? getNum(flowblock['DRY-DENSITY']).div(leg.porosity.fracture): getNum(flowblock['INFILL-DENSITY']));
                leg.porosityfactor = set(flowblock['POROSITY-FACTOR'] ? getTabNum(flowblock['POROSITY-FACTOR']): getTabNum({'ALL': 1}));
                if (leg.fractured===true){
                    leg.porosity.matrix = dm.PQ(matrixblock["MATRIX-POROSITY"]);
                    leg.ssa = set(getNum(rocktype["SPECIFIC-SURFACE-AREA"]));
                    leg.pd = {matrix: getNum(rocktype["PENETRATION-DEPTH"])};
                    leg.effectivediffusion.matrix = getTabNum(matrixblock['EFFECTIVE-DIFFUSION'], 'm2/s');
                    leg.density.matrix = getNum(matrixblock['MATRIX-DENSITY']);
                    leg.porosityfactor.matrix = matrixblock['POROSITY-FACTOR'] ? getTabNum(matrixblock['POROSITY-FACTOR']): getTabNum({'ALL': 1});
                    leg.kd.matrix = getTabNum(matrixblock['MATRIX-KD'], 'm3/kg');
                    if (rocktype["MATRIX-GEOMETRY"] === "CYLINDRICAL"){
                        leg.config = {fracture: "Cylindrical frac.", matrix: 'Matrix', total:'Total'};
                        leg.radius = dm.PQ(2).div(leg.ssa.fracture.mul(leg.porosity.fracture));
                        leg.number = leg.csa.fracture.div(leg.radius.mul(leg.radius).mul(Math.PI));
                        leg.csa.matrix = (((leg.radius.plus(leg.pd.matrix)).mul(leg.radius.plus(leg.pd.matrix)))
                            .mul(leg.number).mul(Math.PI)).minus(leg.csa.fracture);
                    } else if (rocktype["MATRIX-GEOMETRY"] === "PLANAR"){
                        leg.config = {fracture: "Planar frac.", matrix: 'Matrix', total:'Total'};
                        leg.csa.matrix = leg.csa.fracture.mul(leg.porosity.fracture)
                            .mul(leg.ssa.fracture).mul(leg.pd.matrix);
                        leg.fractureaperture = dm.PQ(2).div(leg.ssa.fracture);
                        leg.ti = {fracture: leg.darcyvelocity.fracture.mul(leg.fractureaperture)};
                    }
                    leg.csa.total = leg.csa.matrix.plus(leg.csa.fracture);
                    if (leg['PARALLEL-DARCY-VELOCITY'] !== undefined) {
                        leg.darcyvelocity.matrix = getNum({mag: Math.abs(leg['PARALLEL-DARCY-VELOCITY'].mag), units: leg['PARALLEL-DARCY-VELOCITY'].units});

                        leg.peclet.matrix = dm.PQ(leg['PARALLEL-PECLET']);
                        leg.flowrate.matrix = leg.darcyvelocity.matrix.mul(leg.csa.matrix);
                        leg.flowrate.total = leg.flowrate.fracture.plus(leg.flowrate.matrix);
                        leg.effectivedispersion.matrix = leg.length.general.mul(leg.darcyvelocity.matrix).div(leg.peclet.matrix);
                    }
                    leg.darcyvelocity.total = leg.flowrate.total.div(leg.csa.total);
                }
                //console.log(leg);
            }
        }
    };

    function legtooltip(values, format){
        var txts = [];
        if (values.general !== undefined) {
            txts.push(format(values.general));
        } else {
            if (values.fracture !== undefined){
                txts.push("Fracture: " + format(values.fracture));
            }
            if (values.matrix !== undefined){
                txts.push("Matrix: " + format(values.matrix));
            }
            if (values.total !== undefined){
                txts.push("Total: " + format(values.total));
            }
        }
        if (txts.length === 0){
            return 'no value'
        } else {
            return txts.join('<br>');
        }
    }

    picnictd.prototype.setcoordinates = function(name_coords){
        var fromcoords,
            tocoords,
            junc,
            picnictdleg,
            leg,
            legname,
            coords_junc = {};

        for (legname in this.p.LEG) {
            if (this.p.LEG.hasOwnProperty(legname)) {
                //console.log(legname);
                picnictdleg = this.p.LEG[legname];
                fromcoords = name_coords[picnictdleg.FROM];
                tocoords = name_coords[picnictdleg.TO];
                picnictdleg.coords = {
                    FROM: fromcoords === undefined ? name_coords[legname].FROM : fromcoords,
                    TO: tocoords === undefined ? name_coords[legname].TO : tocoords
                };
                coords_junc[picnictdleg.coords.FROM.toString()] = {name: picnictdleg.FROM, coords: picnictdleg.coords.FROM};
                coords_junc[picnictdleg.coords.TO.toString()] = {name: picnictdleg.TO, coords: picnictdleg.coords.TO};
            }
        }
        this.junctions = d3.values(coords_junc);
        //this.junctions.sort(function(a,b) {return b.coords[1]- a.coords[1] || b.coords[0]- a.coords[0];});
        var xs = this.junctions.map(function(junc) {return junc.coords[0];});
        var ys = this.junctions.map(function(junc) {return junc.coords[1];});
        this.xextent = [d3.min(xs)-1, d3.max(xs)+1];
        this.yextent = [d3.min(ys)-1, d3.max(ys)+1];

    };


    var aw = 7;


    function getNum(obj){
        return dm.PQ(obj.mag, obj.units);
    }
    // render picnictd network and leg table
    picnictd.prototype.renderNetworkAndLegtable = function(ele, propname){
        var networkele = ele.append("div"),
            legtableele = ele.append("div");
        this.render(networkele, undefined, legtableele);
        this.render_legtable(legtableele,networkele);
    };

    // render picnictd network as svg graphic
    picnictd.prototype.render = function(ele, propname, legtableele){
        var junctions,
            key,
            legs,
            leggroups,
            leglength = 40,
            juncradius = 8,
            width = Math.max((this.xextent[1] - this.xextent[0])*leglength, 300),
            height = (this.yextent[1] - this.yextent[0])*leglength,
            left = 100,
            right = 100,
            top = 10,
            bottom = 10,
            xScale = d3.scale.linear()
                .domain(this.xextent)
                .range([left, left+width]),
            yScale = d3.scale.linear()
                .domain(this.yextent)
                .range([top + height, top]),
            div,
            svg,
            gcontent,
            legendg,
            tooltipdiv,
            selectinput,
            that = this;

        ele.selectAll("select")
            .data([null])
            .enter()
            .call(function(){
                selectinput = this
                    .append("div")
                    .append("select")
                    .on("change", function(){
                        that.render(ele, this.options[this.selectedIndex].value, legtableele);
                    });
                that.properties.forEach(function(prop){
                    selectinput.append("option")
                        .attr("value", prop.name)
                        .attr("title", prop.description)
                        .text(prop.name);
                });
                this
                    .append("svg")
                    .call(function(svg){
                        svg.append("g").
                            attr("class", "content");
                        svg.append("g")
                            .attr("class", "legend");
                    });
                this
                    .append("div")
                    .attr("class", "tooltip")
                    .style("position", "absolute");
            });
        selectinput = ele.selectAll("select");

        this.dispatch.on("selectvar.networkfigure", function(varname){
            selectinput.selectAll("option[value='" + varname + "']").property("selected", true);
            that.render(ele, varname, legtableele);
        });

        svg = ele.select("svg")
            .attr("width", width+left+right)
            .attr("height", height+top+bottom);
        tooltipdiv = ele.select("div.tooltip");
        gcontent = svg.select("g.content");
        legendg = svg.select("g.legend");

        propname = propname || this.properties[0].name;
        var shownobjects_property = {},
            property = this.name_prop[propname],
            scales = {},
            getvalues = {},
            focusobjects,
            data = {
                legs: this.p.LEG,
                junctions: this.p.junctions
            };

        if (property) {
            if (property.shownobjects === 'legs') {
                shownobjects_property.legs = property;
                //jr = junctionradius.mi;
                //aw = arrowwidth.ma;
            } else if (property.shownobjects === 'junctions') {
                shownobjects_property.junctions = focusobjects = property;
                //jr = junctionradius.ma;
                //aw = arrowwidth.mi;
            }
            focusobjects = property.shownobjects;
        }

        var allvalues;
        function extend(d){
            var values = d3.values(getvalues[key](d));
            values.forEach(function(val){allvalues.push(val);});
        }
        function identity(d){
            return d;
        }
        for (key in shownobjects_property) {
            if (shownobjects_property.hasOwnProperty(key)){
                property = shownobjects_property[key];
                getvalues[key] = property.getvalues;
                allvalues = [];
                d3.values(data[key]).forEach(extend);
                //console.log("allvalues", allvalues, d3.extent(allvalues));
                var extent = d3.extent(allvalues),
                    scl = d3.scale[property.scale.typ]()
                        .domain(extent),
                    myticks
                    ;
                if (property.scale.typ === 'log'){
                    myticks = scl.ticks().map(scl.tickFormat(6)).filter(identity).map(parseFloat);
                } else {
                    myticks = scl.nice(6).ticks();
                }
                //console.log(myticks)
                scales[key] = d3.scale.threshold()
                    .domain(myticks.length > 0 ? myticks : [extent[0]])
                    .range(["#f7fbff","#deebf7","#c6dbef","#9ecae1","#6baed6","#4292c6","#2171b5","#08519c","#08306b"]);
            }
        }

        create_legend(legendg, scales[focusobjects], propname, property.format);

        function installtooltip(ele, gethtml){
            ele
                .on("mouseover", function(d) {
                    var mousexy = d3.mouse(this);
                    tooltipdiv
                        .html(gethtml(d))
                        .transition()
                        .duration(200)
                        .style("opacity", 0.9)
                        .style("left", (mousexy[0] + 10) + "px")
                        .style("top", (mousexy[1] - 5) + "px");
                    legtableele && legtableele.selectAll("tbody."+ d.name.general).style({border: "2px solid orangered"});
                })
                .on("mouseout", function(d) {
                    tooltipdiv.transition()
                        .duration(500)
                        .style("opacity", 0);
                    legtableele && legtableele.selectAll("tbody."+ d.name.general).style({border: null});
                });
        }

        junctions = gcontent.selectAll("circle.junction")
            .data(this.junctions);
        junctions
            .enter()
            .append("g")
            .call(function(g){
                g
                    .append("circle")
                    .attr("class", "junction")
                    .attr("r", juncradius)
                    .style("stroke", "black")
                    .style("fill", "white");
                g
                    .append("text")
                    .attr('dx', '0.7em')
                    .attr('dy', '1.4em')
                ;

            })
            .call(installtooltip, function(d){
                return d.name+"<br><em>"
            })
            ;
        junctions.selectAll("circle")
            .each(function(d){
                var fill = 'white';
                if (that._at[d.name]) {
                    fill = 'red';
                } else if ('IfaceGeoBio VS CS RM'.indexOf(d.name) > -1) {
                    fill = 'lightgreen';
                }
                d3.select(this)
                    .style("fill", fill)
                    .attr("cx", xScale(d.coords[0]))
                    .attr("cy", yScale(d.coords[1]))
                ;
            })
        ;

        junctions.selectAll("text")
            .attr("x", function(d){return xScale(d.coords[0]);})
            .attr("y", function(d){return yScale(d.coords[1]);})
            //.text(function(d){return d.name === 'IfaceGeoBio'? '': d.name;})
        ;
        junctions
            .exit()
            .remove();
        legs = gcontent.selectAll("g.leg")
            .data(d3.values(this.p.LEG));
        legs
            .enter()
            .append("g")
            .attr("class", "leg")
            .call(function(g){
                g
                    .append("svg:path")
                    .attr('class', 'outer')
                    .attr('stroke', 'green')
                    .attr('stroke-width', 0.5)
                    .attr("fill", 'yellow')
                ;
                g
                    .append("svg:path")
                    .attr('class', 'inner')
                    //.attr("fill", 'lightblue')
                ;
            });

        var innerarrow = dv.Arrow().lengthshift(5).sideshift(3).radius(juncradius+1),
            outerarrow = dv.Arrow().lengthshift(5).sideshift(8).radius(juncradius+1);

        legs
            .call(installtooltip, function(d){
                var values = getvalues.legs(d);
                return d.name.general+"<br><em>"+shownobjects_property.legs.name+"</em>:<br>"
                    + legtooltip(values, property.format)
            })
            .each(function(d){
                var p01 = [[xScale(d.coords.FROM[0]), yScale(d.coords.FROM[1])],
                        [xScale(d.coords.TO[0]),yScale(d.coords.TO[1])]],
                    fracfill = notdefinedcolor,
                    matrixfill = notdefinedcolor,
                    values = getvalues.legs(d),
                    innerdir,
                    outerdir
                ;
                if (d.fractured === true){
                    innerdir = sign(d['DARCY-VELOCITY'].mag);
                    outerdir = d['PARALLEL-DARCY-VELOCITY'] === undefined ? 0 : sign(d['PARALLEL-DARCY-VELOCITY'].mag);
                    d3.select(this).select("path.inner")
                        .attr('stroke', 'black')
                        .attr('stroke-dasharray', '2 2')
                        .attr('stroke-width', 1)
                    ;

                } else {
                    innerdir = outerdir = sign(d['DARCY-VELOCITY'].mag);
                }
                if (values.general !== undefined){
                    fracfill = matrixfill = scales.legs(values.general);
                } else {
                    if (values.fracture !== undefined){
                        fracfill = scales.legs(values.fracture);
                    }
                    if (d.fractured === true && values.matrix !== undefined){
                        matrixfill = scales.legs(values.matrix);
                    }
                }

                d3.select(this).select("path.outer")
                    .classed(d.name.general, true)
                    .attr('d', outerarrow.p01(p01).d(outerdir, outerdir))
                    .attr('fill', matrixfill);
                d3.select(this).select("path.inner")
                    .attr('d', innerarrow.p01(p01).d(innerdir, innerdir))
                    .attr('fill', fracfill);
            });

    };

    picnictd.prototype.render_legtable = function(ele, networkfigureele){
        var tr, tr2, tr3, td, thead, th, leg, detailselect, selectedindex, evenodd;
        var that = this;
        var legproperties = this.legtabproperties.filter(function(prop){return prop.shownobjects === 'legs'});
        var table = ele.html("").append("table")
            .classed("leg", true)
            .style({"border-collapse": "collapse"});
        var colgroup = table.append("colgroup");
        var pre = colgroup.append("col").attr("span", 1);
        var selectedcolumn = colgroup.append("col");//.style({"background-color":"lightgrey" ,"border-width": "2px", "border-style": "solid", "border-color": "red"});
        thead = table.append("thead");
        tr = thead.append("tr").attr("class", "odd");
        tr2 = thead.append("tr").attr("class", "odd");
        legproperties.forEach(function(legproperty, idx){
            th = tr.append("th")
                .text(legproperty.name);
            if (legproperty.details === undefined) {
                th
                    .attr("rowspan", 2)
                    .attr("class", "legpoperty")
                ;
                if (legproperty.scale){
                    th
                        .attr("class", "linkish")
                        .on("click", function(){
                            that.dispatch.selectvar(legproperty.name, idx);
                        })
                    ;
                }
            } else {
                th
                    .attr("colspan", legproperty.details.length)
                    .attr("class", "colspan")
                    .style("position", "relative")
                ;
                legproperty.details.forEach(function(detail){
                    tr2.append("td")
                        .attr("class", "linkish detail " + detail)
                        .text(detail)
                        .on("click", function(){
                            that.dispatch.selectvar(legproperty.name + ' ' + detail, idx);
                        })
                    ;
                });
                if (legproperty.showselect !== undefined){
                    detailselect = th.append("select")
                            .attr("class", "detailselector")
                            .property("multiple", true)
                            .style({position: "absolute", top: "-100px"});
                    selectedindex = that.elements.indexOf('I') > -1 ? that.elements.indexOf('I-129') : 0;
                    that.elements.forEach(function(element, idx){
                        detailselect.append("option")
                            .attr("value", element)
                            .attr("title", element)
                            //.property("selected", idx === selectedindex ? true : false)
                            .text(element)
                        ;
                    });
                    detailselect.on("change", function(){
                        showselectedonly(this);
                    });
                }
            }
        });

        function showselectedonly(that){
            var i,
                option,
                n = that.options.length,
                nselected = that.selectedOptions.length;
            for (i=0; i < n; ++i){
                option = that.options[i];
                d3.selectAll("td.detail."+option.value)
                    .style("display", option.selected === true? "table-cell" : "none");
            }
            d3.selectAll("th.colspan")
                .attr("colspan", nselected)
            ;
        }


        function get_formatterincludingundefinedvalues(func){
            var f = func ? func : function(value){return value;};
            return function(value){
                return value === undefined ? '-': f(value);
            };
        }

        var LEG = d3.map(this.p.LEG);
        var legnames = LEG.keys();
        legnames.sort();
        legnames.forEach(function(legname, counter){
            evenodd =  ['even', 'odd'][counter % 2];
            var tbody = table.append("tbody")
                .attr("class", evenodd + " " + legname)
                .on("mouseover", function(){
                    d3.select(this).style({border: "2px solid orangered"});
                    networkfigureele.selectAll("path.outer."+legname).attr("stroke", 'orangered').attr("stroke-width", 1.5);
                })
                .on("mouseleave", function(){
                    d3.select(this).style({border: null});//.classed("highlight", false)
                    networkfigureele.selectAll("path.outer."+legname).attr("stroke", 'green').attr("stroke-width", 0.5);
                });
            leg = LEG.get(legname);
            //console.log(legname, leg);
            tr = tbody.append("tr");
            if (leg.fractured === true){
                tr2 = tbody.append("tr");
                tr3 = tbody.append("tr");
                legproperties.forEach(function(legproperty){
                    var obj = legproperty.getvalues(leg),
                        format = get_formatterincludingundefinedvalues(legproperty.format);
                    if (obj.general !== undefined){
                        tr.append("td").attr("rowspan", 3).text(format(obj.general));
                    } else {
                        if (legproperty.details === undefined){
                            tr.append("td").text(format(obj.fracture));
                            tr2.append("td").text(format(obj.matrix));
                        } else {
                            legproperty.details.forEach(function(detail){
                                tr.append("td").attr("class", "detail " + detail).text(obj.fracture === undefined ? '-' : format(obj.fracture[detail]));
                                tr2.append("td").attr("class", "detail " + detail).text(obj.matrix === undefined? '-': format(obj.matrix[detail]));
                            });
                        }

                    td = tr3.append("td");
                    if (obj.total !== undefined){
                        td.text(format(obj.total));
                    }}
                });
            } else {
                legproperties.forEach(function(legproperty){
                    var obj = legproperty.getvalues(leg),
                        format = get_formatterincludingundefinedvalues(legproperty.format);
                    if (legproperty.details === undefined){
                        tr.append("td").text(format(obj.general));
                    } else {
                        legproperty.details.forEach(function(detail){
                            tr.append("td").attr("class", "detail " + detail).text(format(obj.general[detail]));
                        });
                    }
                });
            }
        });
        detailselect.node().selectedIndex = selectedindex;
        showselectedonly(detailselect.node());
    };
    dv.picnictd = picnictd;

} ());
