/**
 * Created with PyCharm.
 * User: a404799
 * Date: 15.03.13
 * Time: 11:40
 * To change this template use File | Settings | File Templates.
 */

function create_legend(legendele, scale, title){
    var rectsize = 20,
        fontsize = 11,
        x0 = 10,
        ytitle = 30,
        y0scale = ytitle + fontsize
        ;
    var titleele = legendele.selectAll("text.title")
        .data([title || ""]);
    titleele
        .enter()
        .append("text")
        .attr("class", "title")
        .attr("x", x0)
        .attr("y", ytitle);
    titleele
        .text(function(d){return d;});

    var colorscale = legendele.selectAll("g.colorscale")
        .data(scale.domain());

    //console.log(scale.domain());

    colorscale
        .exit()
        .remove();

    colorscale
        .enter()
        .append("g")
        .attr("class", "colorscale")
        .call(function(sel){
            sel
            .append('rect')
                .attr('width', rectsize)
                .attr('height', rectsize)
                .attr('x', x0)
            ;
            sel
                .append('text')
                .attr('x', x0 + rectsize + fontsize/2);
        }
    );

    colorscale.select('rect')
        .attr('y', function(d, i){
            return i * rectsize + y0scale;
        })
        .attr('fill', function(d){
            return scale(d);
        })
    ;

    colorscale.select('text')
        .attr('y', function(d, i){
            return i * rectsize + y0scale + fontsize/2;
        })
        .text(function(d) {
            return d;
        })
    ;
}

function rncChart(ele){
    "use strict";
    var width = 500,
        height = 500,
        left = 50,
        right = 50,
        top = 50,
        bottom = 50,
        data = {},
        xScale = d3.scale.linear(),
        yScale = d3.scale.linear(),
        props = {legs: undefined, junctions: undefined},
        getvalues = {},
        //eps = 1E-10,
        arrowwidth = {mi: 1, ma: 4},
        junctionradius = {mi: 2, ma: 6},
        aw = arrowwidth.ma,
        jr = junctionradius.mi,
        obj = {}
    ;
    function get_geo(x0, y0, x1, y1){
        var dx = x1 - x0,
            dy = y1 - y0,
            theta = Math.atan2(dy, dx),
            thetaleft = theta + Math.PI/2.0,
            thetaright = theta - Math.PI/2.0
        ;
        return {
            udx: Math.cos(theta),
            udy: Math.sin(theta),
            udxleft: Math.cos(thetaleft),
            udyleft: Math.sin(thetaleft),
            udxright: Math.cos(thetaright),
            udyright: Math.sin(thetaright)
        };
    }

    function arrowhead(x0, y0, x1, y1){
        var geo = get_geo(x0, y0, x1, y1),
            path = []
            ;
        path.push([x0, y0]); // head
        path.push([x0 + aw * (geo.udx + geo.udxleft), y0 + aw * (geo.udy + geo.udyleft)]);
        path.push([x1 + aw * geo.udxleft, y1 + aw * geo.udyleft]);
        path.push([x1 + aw * geo.udxright, y1 + aw * geo.udyright]);
        path.push([x0 + aw * (geo.udx + geo.udxright), y0 + aw * (geo.udy + geo.udyright)]);
        return d3.svg.line()(path) + "Z";
    }

    function arrowtail(x0, y0, x1, y1){
        var geo = get_geo(x0, y0, x1, y1),
            path = []
            ;
        path.push([x0 + aw * geo.udx, y0 + aw * geo.udy]);
        path.push([x0 + aw * geo.udxleft, y0 + aw * geo.udyleft]);
        path.push([x1 + aw * geo.udxleft, y1 + aw * geo.udyleft]);
        path.push([x1 + aw * geo.udxright, y1 + aw * geo.udyright]);
        path.push([x0 + aw * geo.udxright, y0 + aw * geo.udyright]);
        return d3.svg.line()(path) + "Z";
    }

    function noarrow(x0, y0, x1, y1){
        var geo = get_geo(x0, y0, x1, y1),
            path = []
            ;
        path.push([x0 + aw * geo.udxleft, y0 + aw * geo.udyleft]);
        path.push([x1 + aw * geo.udxleft, y1 + aw * geo.udyleft]);
        path.push([x1 + aw * geo.udxright, y1 + aw * geo.udyright]);
        path.push([x0 + aw * geo.udxright, y0 + aw * geo.udyright]);
        return d3.svg.line()(path) + "Z";
    }

    obj.data = function(_){
        if (! arguments.length){
            return data;
        }
        data = _;
        return obj;
    };

    obj.render = function(ele, propname){
        var svg ,
            tooltipdiv,
            gcontent,
            legendg,
            i,
            jn,
            n_j = {},
            key,
            prop,
            name_prop = {};
        ele.selectAll("select")
            .data([null])
            .enter()
            .call(function(){
                var select;
                select = this
                    .append("div")
                    .append("select")
                    .on("change", function(){
                        obj.render(ele, this.options[this.selectedIndex].value);
                    });
                data.properties.forEach(function(prop){
                    select.append("option")
                        .attr("value", prop.name)
                        .attr("title", prop.description)
                        .text(prop.name);
                });
                this
                    .append("svg")
                    .call(function(svg){
                        svg.append("g").
                            attr("class", "content");
                        svg.append("g")
                            .attr("class", "legend");
                    });
                this
                    .append("div")
                    .attr("class", "tooltip")
                    .style({opacity: 0, position:"absolute"});
            });

        svg = ele.select("svg");
        tooltipdiv = ele.select("div.tooltip");
        gcontent = svg.select("g.content");
        legendg = svg.select("g.legend");

        for (i=0; i<data.junctions.length; ++i){
            jn = data.junctions[i];
            n_j[jn.name] = jn;
        }
        for (i=0; i<data.properties.length; ++i){
            prop = data.properties[i];
            name_prop[prop.name] = prop;
        }

        xScale
            .domain(d3.extent(data.junctions, function(d){ return d.x; }))
            .range([0, width - left - right]);
        yScale
            .domain(d3.extent(data.junctions, function(d){ return d.y; }))
            .range([height - top - bottom, 0]);

        prop = name_prop[propname];

        var

            scales = {},
            focusobjects;

        if (prop) {
            if (prop.objects === 'legs') {
                props.legs = prop;
                jr = junctionradius.mi;
                aw = arrowwidth.ma;
            } else if (prop.objects === 'junctions') {
                props.junctions = focusobjects = prop;
                jr = junctionradius.ma;
                aw = arrowwidth.mi;
            }
            focusobjects = prop.objects;
        }
        var allvalues;
        function extend(d){
            var i,
                values = getvalues[key](data, d);
            for (i = 0; i < values.length; ++i){
                allvalues.push(parseFloat(values[i]));
            }
        }
        function identity(d){
            return d;
        }
        for (key in props) {
            if (props.hasOwnProperty(key)){
                if (!props[key]) {
                    props[key] = name_prop[data.defaultproperties[key]];
                }
                prop = props[key];
                getvalues[key] = new Function("data", "obj", "return " + props[key].code + ";");
                allvalues = [];
                data[key].forEach(extend);

                var scl = d3.scale[prop.scale.typ]()
                    .domain(d3.extent(allvalues)),
                    ticks;
                if (prop.scale.typ === 'log'){
                    ticks = scl.ticks().map(scl.tickFormat(6)).filter(identity).map(parseFloat);
                } else {
                    ticks = scl.nice(6).ticks(6);
                }
                scales[key] = d3.scale.threshold()
                    .domain(ticks)
                    .range(["#f7fbff","#deebf7","#c6dbef","#9ecae1","#6baed6","#4292c6","#2171b5","#08519c","#08306b"]);
            }
        }

        if (!focusobjects) {
            focusobjects = "legs";
        }

        create_legend(legendg, scales[focusobjects], propname);

        svg.attr("width", width)
            .attr("height", height);

        gcontent.attr("transform", "translate(" + left + "," + top + ")");

        var leg = gcontent.selectAll('.leg')
            .data(data.legs, function(d){return d.from+ d.to;});

        var leggroup = leg.enter()
            .append("svg:g")
            .attr("class", 'leg')

            .on("mouseover", function(d) {
                var mousexy = d3.mouse(this);
                tooltipdiv.html(d.from+"-->"+ d.to+"<br><em>"+props.legs.name+"</em>:"+getvalues.legs(data, d).join("/"))
                    .style("left", mousexy[0] + "px")
                    .style("top", mousexy[1] + "px")
                    .transition()
                    .duration(200)
                    .style("opacity", 0.9);
            })
            .on("mouseout", function() {
                tooltipdiv.transition()
                    .duration(500)
                    .style("opacity", 0);
            });

        var legfrom = leggroup
            .append("svg:path")
            .attr('class', 'legfrom')
            .attr('stroke', 'black')
            .attr('stroke-width', 0.5);

        leg.selectAll(".legfrom")
            .attr('d', function(d){
                var j0 = n_j[d.from],
                    j1 = n_j[d.to],
                    xfrom = xScale(j0.x),
                    yfrom = yScale(j0.y),
                    xto = (xScale(j1.x) + xfrom)/2,
                    yto = (yScale(j1.y) + yfrom)/ 2,
                    deltax = xto - xfrom,
                    deltay = yto - yfrom,
                    dist = Math.sqrt(deltax*deltax + deltay*deltay),
                    dx = deltax / dist * 2,
                    dy = deltay / dist * 2
                    ;
                xfrom = xfrom + dx;
                //xto = xto - dx;
                yfrom = yfrom + dy;
                //yto = yto - dy;
                if (d.inflow > 0) {
                    return arrowtail(xfrom, yfrom, xto, yto);
                } else if (d.inflow < 0) {
                    return arrowhead(xfrom, yfrom, xto, yto);
                } else{
                    return noarrow(xfrom, yfrom, xto, yto);
                }
            })
            .attr('fill', function(d) {
                //return legscale(Math.abs(d.outflowatj0 || eps));
                return scales.legs(getvalues.legs(data, d)[0]);
            });


        var legto = leggroup
            .append("svg:path")
            .attr('class', 'legto')
            .attr('stroke', 'black')
            .attr('stroke-width', 0.5);

        leg.selectAll(".legto")
            .attr('d', function(d){
                var j1 = n_j[d.from],
                    j0 = n_j[d.to],
                    xto = xScale(j0.x),
                    yto = yScale(j0.y),
                    xfrom = (xScale(j1.x) + xto)/2,
                    yfrom = (yScale(j1.y) + yto)/ 2,
                    deltax = xto - xfrom,
                    deltay = yto - yfrom,
                    dist = Math.sqrt(deltax*deltax + deltay*deltay),
                    dx = deltax / dist * 2,
                    dy = deltay / dist * 2
                    ;
                //xfrom = xfrom + dx;
                xto = xto - dx;
                //yfrom = yfrom + dy;
                yto = yto - dy;

                if (d.outflow > 0) {
                    return arrowhead(xto, yto, xfrom, yfrom);
                } else if (d.outflow < 0) {
                    return arrowtail(xto, yto, xfrom, yfrom);
                } else {
                    return noarrow(xto, yto, xfrom, yfrom);
                }
            })
            .attr('fill', function(d) {
                //return legscale(Math.abs(d.outflowatj1 || eps));
                var values = getvalues.legs(data, d);
                return scales.legs(values.length > 1 ? values[1] : values[0]);
            });


        leg.exit()
            .style("stroke", "red")
            .style("stroke-width", 5)
            .transition()
            .duration(1750)
            .style("stroke-opacity", 1e-6)
            .remove();

        var junction = gcontent.selectAll('.junc')
            .data(data.junctions, function(d){return d.name;});

        junction.exit().remove();

        var junctionenter = junction
            .enter()
            .append("svg:g")
            .attr('class', 'junc');


        junctionenter.append('circle')
            .on("mouseover", function(d) {
                var mousexy = d3.mouse(this);
                tooltipdiv.html(d.label+"<br/><em>"+props.junctions.name+"</em>: "+getvalues.junctions(data, d))
                    .style("left", mousexy[0] + "px")
                    .style("top", mousexy[1] + "px")
                    .transition()
                    .duration(200)
                    .style("opacity", 0.9)
                ;
            })
            .on("mouseout", function() {
                tooltipdiv.transition()
                    .duration(500)
                    .style("opacity", 0);
            });

        junctionenter.append('text')
            .attr('dx', '0.7em')
            .attr('dy', '1.4em')
            .text(function(d){return d.label;})
        ;

        junction.selectAll('circle')
            .attr('r', jr)
            .attr('cx', function(d){return xScale(d.x);})
            .attr('cy', function(d){return yScale(d.y);})
            .style("fill", function(d){
                return scales.junctions(getvalues.junctions(data, d));
            });

        junction.selectAll('text')
            .attr('x', function(d){return xScale(d.x);})
            .attr('y', function(d){return yScale(d.y);});

        return obj;
    };

    obj.arrowwidth = function(_){
        if (!arguments.length) {
            return arrowwidth;
        }
        arrowwidth = _;
        return obj;
    };
    obj.junctionradius = function(_){
        if (!arguments.length) {
            return junctionradius;
        }
        junctionradius = _;
        return obj;
    };
    obj.width = function(_){
        if (!arguments.length) {
            return width;
        }
        width = _;
        return obj;
    };
    obj.height = function(_){
        if (!arguments.length) {
            return height;
        }
        height = _;
        return obj;
    };
    obj.left = function(_){
        if (!arguments.length) {
            return left;
        }
        left = _;
        return obj;
    };
    obj.right = function(_){
        if (!arguments.length) {
            return right;
        }
        right = _;
        return obj;
    };
    obj.bottom = function(_){
        if (!arguments.length) {
            return bottom;
        }
        bottom = _;
        return obj;
    };
    obj.top = function(_){
        if (!arguments.length) {
            return top;
        }
        top = _;
        return obj;
    };
    return obj;
}
