/**
 * Created with PyCharm.
 * User: mag
 * Date: 26.07.14
 * Time: 10:59
 * To change this template use File | Settings | File Templates.
 */



(function (root, factory) {
    if (typeof define === 'function' && define.amd) {
        define([], factory);
    } else if (typeof exports === 'object') {
        // Node, CommonJS-like
        module.exports = factory();
    } else {
        root.dm.stacking = factory();
    }
} (this, function() {
    function get_cums(dims){
        var i,
            n = dims.length,
            cums = [0]
            ;
        for (i=1; i <= n; i = i + 1){
            cums.push(cums[i-1] + dims[i-1]);
        }
        return cums;
    }

    /*
        Strategie:
        numberofstacks = min(kumulierte Länge / max(lengths), limitnumberofstacks)
        tol =
    */

    function Stacking(lengths){
        if ( !(this instanceof Stacking)){
           return new Stacking(lengths);
        }
        this.lengths = lengths;
        this._numberofstacks = 0;
        this._max = 0;
    }

    Stacking.prototype.limitnumberofstacks = function(maxnumberofstacks){
        this._arrange(undefined, maxnumberofstacks ? maxnumberofstacks : 1);
        return this;
    };

    Stacking.prototype.limitstackheight = function(maxheight){
        this._arrange(maxheight, undefined);
        return this;
    };

    Stacking.prototype._arrange = function(maxheight, maxnumberofstacks){
        var lengths = this.lengths,
            lengthslength = lengths.length,
            cumlengths = get_cums(lengths),
            total = cumlengths[lengthslength],
            maxlength,
            idx,
            istack = 0,
            start, stop,
            stackstartidx = 0
            ;
        if (maxnumberofstacks){
            maxlength = Math.max.apply(null, lengths);
            maxheight = total / Math.round(Math.min(total / maxlength, maxnumberofstacks)) + maxlength/2;
        }

        this._confs = [];

        function get_start(i){
            return cumlengths[i] - cumlengths[stackstartidx];
        }

        function get_stop(i){
            return cumlengths[i+1] - cumlengths[stackstartidx];
        }

        for (idx=0; idx < lengthslength; idx=idx+1){
            start = get_start(idx);
            stop = get_stop(idx);
            if (stop > maxheight && istack < maxnumberofstacks-1){
                stackstartidx = idx;
                istack += 1;
                start = get_start(idx);
                stop = get_stop(idx);
            }

            this._confs.push({istack: istack, i: idx, start: start, stop: stop});
            this._max = Math.max(this._max, stop);
        }
        this._numberofstacks = lengthslength ? istack + 1 : istack;
    };

    Stacking.prototype.confs = function(){
        return this._confs;
    };

    Stacking.prototype.max = function(){
        return this._max;
    };

    Stacking.prototype.numberofstacks = function(){
        return this._numberofstacks;
    };
    return {
        Stacking: Stacking
    };
}));