/**
 * Data selector
 * Created with PyCharm.
 * User: mag
 * Date: 15.09.13
 * Time: 21:02
 * To change this template use File | Settings | File Templates.
 */

if (dm === undefined){
    dm = {};
}
(function (){
    "use strict";
    function formulatext(d){
        if (typeof d === "string"){
            return d;
        } else if (d.length !== undefined) {
            return "("+ d.join("<br>+")+")";
        }
    }

    function widgetfactory(){

        var width = 400,
            height = 300,
            widgetprefix = 'wdgt',
            widgetcount = 0,
            availableheadline = "Available data",
            selectedheadline = "Selected data",
            actionvalue = "Show"
            ;



        function widget(ele, db){
            var tr, div;
            var dbf,
                ready = console.log,
                currentselectednames = [],
                selectednames = []
                ;
            var widgetid = widgetprefix+widgetcount,
                rootdiv,
                widgetdiv,
                availablediv,
                selecteddiv,
                searchinput,
                availablenamesdiv,
                selectednamesdiv,
                selectinput,
                actionmenudiv,
                actionbutton,
                widgetonoffdiv,
                selectedcounterspan,
                datatypes,
                datatypeindex,
                datatype,
                obj = {}
                ;
            var actiontypes = [];

            widgetcount ++;

            obj.available = function(_){
                if (!arguments.length) return db;
                db = _;
                return obj;
            };

            obj.ready = function(_){
                if (!arguments.length) return ready;
                ready = _;
                return obj;
            };

            obj.show = function(){
                widgetdiv.style({display: 'block'});
                searchinput.on("keyup")();
                currentselectednames = selectednames.slice();
                showselected();
            };

            obj.hide = function(){
                widgetdiv.style('display', 'none');
            };

            obj.widgettoggle = function(){
                if (widgetdiv.style("display") === 'none'){
                    obj.show();
                } else {
                    obj.hide();
                }
            };

            function showavailable(){
                function updateselectednames(name){
                    var lastitem;
                    if (d3.event.ctrlKey){
                        lastitem = currentselectednames.length ? currentselectednames[currentselectednames.length-1]: undefined;
                        if (typeof lastitem === "string" || lastitem === undefined){
                            lastitem = [name];
                            currentselectednames.push(lastitem);
                        } else {
                            lastitem.push(name);
                        }
                    } else {
                        currentselectednames.push(name);
                    }
                    showselected();
                }

                var div = availablenamesdiv.selectAll("div")
                    .data(dbf.map(function(rec){return rec.name;}), function(d, i){return d + i;});
                div.enter()
                    .append("div")
                    .attr('title', function(d){return d;})
                    .attr('class', "selectable linkish")
                    .on("click", updateselectednames);
                div
                    .text(function(d){
                        return d;
                    });
                div.exit()
                    .remove();
            }

            function showselected(){
                function removeselecteditem(name){
                    var i = currentselectednames.indexOf(name);
                    if (i > -1){
                        currentselectednames.splice(i, 1);
                        showselected();
                    }
                }
                var div = selectednamesdiv.selectAll("div")
                    .data(currentselectednames, formulatext);
                div.enter()
                    .append("div")
                    .attr('class', 'smallicon trashbin linkish')
                    .on('click', removeselecteditem)
                ;
                div.html(formulatext);
                div.exit()
                    .transition()
                    .duration(300)
                    .style("opacity", 0)
                    .remove();
                selectedcounterspan.text(currentselectednames.length);
                actionbutton.attr("disabled", currentselectednames.length === 0 ? "disabled": null);
            }

            function filteravailablenames (){
                //console.log(this);
                var i,
                    substrings = searchinput.node().value.split(" "),
                    n
                    ;

                n = substrings.length;
                dbf = db(datatype.where, function(){
                    for (i=0; i< n; ++i) {
                        if (this.name.indexOf(substrings[i]) === -1) {
                            return false;
                        }
                    }
                    return true;
                });
                showavailable();
            }

            function clearselecteddata(){
                datatype = datatypes[this.value];
                removeallselected();
                searchinput.on("keyup")();
                renderoptionsmenu(actionmenudiv);
                renderapplybutton(actionmenudiv);
            }

            function updateavailabledata(){
                datatypeindex = this.value;
                datatype = datatypes[datatypeindex];
                searchinput.on("keyup")();
            }

            function removeallselected() {
                selectednamesdiv.selectAll("div")
                    .remove();
                currentselectednames = [];
                actionbutton.attr("disabled", "disabled");
                showselected();
            }

            function renderoptionsmenu(ele){
                var ul, li, optionid=0;
                ele.html("");
                ele.append("h2").text("Optionen");
                ul = ele.append("ul")
                        .attr("class", "options");

                datatype.showoptions.forEach(function(option){
                    optionid ++;
                    li = ul.append("li");
                    option.widget = li.append("input")
                            .attr(option.input)
                            .attr("id", optionid)
                            .node()
                            ;
                    li.append("label")
                            .attr("for", optionid)
                            .text(option.input.label);
                });
            }

            function renderapplybutton(ele, func){
                actionbutton = ele.append("input")
                    .attr("type", "button")
                    .attr("value", t("Apply"))
                    .style({width: "100px"})
                    .on("click", function(){
                        obj.hide();
                        obj.selectednames(currentselectednames);
                        ready(obj);
                    });
            }



            obj.rootdiv = function(_){
                if (!arguments.length) return rootdiv;
                rootdiv =  d3.select(_).node();
                rootdiv.html("")
                    .append("div")
                    .attr("class", "dataselect add linkish")
                    .style("position", "relative")
                    .text("Settings")
                    .on("click", obj.widgettoggle);

                widgetdiv = rootdiv.append("div")
                    .attr("class", "dataselect widget shadow")
                    //.attr("tabindex", -1)
                    //.on("blur", hide)
                    .style({display: "none", position: "absolute", top: "1.5em", left:"1.5em"});

                //
                // Menu for available data
                //
                availablediv = widgetdiv.append("div")
                    .attr("class", "dataselect available")
                    .style({width:  width+"px", 'float':'left'});
                //availablediv.append("h2").text(availableheadline);
                var tbody = availablediv.append("table").append("tbody");
                tr = tbody.append("tr");
                tr.append("td").text("Data type");
                selectinput = tr.append("td").append("select")
                    .on('change', clearselecteddata);
                datatypes.forEach(function(dt, idx){
                    selectinput.append("option")
                        .attr("value", idx)
                        .text(dt.label);
                    if (idx === 0 || dt.selected) {
                        datatype = dt;
                    }
                });
                dbf = db(datatype.where);
                tr = tbody.append("tr");
                tr.append("td").text("Search");
                searchinput = tr.append("td").append("input")
                    .attr("type", "text")
                    .on('keyup', filteravailablenames);
                tr.append("td")
                    .attr("class" , "linkish")
                    .text("select all")
                    .on("click", function(){
                        availablenamesdiv.selectAll("div").data().forEach(function(name){
                            currentselectednames.push(name);
                            showselected();
                        });
                    });
                availablenamesdiv = availablediv.append("div")
                    .attr("class", "dataselect availablenames")
                    .style({height:height+"px", overflow: "auto"});
                //
                // Selected data
                //
                selecteddiv = widgetdiv.append("div")
                    .attr("class", "dataselect selected")
                    .style({width:  width+"px", 'float':'left'});
                selecteddiv.append("h2").text(selectedheadline).style("margin-top", "0px");
                var txt = selecteddiv.append("text");
                selectedcounterspan = txt.append("span");
                txt.append("span").text(" items selected ");
                txt.append("span")
                    .attr("class", "smallicon trashbin linkish")
                    .text("remove all")
                    .on("click", removeallselected);
                selectednamesdiv = selecteddiv.append("div")
                    .attr("class", "dataselect selctednames")
                    .style({height: height + "px", overflow: "auto", position: "relative", top: "0.6em"});
                //
                // Menu for Action
                //
                actionmenudiv = widgetdiv.append("div")
                    .style({'float':'left'}).html("");

                renderoptionsmenu(actionmenudiv);
                renderapplybutton(actionmenudiv);
                return obj;
            };
            obj.selectednames = function(_){
                if (!arguments.length) {return selectednames;}
                selectednames = _;
                return obj;
            };


            obj.actiontypes = function(){
                var option_widget = {};
                datatype.showoptions.forEach(function(option){
                    option_widget[option.cls] = option.widget;
                    option.checked = option.widget.checked;
                    option.value = option.widget.value;
                });
                return datatype.showoptions.filter(
                    function(option){
                        if (option.f !== undefined) {
                            option.option_widget = option_widget;
                            return true;
                        }
                    });
            };

            obj.datatypeindex = function(_){
                if (!arguments.length) {return datatypeindex;}
                datatype = datatypes[_];
                datatypeindex = _;
                selectinput.selectAll("option")[0][_].selected = "selected";
                return obj;
            };

            obj.datatypes = function(_){
                if (!arguments.length) {return datatypes;}
                datatypes = _;
                return obj;
            };

            return obj;
        }
        widget.width = function(_){
            if (!arguments.length) return width;
            width = _;
            return widget;
        };
        widget.height = function(_){
            if (!arguments.length) return height;
            height = _;
            return widget;
        };

        return widget;
    }
    dm.widgetfactory = widgetfactory;
})();

