/**
 * Created with PyCharm.
 * User: a404799
 * Date: 15.03.13
 * Time: 11:40
 * To change this template use File | Settings | File Templates.
 */

var dv = dv || {};

(function () {
    "use strict";

    var counter = 0;

    function XYChart(ele) {
        var chartid = 'XYChart' + counter++,
            width = 500,
            height = 400,
            leftMargin = 100,
            rightMargin = 50,
            topMargin = 50,
            bottomMargin = 50,
            dpi = 96,
            data,
            minorticksize = 4,
            majorticksize = 10,
            xtitle,
            ytitle,
            xmin,
            xmax,
            ymin,
            ymax,
            xtype,
            ytype,
            xunits,
            yunits,
            xScale,
            yScale,
            xAxis,
            leftyAxis,
            legendtotalx,
            legendtotaly,
            evaluationperiod,
			axistitlefontsizept = 10,
			tickfontsizept = 10
            ;
        var
            svg = d3.select(ele).node().html("")
                .append("svg:svg")
                //.style("font-family", "Arial,Helvetica,sans-serif")
                //.style("font-size", 10*dv.pt2px+"px")
                .attr("id", idstr()),
            defs = svg.append("svg:defs"),
            titletext = svg.append("text")
                .attr("id", idstr("title")),
            legendtotalg = svg.append("svg:g")
                .attr('id', idstr("legendtotal"))
                .attr('class', "legendtotal"),
            plotarea = svg.append("svg:g")
                .attr("id", idstr("plotarea"))
                .attr("clip-path", 'url(#'+idstr("clip")+')'),
            div = d3.select(ele).node().append("div")
                .attr("class", "tooltip")
                .style("opacity", 0),
            properties = d3.select(ele).node().append("div")
                .attr("class", "properties widget shadow")
                .style({position: "absolute", top: "0.5em", left: "10em", visibility: "hidden"}),
            cliprect = svg.append("svg:clipPath").attr("id", idstr("clip")).append("svg:rect"),
            xaxistopg,
            xaxisbottomg,
            yaxisleftg,
            yaxisrightg,
            dataline = d3.svg.line(),
            zeroforlogscale = 1E-50,
            dm,
            redraw,
            pointindicator,
            obj = {}

        ;
        defs.append("style").attr("type", "text/css").html("text {font-family: Arial,Helvetica,sans-serif; }");



        function idstr(){
            var i, parts = [chartid];
            for(i = 0; i < arguments.length; ++i){
                parts.push(arguments[i]);
            }
            return parts.join("--");
        }

        function refidstr(){
            return "#" + idstr.apply(undefined, arguments);
        }

        function define_marker(marker, id){
            var m = dv.marker(marker.symbol, marker.size, marker.orient);
            defs
                .append("svg:marker")
                .attr("id", id)
                .attr(m.attr)
                .style(marker.style)
                .append("svg:path")
                .attr('d', m.d)
            ;
            return id;
        }


        function Pointindicator(){
            var horline,
                verline,
                xtext,
                ytext,
                labeltext,
                xrect,
                yrect,
                labelrect,
                grouppointindicator = svg.selectAll("g.pointindicator")
                    .data([null]);
            grouppointindicator
                .enter()
                .call(function(sel){
                    var rectstyle = {"fill": 'white', stroke: 'gray', "stroke-width": 1, "stroke-dasharray": "2, 2"};
                    var g = sel
                        .append("g")
                        .attr("class", "pointindicator");
                    horline = g.append("line")
                        .attr("class", "horline")
                        .style({fill: "none", stroke:'black', "stroke-width": 1, "stroke-dasharray": "2, 2"});
                    verline = g.append("line")
                        .attr("class", "verline")
                        .style({fill:"none", stroke:'black', "stroke-width": 1, "stroke-dasharray": "2, 2"});
                    labelrect = g.append("rect")
                        .style(rectstyle);
                    labeltext = g.append("text")
                        .attr("dx", '.5em')
                        .attr("dy", '-.5em')
                        .style({"text-anchor": "start"});
                    xrect = g.append("rect")
                        .style(rectstyle);
                    xtext = g.append("text")
                        .attr("dy", '1.5em')
                        .style({"text-anchor": "middle"})
                    ;
                    yrect = g.append("rect")
                        .style(rectstyle);
                    ytext = g.append("text")
                        .style({"text-anchor": "end"})
                        .attr("dx", '-0.5em');
                });

            return {
                show: function(xmax, ymax, label){
                    var xm = xScale(xmax.mag),
                        ym = yScale(ymax.mag)
                        ;
                    horline
                        .attr("x1", leftMargin)
                        .attr("x2", xm)
                        .attr("y1", ym)
                        .attr("y2", ym);
                    verline
                        .attr("x1", xm)
                        .attr("x2", xm)
                        .attr("y1", height - bottomMargin)
                        .attr("y2", ym);
                    xtext
                        .attr("x", xm)
                        .attr("y", height - bottomMargin)
                        .text(xmax.mag.toExponential(2));
                    ytext
                        .attr("x", leftMargin)
                        .attr("y", ym)
                        .text(ymax.mag.toExponential(2));
                    labeltext
                        .attr("x", xm)
                        .attr("y", ym)
                        .text(label);
                    grouppointindicator.style("display", "block");
                    dv.copybb(labeltext, labelrect);
                    dv.copybb(ytext, yrect);
                    dv.copybb(xtext, xrect);

                },
                hide: function(){
                    grouppointindicator.style("display", "none");
                }
            };
        }


        function classchange(obj, factor){
            var firstclass = obj.className.baseVal.split(/\s+/)[0],
                totalclasses,
                datum;

            function changestyle(obj, attr, increment){
                //console.log(obj);
                try {
                    var val = parseInt(obj.style(attr), 10);
                    obj.style(attr, (val + factor*increment));
                } catch(e) {
                    console.log(e);
                }
            }

            function textboldnormal(obj){
                obj.style("font-weight", factor >= 0 ? "bold" : "normal");
            }

            if (firstclass === 'total'){
                totalclasses = obj.className.baseVal.replace(/^\s+|\s+$/g, '').replace(/ +/g, '.');
                datum = svg.selectAll("path.line" + totalclasses).call(changestyle, "stroke-width", 2).datum();
                if(factor > 0){
                    pointindicator.show(datum.xmax, datum.ymax, datum.label);
                }
                svg.selectAll("path." + totalclasses).call(changestyle, "stroke-width", 2);
                svg.selectAll("text." + totalclasses).call(textboldnormal);
            }
            else if (firstclass === 'linetotal'){
                totalclasses = obj.className.baseVal.replace(/^\s+|\s+$/g, '').replace(/ +/g, '.').substr(4);
                datum = svg.selectAll("path.line" + totalclasses).call(changestyle, "stroke-width", 2).datum();
                if(factor > 0){
                    pointindicator.show(datum.xmax, datum.ymax, datum.label);
                }
                svg.selectAll("path." + totalclasses).call(changestyle, "stroke-width", 2);
                svg.selectAll("text." + totalclasses).call(textboldnormal);
            } else {
                var detailclass = obj.className.baseVal.replace(/^\s+|\s+$/g, '').split(/\s+/)[1];
                totalclasses = obj.className.baseVal.split(' ').slice(2).toString().replace(/ +/g, '.');
                if (firstclass === 'linedetail'){
                    datum = svg.selectAll("path.linedetail." + detailclass).call(changestyle, "stroke-width", 2).datum();
                    if(factor > 0){
                        pointindicator.show(datum.xmax, datum.ymax, datum.label);
                    }
                    svg.selectAll("text.legendtextdetail." + detailclass).call(textboldnormal);
                    svg.selectAll("path.total." + totalclasses).call(changestyle, "stroke-width", 1);
                    svg.selectAll("text.total." + totalclasses).call(textboldnormal);
                } else if (firstclass === 'legendtextdetail' || firstclass === 'legendlinedetail'){
                    svg.selectAll("path.linedetail." + detailclass).call(changestyle, "stroke-width", 2);
                    svg.selectAll("text.legendtextdetail." + detailclass).call(textboldnormal);
                }
            }
        }

        function highlight(){
            classchange(this, +4);
        }

        function normal(){
            classchange(this, -4);
            pointindicator.hide();
        }

        obj.animatetotal = function(){
            svg.selectAll("path.total,path.linetotal,text.total")
                .on("click", toggledetails)
                .on("mouseover", highlight)
                .on("mouseout", normal);
        };

        obj.animatedetails = function(){
            svg.selectAll("path.linedetail,path.legendlinedetail,text.legendtextdetail")
                .on("mouseover", highlight)
                .on("mouseout", normal);
        };

        obj.animate = function(){
            pointindicator = Pointindicator();
            obj.animatetotal();
            obj.animatedetails();
        };


        function get_detaillinestyle(name){
            return {"stroke-width": 2, stroke:get_detailcolor(name), fill:"none"};
        }

        function editaxis(){
            properties.html('<fieldset><legend>Axes</legend>\
<fieldset>\
<legend>X</legend>\
<table>\
<tr><td>Min:</td><td><input class="xmin" size="10" type="text"></td></tr>\
<tr><td>Max:</td><td><input class="xmax" size="10" type="text"></td></tr>\
<tr><td>Type:</td><td><select class="xaxistype">\
<option value="log">log</option>\
<option value="lin">lin</option>\
</select>\
</td></tr>\
</table>\
</fieldset>\
<fieldset>\
<legend>Y</legend>\
<table>\
<tr><td>Min:</td><td><input class="ymin" size="10" type="text"></td></tr>\
<tr><td>Max:</td><td><input class="ymax" size="10" type="text"></td></tr>\
<tr><td>Type:</td><td><select class="yaxistype">\
<option value="log">log</option>\
<option value="lin">lin</option>\
</select>\
</td></tr>\
</table>\
</fieldset>\
<input class="axisapply" type="button" value="Apply">\
<input class="axisclose" type="button" value="Close">\
</fieldset>\
</fieldset>');
            properties.style("visibility", "visible");
            properties.select(".xmin").attr("value", xmin);
            properties.select(".xmax").attr("value", xmax);
            properties.select(".xaxistype option[value="+xtype+"]").attr("selected", true);
            properties.select(".ymin").attr("value", ymin);
            properties.select(".ymax").attr("value", ymax);
            properties.select(".yaxistype option[value="+ytype+"]").attr("selected", true);

            properties.select(".axisapply").on("click", function(){
                xmin = parseFloat(d3.select(".xmin").node().value);
                xmax = parseFloat(properties.select(".xmax").node().value);
                xtype = properties.select(".xaxistype").node().value;
                ymin = parseFloat(properties.select(".ymin").node().value);
                ymax = parseFloat(properties.select(".ymax").node().value);
                ytype = properties.select(".yaxistype").node().value;
                redraw(obj);
            });
            properties.select(".axisclose").on("click", function(){
                properties.style("visibility", "hidden");
            });
        }

        obj.onredraw = function(_){
            redraw = _;
        };



        obj.plotaxis = function(){
            xAxis = d3.svg.axis()
                .scale(xScale)
                .orient('bottom')
                .tickSize(-majorticksize, -minorticksize)
                .tickPadding(2*majorticksize)
                .ticks(5)
            ;

            var topxAxis = d3.svg.axis()
                .scale(xScale)
                .orient('bottom')
                .tickSize(majorticksize, minorticksize)
                .ticks(5)
                .tickFormat(function(){});


            leftyAxis = d3.svg.axis()
                .scale(yScale)
                .ticks(4)
                .tickPadding(10)
                .tickSize(-majorticksize, -minorticksize)
                .orient('left');

            var rightyAxis = d3.svg.axis()
                .scale(yScale)
                .ticks(4)
                .tickSize(majorticksize, minorticksize)
                .orient('left')
                .tickFormat(function(){});

            //var fmt = rightyAxis.tickFormat();
            //.tickFormat(function(x){return fmt(x).toString().split('e').join('--')});

            svg
                .attr("width", dv.pt(width, dpi))
                .attr("height", dv.pt(height, dpi))
                .attr("viewBox", "0 0 " + width + " " + height)
            ;

            cliprect
                .attr("x", leftMargin)
                .attr("y", topMargin)
                .attr("width", width - leftMargin - rightMargin)
                .attr("height", height - topMargin - bottomMargin);


            // Add bottom x-axis.
            xaxisbottomg = svg.selectAll("g.x.axis.bottom")
                .data([null]);
            xaxisbottomg
                .enter()
                .append('svg:g')
                .attr("class", "x axis bottom")
                .on('click', editaxis)
                .append("text")
                .attr("class", "title")
                //.attr("dy","3em")
                .attr("dy",3*axistitlefontsizept * dv.pt2px)
                .style("text-anchor", "middle");
            xaxisbottomg
                .attr("transform", "translate(0," + (height - bottomMargin) + ")")
                .call(xAxis);
            xaxisbottomg.select("text.title")
                .attr("transform", "translate("+ ( leftMargin +(width-rightMargin-leftMargin)/2) + ")")
				.style("font-size", axistitlefontsizept * dv.pt2px+"px")
                .call(dv.supernumbers, (xtitle === undefined ? " ": xtitle)+ " [" + xunits + "]");

            /* Add top x-axis*/
            xaxistopg = svg.selectAll("g.x.axis.top")
                .data([null]);
            xaxistopg
                .enter()
                .append('svg:g')
                .attr("class", "x axis top");
            xaxistopg
                .attr("transform", "translate(0," + topMargin + ")")
                .call(topxAxis);

            // Add the left y-axis.
            yaxisleftg = svg.selectAll("g.y.axis.left")
                .data([null]);
            yaxisleftg
                .enter()
                .append('svg:g').attr("class", "y axis left")
                .on('click', editaxis)
                .append("text")
                .attr("class", "title")
                //.attr("dy","-5em")
                .style("text-anchor", "middle");
            yaxisleftg
                .attr("transform", "translate(" + leftMargin + ",0)")
                .call(leftyAxis);
            yaxisleftg.select("text.title")
                //.attr("transform", "translate(" + (-leftMargin+axistitlefontsizept*dv.pt2px*1.3) + "," + (topMargin + (height-topMargin-bottomMargin)/2) + "), rotate(-90)")
                .attr("transform", "matrix(0,-1,1,0,0,0)")
                .attr("x", -(topMargin + (height-topMargin-bottomMargin)/2))
                .attr("y", -leftMargin+axistitlefontsizept*dv.pt2px*1.3)
				.style("font-size", axistitlefontsizept * dv.pt2px+"px")
                .call(dv.supernumbers, (ytitle === undefined ? " ": ytitle)+ " [" + yunits.replace('/a', ' a-1') + "]");

            yaxisrightg = svg.selectAll("g.y.axis.right")
                .data([null]);
            yaxisrightg
                .enter()
                .append('svg:g').attr("class", "y axis right");
            yaxisrightg
                .attr("transform", "translate("+ (width - rightMargin) + ",0)")
                .call(rightyAxis);

            var scientificformat = dv.get_scientificformatter(tickfontsizept);
            svg.selectAll("g.tick text").each(scientificformat);
        };


        function get_dataline(xmag, ymag, every, offset){
            var j,
                datum = [];
            every = every ? every : 1;
            offset = offset ? offset : 0;
            for (j = offset; j < xmag.length; j=j+every) {
                datum.push([xmag[j], ymag[j]]);
            }
            return dataline(datum);
        }


        function toggledetails(){
            var cssclasses = this.__data__.subset.cssclasses.length > 0 ? "."+ this.__data__.subset.cssclasses.join("."): "";

            var linetotalsubset = plotarea.selectAll("path.linetotal"+cssclasses).node().__data__.subset;

            if (linetotalsubset.visible === 'details'){
                svg.selectAll(refidstr("linedetail", linetotalsubset.idx)).remove();
                svg.selectAll("text.total"+cssclasses)
                    .attr("text-decoration", null);
                svg.selectAll("path"+cssclasses)
                    .style("opacity", 0.07);
                linetotalsubset.visible = null;
            } else if(linetotalsubset.visible === 'total') {
                linetotalsubset.visible = "details";
                svg.selectAll("text.total"+cssclasses)
                    .attr("text-decoration", "underline");
                plotdetails(linetotalsubset.idx);
            } else if(linetotalsubset.visible === null) {
                linetotalsubset.visible = "total";
                svg.selectAll("path"+cssclasses)
                    .style("opacity", 1.0)
                ;
                svg.selectAll("text.total"+cssclasses)
                    .attr("text-decoration", "null");
            }
            plotlegenddetail();
            obj.animatedetails();
        }

        function plotdetails(idx){
            var name,
                g,
                xy = data[idx].xy,
                xyevaluationperiod = data[idx].xy.slice({le: evaluationperiod}),
                d,
                ydetail
                ;

            g = plotarea.append('g')
                .attr('id', idstr("linedetail",idx))
            ;

            var clip = 'url(#'+idstr("clip")+')',
                classes = data[idx].subset.cssclasses.join(' ');

            for (name in xy.y.mag){
                if(xy.y.mag.hasOwnProperty(name)){
                    d = {idx: idx};
                    ydetail = xyevaluationperiod.y.get(name);
                    d.ymax = ydetail.max();
                    var imax = ydetail.mag.indexOf(d.ymax.mag);
                    d.xmax = xy.x.get(imax);
                    d.label = data[idx].subset.label + ": " +name;
                    g.append("path")
                        .datum(d)
                        .attr("id", idstr("linedetail", idx, name))
                        .attr("class", "linedetail " + name + " " + classes)
                        .attr("clip-path", clip)
                        .attr("d", get_dataline(xy.x.mag, xy.y.mag[name]))
                        .style(get_detaillinestyle(name))
                    ;
                }
            }
        }

        obj.plotdata = function(){
            var clip = 'url('+refidstr("clip")+')';
            var linetotal = plotarea.selectAll("path.linetotal")
                .data(data);
            linetotal
                .enter()
                .append("path")
                .attr("class", function(d){return "linetotal " + d.subset.cssclasses.join(' ');})
                .attr("clip-path", clip)
                //.call(d3.helper.tooltip().style({color: 'blue', "background-color": 'white', opacity:0.8}).text(function(d){return maxtooltip(d.xmax, d.ymax);}))
                ;
            linetotal
                .each(function(d){
                    d3.select(this).style(d.subset.linestyle);
                })
                .attr("d", function(d){
                    var total = d.xy.total(),
                        totalevaluationperiod = total.slice({le: evaluationperiod})
                        ;
                    d.ymax = totalevaluationperiod.y.max();
                    var imax = totalevaluationperiod.y.mag.indexOf(d.ymax.mag);
                    d.xmax = totalevaluationperiod.x.get(imax);
                    d.label = d.subset.label;
                    return get_dataline(total.x.mag, total.y.mag);
                })
            ;
            linetotal
                .exit()
                .remove()
                .call(function(_){

                })
            ;
            var markertotal = plotarea.selectAll("path.markertotal")
                .data(data);
            markertotal
                .enter()
                .append("path")
                .attr("class", function(d){return "markertotal " + d.subset.cssclasses.join(' ');})
                .attr("clip-path", clip)
            ;
            markertotal
                .each(function(d){
                    var total,
                        marker = d.subset.marker,
                        markerid;
                    if (marker === undefined) {
                        return null;
                    }

                    markerid = define_marker(marker, d.subset.cssclasses.join());
                    total = d.xy.total();
                    d3.select(this)
                        .style({fill:"none"})
                        .style("stroke-width", d.subset.linestyle["stroke-width"])
                        .attr('d', get_dataline(total.x.mag, total.y.mag, marker.every, marker.offset))
                        .attr('marker-mid', "url(#"+markerid+")")
                        .attr('marker-start', "url(#"+markerid+")")
                        .attr('marker-end', "url(#"+markerid+")")
                    ;
                })
            ;


            obj.animatetotal();

        };

        obj.plottitle = function(title){
            titletext
                .attr("x", leftMargin + (width - leftMargin -rightMargin)/2)
                .attr("y", topMargin)
                .attr("dy", -0.5*axistitlefontsizept*dv.pt2px)
                .style({font:'Arial', 'font-size': axistitlefontsizept*dv.pt2px+"px", "text-anchor": "middle"})
                .text(title);
        };

        function plotlegenddetail(){
            var i, xy, xylabel_max, label,
                label_max = {},
                listof_max_label,
                max,
                yscalemin,
                g,
                dy = 44,
                origin = (width-1.15*rightMargin)+"," + (topMargin)
                ;
            svg.select(refidstr("legenddetail")).remove();
            g = svg.append('svg:g')
                .attr("transform", "translate("+origin+")")
                .attr('id', idstr("legenddetail"))
                .attr('class', "legend");
            for(i = 0; i < data.length; ++i){
                xy = data[i].xy;
                if (data[i].subset.visible==='details'){
                    xylabel_max = xy.y.maxTab().mag;
                    //console.log(xylabel_max);
                    for (label in xylabel_max){
                        if(xylabel_max.hasOwnProperty(label)){
                            if (label_max[label] === undefined){
                                label_max[label] = xylabel_max[label];
                            } else {
                                label_max[label] = Math.max(label_max[label], xylabel_max[label]);
                            }
                        }
                    }
                }
            }
            listof_max_label = [];
            for(label in label_max){
                if (label_max.hasOwnProperty(label)){
                    listof_max_label.push([label_max[label], label]);
                }
            }
            listof_max_label.sort(function(a, b){return b[0]-a[0];});
            //console.log(listof_max_label);
            yscalemin = yScale.domain()[0];
            for(i = 0; i < listof_max_label.length; ++i){
                max = listof_max_label[i][0];
                if (max < yscalemin) break;
                label = listof_max_label[i][1];
                g.append("text")
                    .text(label)
                    //.attr('id', idstr("legendtextdetail",label))
                    .attr('class', "legendtextdetail " + label)
                    .attr('x', 40)
                    .attr('y', i*dy+20)
                    .attr('fill', get_detailcolor(label))
                ;
            }
        }

        obj.xysExtent = function(){
            var i, xmimax, ymimax, xdums = [], ydums = [];
            for(i=0; i < data.length; ++i){
                xmimax = data[i].xy.x.extent().mag;
                xdums.push(xmimax[0]);
                xdums.push(xmimax[1]);
                ymimax = data[i].xy.y.extent().mag;
                ydums.push(ymimax[0]);
                ydums.push(ymimax[1]);
            }
            return {
                'x': d3.extent(xdums),
                'y': d3.extent(ydums)
            };

        };

        obj.svg = function(){
            return svg;
        };

        obj.plotarea = function(){
            return plotarea;
        };

        obj.path = function(points){
            return dataline(points);
        };

        obj.data = function(_){
            if (!arguments.length) return data;
            data = _;
            xunits = xunits || data[0].xy.x.units;
            yunits = yunits || data[0].xy.y.units;
            return obj;
        };

        function xytable(xy, sel){
            var table = sel.selectAll("table.xydata").data([null]).enter().append("table").attr("class", "xydata").html(""),
                trhead = table.append("tr"),
                tbody = table.append("tbody"),
                tr
            ;
        }
        function nofilter(){
            return true;
        }
        function XyTable(xy, showtotal, detailfilter){
            this.xy = xy;
            var ykeys = d3.keys(xy.y.mag);
            this.ykeys = ykeys.filter(detailfilter || nofilter);
            this.ykeys.sort();
            this.numberofykeys = this.ykeys.length;
            this.numberofdata = xy.y.mag[ykeys[0]].length;
        }
        XyTable.prototype.addTitleline = function(tr, showtotal){
            this.total = this.xy.total();
            tr
                .append("td")
                .attr("colspan", this.numberofykeys + 1 + (showtotal ? 1 : 0))
                .text(this.xy.name + " [" + this.xy.y.units+ "]");
        };

        XyTable.prototype.addColumHeadline = function(tr, showtotal){
            var j;
            tr
                .append("td").text("t ["+this.xy.x.units +"]");
            if (showtotal){
                tr.append("td").text("total");
            }
            for (j = 0; j < this.numberofykeys; j++){
                tr.append("td")
                    .text(this.ykeys[j]);

            }
        };

        XyTable.prototype.addDataline = function(tr, i){
            var j,
                y = this.xy.y,
                x = this.xy.x;
            if (i < this.numberofdata){
                tr.append("td").text(x.mag[i]);
                for (j = 0; j < this.numberofykeys; j++){
                    tr.append("td").text(y.mag[this.ykeys[j]][i]);
                }
            } else {
                tr.append("td");
                for (j = 0; j < this.numberofykeys; j++){
                    tr.append("td");
                }
            }
        };

        XyTable.prototype.addNumbersline = function(tr, i, showtotal, digits){
            var j,
                y = this.xy.y,
                x = this.xy.x
            ;
            if (i < this.numberofdata){
                tr.append("td").text(x.mag[i].toExponential(digits));
                if (showtotal){
                    tr.append("td").text(this.total.y.mag[i].toExponential(digits));
                }
                for (j = 0; j < this.numberofykeys; j++){
                    tr.append("td").text(y.mag[this.ykeys[j]][i].toExponential(digits));
                }
            } else {
                tr.append("td");
                for (j = 0; j < this.numberofykeys; j++){
                    tr.append("td");
                }
            }
        };

        XyTable.prototype.render = function(sel){
            var table = sel.selectAll("table.xydata").data([null]).enter().append("table").attr("class", "xydata").html(""),
                tbody,
                tr,
                i
                ;
            this.addTitleline(table.append("tr"));
            this.addColumHeadline(table.append("tr"));
            tbody = table.append("tbody");
            for (i = 0; i < this.numberofdata; i++){
                this.addDataline(tbody.append("tr"), i);
            }
        };

        function selectElementContents(el) {
            var body = document.body, range, sel;
            if (document.createRange && window.getSelection) {
                range = document.createRange();
                sel = window.getSelection();
                sel.removeAllRanges();
                try {
                    range.selectNodeContents(el);
                    sel.addRange(range);
                } catch (e) {
                    range.selectNode(el);
                    sel.addRange(range);
                }
            } else if (body.createTextRange) {
                range = body.createTextRange();
                range.moveToElementText(el);
                range.select();
            }
        }
        d3.get_or_create = function(sel, ele, name, data){
            var selection;
            if (name[0] ==='#'){
                selection = sel.selectAll(name).data(data || [null]);
                selection.enter()
                    .append(ele)
                    .attr("id", name.slice(1))
                ;
            } else {
                selection = sel.selectAll(ele + "." + name).data(data || [null]);
                selection.enter()
                    .append(ele)
                    .attr("class", name)
                ;
            }
            return selection;
        };
        obj.tabledialogopener = function(chartele){
            var tabledialogopener = chartele.selectAll("img.table").data([null]);
            tabledialogopener
                .enter()
                .append("img")
                .attr("class", "linkish copy")
                .attr("src", "edr/css/16px/table2.png")
                .style({position: "absolute", right: "80px", top: "1px"})
                .attr("title", "Erstelle Datentabelle")
                .on("click", function(){
                    tabledialog(d3.select("body"));
                });
        };

        function tabledialog(sel){
            var xytables = data.map(function(d){return new XyTable(d.xy);}),
                exporttablemain = d3.get_or_create(sel, "div", "#expottablemain"),
                form = d3.get_or_create(exporttablemain, "div", "#form"),
                showtotalcheckbox,
                shownuclideslcheckbox,
                allkeyset = d3.set(),
                allkeys,
                filterselect,
                i;

            xytables.forEach(function(xytable){
                for (i = 0; i < xytable.numberofykeys; i++){
                    allkeyset.add(xytable.ykeys[i]);
                }
            });
            allkeys = allkeyset.values();
            allkeys.sort();
            function Filterselect(initialoptions){
                this.initialoptions = initialoptions;
            }
            Filterselect.prototype.render = function(sel){
                this.filterselect = sel.selectAll("select").data([null]);
                this.filterselect.enter()
                    .append("select")
                    .attr("multiple", "true")
                    .attr("title", "press Ctrl key to select/deselect item, press Shift key to select multiple items")
                    .style("vertical-align", "top")
                    ;
                this.filterselect
                    .on("change", createtable)
                ;
                this.options = this.filterselect.selectAll("option").data(this.initialoptions);
                this.options.enter()
                    .append("option")
                ;
                this.options
                    .attr("value", function(d){return d.name;})
                    .attr("selected", function(d){return d.selected === true? "selected" : null;})
                    .text(function(d){return d.name;})
                ;
                this.options.exit().remove();
            };
            Filterselect.prototype.selectedOptions = function(){
                return this.options[0].filter(function(option){return option.selected;}).map(function(x){return x.__data__.name;});
            };

            var filterselect = new Filterselect(allkeys.map(function(key){return {name: key, selected: true};}));

            function createtable(){
                var keyset = d3.set(filterselect.selectedOptions());
                var shownuclides = shownuclideslcheckbox.node().checked;
                function detailfilter(key){
                    return keyset.has(key) && shownuclides;
                }
                //tablediv.html("");
                renderastable(tablediv, 3, showtotalcheckbox.node().checked, detailfilter)
            }

            showtotalcheckbox = d3.get_or_create(form, "input", "showtotal")
                .attr("type", "checkbox")
                .attr("checked", true)
                .on("change", createtable)
            ;
            d3.get_or_create(form, "label", "showtotal")
                .text("Total aller Radionuklide")
                .style("padding-right", "20px");

            shownuclideslcheckbox = d3.get_or_create(form, "input", "shownuclides")
                .attr("type", "checkbox")
                .attr("checked", null)
                .on("change", createtable)
            ;
            d3.get_or_create(form, "label", "shownuclides")
                .text("Radionuklide:");

            filterselect.render(form);

            function selectTable(){
                selectElementContents(tablediv.node());
            }
            d3.get_or_create(form, "p","marttable");
            d3.get_or_create(form, "button","marttable")
                .text("Tabelle markieren")
                .on("click", selectTable)
            ;

            var tablediv = d3.get_or_create(exporttablemain, "div", "xytable");
            createtable();

            $(exporttablemain.node()).dialog({
                modal: true,
                title: 'Erstelle Datentabelle',
                width: 800,
                height: 500
            });

        }

        function renderastable(sel, digits, showtotal, detailfilter){
            var table = d3.get_or_create(sel, "table", "xydata").html(""),
                tbody,
                tr,
                i, j,
                xytables = data.map(function(d){return new XyTable(d.xy, showtotal, detailfilter);}),
                maxnumberofdata = Math.max.apply(null, xytables.map(function(xytable){return xytable.numberofdata;}))
            ;
            digits = digits || 3;
            tr = table.append("tr");
            for (j = 0; j< xytables.length; j++){
                xytables[j].addTitleline(tr, showtotal);
            }
            tr = table.append("tr");
            for (j = 0; j< xytables.length; j++){
                xytables[j].addColumHeadline(tr, showtotal);
            }
            tbody = table.append("tbody");
            for (i = 0; i < maxnumberofdata; i++){
                tr = tbody.append("tr");
                for (j = 0; j< xytables.length; j++){
                    xytables[j].addNumbersline(tr, i, showtotal, digits);
                }
            }
        }


        obj.set = function(){
            var extent = this.xysExtent();
            var xextent = [xmin===undefined ? extent.x[0]: xmin,
                    xmax===undefined ? extent.x[1]: xmax],
                yextent = [ymin===undefined ? extent.y[0]: ymin,
                    ymax===undefined ? extent.y[1]: ymax];

            if(xtype === 'log'){
                xScale = d3.scale.log().domain((xextent));
                dataline.x(function(d){return xScale(Math.max(d[0], zeroforlogscale));});
            } else {
                xScale = d3.scale.linear().domain(xextent);
                dataline.x(function(d){return xScale(d[0]);});
            }
            xScale.range([leftMargin, width - rightMargin]);

            if(ytype === 'log'){
                yScale = d3.scale.log().domain((yextent));
                dataline.y(function(d){return yScale(Math.max(d[1], zeroforlogscale));});
            } else {
                yScale = d3.scale.linear().domain(yextent);
                dataline.y(function(d){return yScale(d[1]);});
            }
            yScale.range([height - bottomMargin, topMargin ]);

            return obj;
        };

        obj.dm = function(_){
            if (!arguments.length) return dm;
            dm = _;
            return obj;
        };

        obj.xtitle = function(_){
            if (!arguments.length) return xtitle;
            xtitle = _;
            return obj;
        };

        obj.ytitle = function(_){
            if (!arguments.length) return ytitle;
            ytitle = _;
            return obj;
        };

        obj.xtype = function(_){
            if (!arguments.length) return xtype;
            xtype = _;
            return obj;
        };

        obj.ytype = function(_){
            if (!arguments.length) return ytype;
            ytype = _;
            return obj;
        };

        obj.xmin = function(_){
            if (!arguments.length) return xmin;
            xmin = _;
            return obj;
        };

        obj.xmax = function(_){
            if (!arguments.length) return xmax;
            xmax = _;
            return obj;
        };

        obj.xScale = function(){
            return xScale;
        };

        obj.yScale = function(){
            return yScale;
        };

        obj.ymin = function(_){
            if (!arguments.length) return ymin;
            ymin = _;
            return obj;
        };

        obj.ymax = function(_){
            if (!arguments.length) return ymax;
            ymax = _;
            return obj;
        };

        obj.evaluationperiod = function(_){
            if (!arguments.length) return evaluationperiod;
            evaluationperiod = _;
            return obj;
        };

        obj.minorticksize = function(_){
            if (!arguments.length) return minorticksize;
            minorticksize = _;
            return obj;
        };

        obj.majorticksize = function(_){
            if (!arguments.length) return majorticksize;
            majorticksize = _;
            return obj;
        };

        obj.xUnits = function(_){
            if (!arguments.length) return xunits;
            xunits = _;
            return obj;
        };

        obj.yUnits = function(_){
            if (!arguments.length) return yunits;
            yunits = _;
            return obj;
        };

        obj.xAxis = function(_){
            if (!arguments.length) return xAxis;
            xAxis = _;
            return obj;
        };

        obj.yAxis = function(_){
            if (!arguments.length) return leftyAxis;
            leftyAxis = _;
            return obj;
        };

        obj.width = function(_){
            if (!arguments.length) return width;
            width = _;
            return obj;
        };
        obj.height = function(_){
            if (!arguments.length) return height;
            height = _;
            return obj;
        };
        obj.leftMargin = function(_){
            if (!arguments.length) return leftMargin;
            leftMargin = _;
            return obj;
        };
        obj.rightMargin = function(_){
            if (!arguments.length) return rightMargin;
            rightMargin = _;
            return obj;
        };
        obj.bottomMargin = function(_){
            if (!arguments.length) return bottomMargin;
            bottomMargin = _;
            return obj;
        };
        obj.topMargin = function(_){
            if (!arguments.length) return topMargin;
            topMargin = _;
            return obj;
        };

        obj.legendtotalx = function(_){
            if (!arguments.length) return legendtotalx || (2*leftMargin);
            legendtotalx = _;
            legendtotalg.attr("transform", "translate("+ legendtotalx + "," + obj.legendtotaly() + ")");
            return obj;
        };

        obj.legendtotaly = function(_){
            if (!arguments.length) return legendtotaly || (1.1 * topMargin);
            legendtotaly = _;
            legendtotalg.attr("transform", "translate("+ obj.legendtotalx() + "," + legendtotaly + ")");
            return obj;
        };
		
		obj.tickfontsizept = function(_){
			if (!arguments.length) return tickfontsizept;
			tickfontsizept = _;
		};
		
		obj.axistitlefontsizept = function(_){
			if (!arguments.length) return axistitlefontsizept;
			axistitlefontsizept = _;
		};	

        obj.legendtotalg = function(){
            return legendtotalg;
        };

        obj.idstr = idstr;
        obj.refidstr = refidstr;

        return obj;
    }
    dv.XYChart= XYChart;
})();



/*
 1px = 0.1 mm
 */
